INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Build/Explode internal data types

**********************************************************************
* EXPORT:
*
*	2LAMBIND	( o2, o1 -> )
*			Binds o2 and o1 to {{ NULLLAM NULLLAM }}
*	3LAMBIND	( o3, o2, o1 -> )
*			Binds o3, o2 and o1 to {{ NULLLAM NULLLAM NULLLAM }}
*	CKINNERCOMP	( {} -> meta )
*			( obj -> obj, #1 )
*			Like INNERCOMP for lists, checks for non-list
*	CKCARCOMP	( {} -> obj )
*			( obj -> obj )
*			Like CARCOMP for lists, checks for non-list
*	DUPCKLEN{}	( {} -> {}, # )
*			( obj -> obj, #1 )
*	CARCOMPext	( Q1/Q2 -> Q1'/Q2' )
*			extracts one depth for a constant fraction wrt to the
*			outer variable
* --------------------------------------------------------------------
*	RISCH13		( {}/{}' -> {}'')
*			Assuming {}' has length 1, divides all
*			elements of {} by this element. Used by
*			RISCHext and by SERIES to have a nicer
*			output of series
*
*	CXRIect		( C -> Z, Z )
*			real and imaginary part of a Gauss integer
*
*	RIXCext		( Z, Z -> C )
*
*	IRXCext		( Z, Z -> C )
*
*	SWAPNDXF	( o2, o1 -> o1/o2 )
*			same tests as NDXFext
*
*	NDXFext		( o2, o1 -> o2/o1 )
*			build a symbolic fraction, tests for
*			 o1=%1, Z1 and o2=0
*
*	SWAPFXND	( o2, o1 -> o1, n2, d2 )
*			see FXNDext
*
*	FXNDext		( o1 -> n1, d1 )
*			with o1=n1/d2, d1=1 if o1 is not a symbolic
*			with last element x/
*
*	QXNDext		( irrq -> a, b, c )
*			b=0 and c=1 if stk level 1 is not an irrq
*
*	NDXQext		( a, b, c -> irrq )
*
**********************************************************************

**********************************************************************
* Desc:		Bind two lambda variables, like 1LAMBIND.
* Stack:	( ob1 ob2 --> )
***********************************************************************
NULLNAME 2LAMBIND
::
  ' NULLLAM DUPTWO DOBIND
;

**********************************************************************
* Desc:		Bind three lambda variables, like 1LAMBIND.
* Stack:	( ob1 ob2 ob3 --> )
***********************************************************************
NULLNAME 3LAMBIND
::
  ' NULLLAM DUPDUP THREE DOBIND
;


**********************************************************************
* Desc:		Explode symbolics, but with size 1 for non-symbolics
* Stack:	( symb --> ob1 .. obN #n )
*		( ob --> ob #1 )
*		( {} --> {} #1 or -{} xNEG #2 )
**********************************************************************
NULLNAME SYMBINCOMP
( obj -> meta )
CODE
=symbincomp	C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	symbininner
		LC(5)	=DOLIST
		?A#C	A
		GOYES	symbinone
		LA(5)	=symbinlist!
		PC=(A)
symbinone	LA(5)	=ONE
		PC=(A)
symbininner	LA(5)	=INNERCOMP
		PC=(A)
ENDCODE

**********************************************************************
* Desc:		returns a meta equivalent to the input object
* Stack:	( ob --> ob #1 )
*		( ob --> -ob xNEG #2 )
**********************************************************************
LABEL symbinlist!
::
  POSITIFext case ONE
  RNEGext ONE metaneg
;


**********************************************************************
* Desc:		Explode list, but with size 1 for non-lists.
* Stack:	( L --> ob1 .. obN #n )
*		( ob --> ob #1 )
**********************************************************************
NULLNAME CKINNERCOMP
CODE
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A=C	A
		GOYES	+
		LA(5)	=ONE
		PC=(A)
+		LA(5)	=INNERCOMP
		PC=(A)
ENDCODE

**********************************************************************
* Desc:		Return length of list, or 1 for non-lists.
* Stack:	( L --> L #n )
*		( ob --> ob #1 )
* **********************************************************************
NULLNAME DUPCKLEN{}
CODE
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A=C	A
		GOYES	+
		LA(5)	=ONE
		PC=(A)
+		LA(5)	=DUPLENCOMP
		PC=(A)
ENDCODE

**********************************************************************
* Desc:		Returns first element for lists, or object itself.
* Stack:	( L --> ob1 )
*		( ob --> ob )
**********************************************************************
NULLNAME CKCARCOMP
* changed code to handle irrq with a list c
::					( ob )
  dLISTcase CARCOMP			( -> ob' )
					( ob )
  DTYPEIRRQ? NOT?SEMI			( -> ob )
  DUP QXNDext 				( ob a b c )
  NOTLISTcase 3DROP			( -> ob )
  TRANSCERROR
;
* old code
*CODE
*		C=DAT1	A
*		CD1EX
*		A=DAT1	A
*		CD1EX
*		LC(5)	=DOLIST
*		?A=C	A
*		GOYES	+
*		GOVLNG	=Loop
*+		LA(5)	=CARCOMP
*		PC=(A)
*ENDCODE
* end old code

**********************************************************************
* Desc:		Extracts leading coefficients for the first variable
*		from a rational polynomial.
* Stack:	( Q1/Q2 --> Q1'/Q2' )
**********************************************************************
NULLNAME CARCOMPext
::	
  FXNDext
  SWAP CKCARCOMP
  SWAP CKCARCOMP
  RDIVext
;

* ====================================================================
* Desc:		Assuming {}' has length 1, divides all elements of {}
*		by this element. Used by RISCHext and by SERIES to
*		have a nicer output of series.
* Stack:	( {}/{}' -> {}'' )
* ====================================================================
NULLNAME RISCH13
::
  FXNDext
  ( * added a check of the deno length * )
  DUPCKLEN{} #1= NOTcase NDXFext
  CKCARCOMP DIVOBJext
  NOTLISTcase ONE{}POLY
;

* ====================================================================
* Desc:		Return real and imaginary part of Gaussian integer.
* Stack:	( C --> Zre Zim )
* ====================================================================
NULLNAME CXRIext
::
  DUPTYPECOL? NOTcase Z0		( --> Z 0 for real numbers )
  INNERDUP #2= case DROPSWAP		( Zre Zim )
  ::POLY Z0				( --> Q 0 for quadratic extensions )
;

* ====================================================================
* Desc:		Convert integers to complex.
* Stack:	( Zre Zim --> C )
* ====================================================================
NULLNAME RIXCext
CODE
rixc	GOSBVL	=swapml
	GOTO	irxc
ENDCODE

* ====================================================================
* Desc:		Convert integers to complex.
* Stack:	( Zim Zre --> C )
* ====================================================================
NULLNAME IRXCext
CODE
irxc		D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	11
		CD1EX
		LCZ0
		P=	10
		?A#C	WP
		GOYES	irxc!0
		P=	0
		LA(5)	=SWAPDROP
		PC=(A)
irxc!0		P=	0
		LA(5)	=TWO::POLY
		PC=(A)
*	irxc!1	LA(5)	=irxc2!
*		PC=(A)
ENDCODE

ASSEMBLE
=irxc2!
RPL
NULLNAME IRXC2
::
  SWAP iisirrqflag TestSysFlag
  NOTcase RIXCext
  Z-1 NDXQext
;

* ====================================================================
* Desc:		Build a symbolic from rational polynomial.
* Stack:	( Qden Qnom --> symb )
* ====================================================================
NULLNAME SWAPNDXF
CODE
	GOSBVL	=swapml
	GOTO	ndxf
ENDCODE

* ====================================================================
* Desc:		Build a symbolic from rational polynomial.
* Stack:	( Qnom Qden --> symb )
* ====================================================================
NULLNAME NDXFext

( o2, o1 )
* Check special cases: o1=1 or -1, or o2=0
CODE
ndxf		C=DAT1	A
		LA(5)	=%1
		?A=C	A
		GOYES	hstr#0
		CD1EX
		A=DAT1	W
		CD1EX
		LCZ1
		?A#C	A
		GOYES	ndxfstk2
		P=	11
		?A#C	WP
		GOYES	hstrnot#1
* o1=1 -> DROP
hstr#0		P=	0
		GOVLNG	=DropLoop
hstrnot#1	SETDEC
		C=-C-1	P
		SETHEX
		?A#C	WP
		GOYES	ndxfstk2
		P=	0
		D=D+1	A
		D1=D1+	5
		GOVLNG	=rneg
ndxfstk2	P=	0
		D1=D1+	5
		C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		D1=D1-	5
		LCZ0
		P=	10
		?A=C	WP
		GOYES	hstr#0
ndxfnot#0	P=	0
ndxf1		LA(5)	=buildfraction
		PC=(A)
ENDCODE

LABEL buildfraction
::
  CK&DISPATCH1
  symb ndxfsymb
  symbany ndxfsymb
  any ndxfoo
;

LABEL ndxfsymb
:: 2SYMBINCOMP top&addt/ SYMBN ;

LABEL ndxfoo
:: ' x/ THREE SYMBN ;

* ====================================================================
* Desc:		Convert symbolic to rational polynomial.
* Stack:	( symb ob --> ob Qnom Qden )
* ====================================================================
NULLNAME SWAPFXND
CODE
	GOSBVL	=swapml
	GOTO	fxnd
ENDCODE
* ====================================================================
* Desc:		Convert symbolic to rational polynomial.
* Stack:	( symb --> Qnom Qden )
* ====================================================================
NULLNAME FXNDext
CODE
fxnd	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOSYMB
	?A=C	A
	GOYES	fxnd1
	GOVLNG	=zint1
fxnd1	LA(5)	=fxndext!
	PC=(A)
ENDCODE

ASSEMBLE
=fxndext!
RPL
::				( o -> num, deno )
  Z1 OVER			( symb, 1, symb )
  INNERCOMP			( symb, 1, meta )
  CODE
fxndPOS	EQU	9		Flag to indicate non NEG
	ST=1	fxndPOS	( non NEG )
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	LC(5)	=xNEG
	?A=C	A
	GOYES	fxndneg
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	GOTO	fxndegal
fxndneg	ST=0	fxndPOS	( NEG )
	D1=D1+	10
	A=DAT1	A
	D1=D1-	10
* stk= symb, 1, meta
* teste si l'operateur est x/ si non -> NDROP
fxndegal
	LC(5)	=x/
	?A#C	A
	GOYES	fxndn=
	A=DAT1	A
	?ST=0	fxndPOS
	GOYES	fxndegn
	D1=D1+	5
	D=D+1	A
	DAT1=A	A	A contient le nombre d'elements du symbolique
	LA(5)	=#1-
	PC=(A)
fxndegn	D1=D1+	10
	D=D+1	A
	D=D+1	A
	DAT1=A	A
	LA(5)	=#2-
	PC=(A)
fxndn=	GOSBVL	=semiml
	LA(5)	=NDROP
	PC=(A)
  ENDCODE

  larg				( symb, 1, meta_sans_x/ )
  CODE
	GOTO	symn
  ENDCODE
				( symb, 1, meta-n, deno )
  CODE
	GOSBVL	=obj>rml
symn	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A
	CD1EX
	A=A-CON	A,2
	GOC	symnext
	LA(5)	=SYMBN
	PC=(A)
symnext	D=D+1	A
	D1=D1+	5
	A=DAT1	A
symn1	LC(5)	=xi
	?A=C	A
	GOYES	symncmp
symn2	LC(5)	=xCONSTANTe
	?A=C	A
	GOYES	symncmp
	LC(5)	=xPI
	?A=C	A
	GOYES	symncmp
symnlp	GOVLNG	=Loop
symncmp	LA(5)	=symcomp
	PC=(A)
  ENDCODE
				( symb, 1, num )
  UNROT2DROP
  CODE
		?ST=0	fxndPOS
		GOYES	fxndrneg
fxndlp		GOVLNG	=Loop
fxndrneg	GOVLNG	=rneg
  ENDCODE
				( num )
  CODE
		GOSBVL	=r>objml
		GOTO	fxndlp
  ENDCODE
;

* ====================================================================
* Desc:		b=0 and c=1 if stk level 1 is not an irrq
* Stack:	( irrq -> a, b, c )
* ====================================================================
NULLNAME QXNDext
CODE
qxnd		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		C=A	W
		LCIRRQ
		?A#C	W
		GOYES	+
		LA(5)	=qxndext!
		PC=(A)
+		LA(5)	=Z0Z1
		PC=(A)
ENDCODE

LABEL qxndext!
::				( obj -> a, b, c )
  INNERCOMP #5= NOTcase INTERNALERR
  DROP 4ROLLDROP
;

* MPH: Use Z0Z1 instead
*	LABEL qxndnotirrq!
*	:: Z0 Z1 ;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL ndxqlist!
::
  ( a, b, c; c est une liste )

  DUPLENCOMP #1= NOTcase
  CODE
	GOTO	ndxqmake
  ENDCODE
  ( * si b est un irrquad, il est moins complexe que c dont constant * )
  CARCOMP			( a, b, c' )
  SWAP CKINNERCOMP get1		( a, b1, ..., bn, #n, c' )
  SWAPDUP
  ZERO_DO (DO)			( b1, ..., bn, c', #n )
     get1 Z0 SWAP4PICK		( b2, .., bn, c', #n, 0, b1, c' )
     NDXQext UNROT
  LOOP
  SWAPDROP {}POLY RADDext
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( a, b, c -> seco )
* --------------------------------------------------------------------
NULLNAME NDXQext
*:: SHALT ( test )
CODE
ndxq		GOSBVL	=a=stkwc1
		?A#C	W
		GOYES	ndxqnot1
		D=D+1	A
		D1=D1+	5
		GOVLNG	=radd
ndxqnot1	D1=D1+	5
		GOSBVL	=a=stkwc0
		D1=D1-	5
		?A#C	W
		GOYES	+
		LA(5)	=2DROP
		PC=(A)
+		GOTO	ndxqbuild
* debut de modif
*+		C=A	W
*		LCIRRQ
*		?A#C	W
*		GOYES	ndxqbuild
*ndxqext		A=PC
*		LC(5)	(ndxqext!)-(*)
* fin de modif
ndxqbranch	A=A+C	A
		PC=(A)
ndxqbuild	GOSBVL	=A=stk5		( c est-il une liste )
		LC(5)	=DOLIST
		?A#C	A
		GOYES	ndxqmake
* si c est une liste, il faut tester la longueur
		A=PC
		LC(5)	(ndxqlist!)-(*)
		GOTO	ndxqbranch
ndxqmake	D=D-CON	A,3		
		GONC	ndxq!2
		LC(5)	3
		GOSBVL	=GARBAGE2
ndxq!2		C=DAT1	15		( adresses de a, b, c )
		LA(5)	=x<<
		D1=D1+	10		( niveau 3 qui va devenir niveau 6 )
		DAT1=A	A
		D1=D1-	15
		DAT1=C	15
		D1=D1-	5
		LA(5)	=x>>
		DAT1=A	A
		D1=D1-	5
		LA(5)	=FIVE
		DAT1=A	A
		LA(5)	=CK::POLY 	::POLY ne suffit pas, exemple
		PC=(A)			pi/sqrt(2*pi*n)*n^n
ENDCODE
*; ( test )

LABEL CK::POLY
::
  ROT NEWTRIMext 		( << a b >> #5 c )
  Z1 EQUALcasedro CK::POLY1
  UNROT ::POLY
;

LABEL CK::POLY1
::				( << a b >> #5 )
  2DROP QAdd SWAPDROP		( a+b )
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------

*LABEL ndxqext!
*::
*( a, b, c )
*OVER sqrtflag TestSysFlag 
*( a, b, c, b, ?not_seco )
*CODE
*		GOSBVL	=popflag
*		GOC	dropbuild
*		GOLONG	qxnd
*dropbuild	D1=D1+	5	DROP, puis ndxqbuild
*		D=D+1	A
*		GOTO	ndxqbuild
*ENDCODE
*ROT 
*( a, b, c, e, f, d )
*CODE
*	GOLONG	num0
*ENDCODE 
*	::	( a, b, c, e, f, 0 )
*		DROPROT 4ROLLDROP RMULText
*		( a, e, c*f )
*		iisirrqflag TestSysFlag 
*		case
*		CODE
*		GOTO	ndxqbuild
*		ENDCODE
*		iisirrqflag SetSysFlag
*		SIMPEVALext SXSQRext
* ca devrait etre XSQRext mais ca peut alors creer des valeurs absolues
* imbriquees, il faudrait faire XSQRext et renvoyer une erreur si ABS
*		( a, e, sqrt[c*f] )
*		RMULText RADDext
*		( a+e*sqrt[c*f] )
*		iisirrqflag ClrSysFlag
*		;
*( 3DROP -> << >> )
*CODE
*		D=D+CON	A,3
*		D1=D1+	15
*		GOTO	ndxqbuild
*ENDCODE
*
*;
********************************************************************

