INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Heuristic GCD
**********************************************************************
* EXPORT:
*
* GCDHEUext	( A, B -> a, b, c, pr[gcd], A'/G', B'/G', flag )
*		A, B must be polynomials, then:
*		a,b = Gauss integer gcd of A and B, 
*		c=gcd[a,b], 
*		A' and B'=primitive parts of A and B,
*		flag is TRUE if GCDHEUext was successfull
*
* PPZ		( P -> P, obj )
*		obj is the gcd of all constant coefficients of P
*		(integer, Gauss integers, irrquads
*		with the implementation of the "gcd" for irrquads)
*
* PZadic	( Q, Z -> Q' )
*
* QMODSYMext	( Q, Z -> Q mod Z )
*		symmetric representation
**********************************************************************

LABEL GCDHEUOUT1
::
  Z1 SWAPROT TRUE		( a b c 1 A' B' true )
;

LABEL GCDHEUOUT2
::
  Z1 SWAPROT FALSE		( a b c 1 A' B' false )
;

LABEL GCDHEUOUT3
::
  SWAPDROP Z1 UNROT TRUE	( a b c 1 A' B' true )
;

LABEL GCDHEUOUT4
::
  SWAPDROP Z1 UNROT FALSE
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL GCDHEUMSG1
{ BlankDA1
  "GCDHeu, depth"
  OVER DO>STR &$
  DISPROW1
}

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL GCDHEUMSG2
{	
  "try -" 3PICK UNCOERCE DO>STR &$
  ", z=" &$
  OVER DO>STR &$
  DISPROW2
}

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL GCDHEULPEXIT
::
  3DROP
  Z1 UNROT
  2RDROP TRUE			(  a, b, c, G=1, A, B, TRUE )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL GCDHEULOOP
::				( a b c A' B' k z A'z B'z )
  GCDext OVER PZadic		( a b c A B k z G )
  NOTLISTcase GCDHEULPEXIT
  PPZ				( a b c A B k z G' g )
  DROP				( a b c, A, B, k, z, G' )
  5PICK OVER DIVISIBLE?  
  NOTcase2DROP			( --> a b c A B )
				( a b c, A, B, k, z, G', A/G' )
  5PICK 3PICK DIVISIBLE? 
  NOTcase 3DROP			( --> a b c A B )
				( a b c, A, B, k, z, G', A/G', B/G' )
  8UNROLL 8UNROLL		( a b A/G', B/G', c, A, B, k, z, G' )
  5UNROLL 4DROP			( a b A/G', B/G', c, G' )
  2SWAP 2RDROP TRUE		( -->  a, b, c, G', A/G', B/G', TRUE )
;

**********************************************************************
* Desc:		Heuristic GCD
* Stack:	A, B -> a, b, c, pr[pgcd], A'/G', B'/G', flag
* Note:		a=pgcd entier de A
*		b=pgcd entier de B
*		c=pgcd[a,b]
*		A'=pr[A]
*		B'=pr[B],
*		pr: partie primitive
**********************************************************************
* GCDHEUext has been moved in util.s
* The algorithm can be found e.g. in the MuPAD CAS
* untar lib.tar in /usr/local/MuPAD/share and look at
* lib/GCDLIB/heu_gcd.mu
**********************************************************************

**********************************************************************
* Desc:
* Stack:	( p -> p/pgcd, pgcd des scalaires de p )
**********************************************************************
NULLNAME PPZ
::
  NOTLISTcase :: Z1 SWAP ;
					( liste )
  Z0 OVERSWAP				( liste, liste, pgcd )
  PPZLP					( liste, pgcd )
  num#1=case NOP
  DUPUNROT 'QDivLOPA
  SWAP
;

LABEL PPZLP
* obj, scalar -> scalar
CODE
* test si pgcd = #1 -> swapdrop
=ppz		C=DAT1	A
		CD1EX
		A=DAT1	12
		CD1EX
		C=A	W
		LCZ1
		?A#C	W
		GOYES	ppznot1
ppzswdrp	LA(5)	=SWAPDROP
		PC=(A)
ppznot1		D1=D1+	5
		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		D1=D1-	5
		LC(5)	=DOLIST
		?A#C	A
		GOYES	ppzgcd
		LA(5)	=ppzl!
		PC=(A)
ppzgcd		C=A	W
		LCIRRQ
		?A=C	W
		GOYES	ppzirrq
		GOVLNG	=gcd
ppzirrq		LA(5)	=ppzirrq!
		PC=(A)
ENDCODE


LABEL 'QDivLOPA
* o2, o1 -> o2/o1, o1 is assumed to be a zint/ereal or ecmp
:: ' RDIVext LOPAext ;

**********************************************************************
* Desc:
* Stack:
* Note:		obj est une liste: on appelle gcd(carcomp(liste),pgcd)
*		puis ppz avec cdrcomp
**********************************************************************
LABEL ppzl!
::				( liste, pgcd )
  SWAPINCOMP
  get1 SWAP
  ZERO_DO (DO)			( o1, ..., on, pgcd )
    PPZLP
  LOOP
;

LABEL ppzirrq!
::
  					( irrq o )
  ( * if irrq.c is an integer call gcd else call gcd[o,a,b] * )
  SWAPDUP FOUR NTHCOMPDROP TYPEZINT?	( o irrq ?c_is_zint )
  case GCDext				( -> o' )
					( o irrq )
  QXNDext				( o a b c )
  DROPROT				( a b o )
  PPZLP PPZLP				( o' )
;

**********************************************************************
* Desc:
* Stack:	( a z -> a mod z )
**********************************************************************
NULLNAME PZHSTR
LABEL pzhstr!
::
  SWAPOVER		( M A M )
  ZMod			( M R )
  DUPROT OVER ZIsNeg?	( R R M sflag )
  ITE RADDext RSUBext	( R -sign[R]*[M-|R|] )
  ZNMin			( Z )
;

**********************************************************************
* Desc:
* Stack:	( a  z -> a mod z )
**********************************************************************
LABEL pzcmplx!
::
  SWAP INCOMPDROP		( z, i, r )
  3PICK PZHSTR			( z, i, r mod z )
  SWAPROT PZHSTR		( r mod z, i mod z )
  SWAP IRXCext
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL pzirrq!
::
  SWAP QXNDext			( z, a, b, c )
  SWAP4PICK QMODSYMext		( z, a, c, b' )
  ROT 4ROLL QMODSYMext		( c, b', a' )
  SWAPROT NDXQext
;

**********************************************************************
* Desc:
* Stack:	( l z -> l mod z )
**********************************************************************
LABEL pzlist!
::
  SWAPINCOMP get1 SWAPDUP
  ZERO_DO (DO)			( o1, ..., on, z, #n )
     get1			( o2, ..., on, z, #n, o1 )
     3PICK
     CODE
	GOVLNG	=qmodlong
     ENDCODE
				( o2, ..., on, z, #n, o1 mod z )
     UNROT
  LOOP
				( o1, ..., on, z, #n )
  SWAPDROP >POLYTRIM
;

**********************************************************************
* Desc:
* Stack:	( P, r -> P[r] )
**********************************************************************
NULLNAME HORNER1ext
::
  CK&DISPATCH1
  EIGHTY   PEval
  symbany  ::
              SWAPFXND			( r, P.n, P.d )
              SWAP3PICK HORNER1ext	( r, P.d, P.n[r] )
              UNROTSWAP HORNER1ext	( P.n[r], P.d[r] )
              RDIVext
           ;
  BINT80h  ::
              SWAP
              DUPLENCOMP #2= case SWAPDROP
              QXNDext	 		( r, a, b, c )
              ROT 4PICK HORNER1ext	( r, b, c, a[r] )
              ROT 4ROLL HORNER1ext
              ROT NDXQext
           ;
  any      DROP
;

**********************************************************************
* Desc:
* Stack:	( P, r --> P[r] )
* Note:		P msut be a list polynomail
**********************************************************************
NULLNAME PEval
::
  OVER TYPELIST? NOTcaseDROP
  SWAP 
  PEvalFast? ?SEMI			( r, P )
  PEvalSlow
;

LABEL PEvalSlow
::					( r P )
  FIVE NEXTCOMPOB NcaseTYPEERR
					( r P pos resultat )
  horn2#ext!
;

**********************************************************************
* Desc:			
* Stack:		( r P pos resultat -> P[r] )
**********************************************************************
LABEL horn2#ext!
::	
  4UNROLL NEXTCOMPOB NOTcase2DROP
  5ROLL 5PICK RMULText RADDext
  CODE
	LC(5)	5	( rdrop )
	B=B-C	A
	D=D+1	A
horn2	LA(5)	=horn2#ext!
	PC=(A)
  ENDCODE
;

