	STITLE  ERABLE KERNEL

INCLUDE keydefs.h
INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE erext.h
INCLUDE global.s

**********************************************************************
* EXPORT: (assembly)
*
* =swapml	( o2, o1 -> o1, o2 )
*
* =swap3ml	( o6, o5, o4, o3, o2, o1 -> o3, o2, o1, o6, o5, o4 )
*
* =unrotml	( o3, o2, o1 -> o1, o3, o2 )
*
* =ndropml	( o1, ..., on, #n -> )
*
* =swapdropml	( o2, o1 -> o2 )
*
* =semiml	( -> ) 
*		executes SEMI
*
* =rsubrcl	
*		prolog of stk1 -> R1 and A, prolog stk2-> R2, modifies C
*
* =a=stkwc1	
*		stk1 -> A field W, set C to Z1
*
* =a=stkwc0	
*		stk1 -> A field W, set C to Z0
*
* =a=stk1	
*		stk1 -> A field A, modifies C
**********************************************************************

**********************************************************************
* EXPORT:
*
* VERNUMext	( -> % ) 
*		version number
*
* #3+ROLL	#3+ ROLL
*
* OBJ>R		( obj -> ) 
*		save obj from stk to return stk
*
* R>OBJ		( -> obj ) 
*		restore obj from return stk
*
* SortList	( L pred --> L' )
*
* LESSCOMPLEX?	( o2, o1 -> o2, o1, o2<o1? ) 
*		sort by type then by CRC 
*
* LISTIRRQ      ( o, list -> list ) 
*		adds the "c part" of all irrquads of obj
*
* num0case	( o -> o ) 
*		TRIM object then like num0=case, 
*
* num#0=case	( o -> o ) 
*		like num0=case but handles Z too
*
* num#1=case	( o -> o ) 
*		like num1=case but handles Z too
*
* Z0=case	( o -> o ) 
*		like num0=case but handles Z only
*
* Z1=case	( o -> o ) 
*		like num1=case but handles Z only
*
* j#0=case	( o -> )
*		like j%0=case but handles Z
*
* jZ0=case	( Z -> )
*
* j#1=case	( o -> )
*		like j%1=case but handles Z
*
* jZ1=case	( Z -> )
*
* j%1=case	( % -> )
*
* Z1Z1, Z1Z0, Z-1Z0 
*               ( -> Z Z )
*		returns 2 integers
*
* LIST1i-1-i	( -> list ) 
*		returns a list made of 1 i -1 -i (internal objects)
*
* TESTINFINI	( obj -> obj, flag ) 
*		tests if obj is/contains infinity
*
* POSINFext	( obj -> obj, # ) 
*		returns position of 1st occurence of infinity
*
* INFINIext	( -> symb ) 
*		returns unsigned infinity 
*
* MINSUINFext	( -> symb ) 
*		returns minus infinity
*
* PLUSINFext	( -> symb ) 
*		returns plus infinity
*
* ?ext		( -> symb ) 
*		returns undef
*
* POSUNDEFext	( obj -> obj, # ) 
*		returns position of 1st occurence of undef
*
* pisur2	( -> symb ) 
*		pi/2
*
* pisur12	( -> symb ) 
*		pi/12
*
* pi		( -> symb ) 
*		pi
*
* ipi		( -> symb ) 
*		i*pi
*
* pifois2	( -> symb ) 
*		2*pi
*
* RCLMODULO	( -> Z ) 
*		value of { HOME MODULO }
*
* STOMODULO	( o -> ) 
*		store object in { HOME MODULO }
*
* RCLVX		( -> idnt ) 
*		value of { HOME VX }
*
* STOVX		( o -> ) 
*		store object in { HOME VX }
*
* RCLEPS	( -> % ) 
*		value of { HOME EPS }
*
* LOP1ext	( {}, obj, binary_op -> {} )
*		Applies non recursively << obj binary_op >> to the
*		elements of list
*
* LOPAext	( list, obj, binary_op -> list )
*		Applies recursively << obj binary op >> 
*		to non-list elements of list
*
* LISTSECOext	( composite -> composite )
*		Applies 1GETLAM non recursiveley to all elements of lists
*
* QOBJSECOext	( obj,  [ runstream program ] -> obj )
*		Applies program to obj, recursively for lists and secondaries
*
* QOBJext	( obj,  [ runstream program ] -> obj )
*		Applies program to obj, recursively for lists 
*
* LIFCext	( {} -> fraction )
*		Continued fraction coefficient list to rational conversion
*
* CK1TONOext	( prg -> prg ) 
*		replace first CK1|2&Dispatch by CK&DISPATCH1
*
* NEXTPext	( list -> list1, list2 )
*		Extract in list2 all occurences of the 1st object of list, 
*		the remaining objects are stored in list1[=list-list2]
*
* INSERT{}N	( list, obj, #pos -> list )
*		Insert object in list at position #pos. 
*		#pos must be < to lenght[list]
*		If #pos=#0, object is >TCOMPed to the list
*
* COMPRIMext	( {} -> {} )
*		Suppress multiples occurences in the original list
*
* Sys1IT	( obj -> )
*		"Executes" object at level 1 if displayflag is set
*
* EQUALPOSMETA	( meta, obj -> meta, obj, # )
*		returns last occurence of obj in meta or #0 if not present
* EQUALPOS2META	( meta2, meta1, obj -> meta2, meta1, obj, # )
*		returns last occurence of obj in meta1 as MINUSONE-#pos
*		if obj not present in meta1 looks in meta2 
*		return last occurence of obj in meta2 or #0 if not present
**********************************************************************


* ======================================================================
* Assembly language stack manipulation
* ======================================================================

ASSEMBLE

**********************************************************************
* Stack:	( 2 1 --> 1 2 )
**********************************************************************
=swapml		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		DAT1=C	A
		D1=D1-	5
		DAT1=A	A
		RTN
**********************************************************************
* Stack:	( 6 5 4 3 2 1 --> 3 2 1 6 5 4 )
**********************************************************************
=swap3ml	A=DAT1	15
		D1=D1+	15
		C=DAT1	15
		DAT1=A	15
		D1=D1-	15
		DAT1=C	15
		RTN
**********************************************************************
* Stack:	( 3 2 1 --> 1 3 2 )
**********************************************************************
=unrotml	A=DAT1	A
		D1=D1+	5
		C=DAT1	10
		D1=D1+	5
		DAT1=A	A
		D1=D1-	10
		DAT1=C	10
		RTN
**********************************************************************
* Stack:	( n ... 1 #n --> )
* Input:	C[A] = N+1
**********************************************************************
=ndropml	C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		CD1EX
		C=C+A	A
		CD1EX
		D=D+C	A
		RTN
**********************************************************************
* Stack:	( 2 1 --> 1 )
**********************************************************************
=swapdropml	A=DAT1	A
		D=D+1	A
		D1=D1+	5
		DAT1=A	A
		RTN
**********************************************************************
* Desc:		Executes SEMI
**********************************************************************
=semiml		C=B	A
		CD0EX
		D0=D0-	5
		A=DAT0	A
		AD0EX
		B=A	A
		D=D+1	A
		RTN
**********************************************************************
* Output:	A[W] = R1[W] =	@stk1
*		R2[W] = @stk2
* Alters:	C[A]
**********************************************************************
=rsubrcl	D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	W
		R2=A		-> stk2
		CD1EX
		C=DAT1	A
		CD1EX
		A=DAT1	W	
		R1=A		-> stk1
		CD1EX
		RTN
**********************************************************************
* Output:	A[W] = @stk1
*		C[W] = Z1
**********************************************************************
=a=stkwc1	C=DAT1	A
		CD1EX		( @D1=stk1 )
		A=DAT1	W
		CD1EX		( restaure D1 )
		C=A	W
		LCZ1		( C=Z1 )
		RTN
**********************************************************************
* Output:	A[W] = @stk1
*		C[W] = Z0
**********************************************************************
=a=stkwc0	C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		C=A	W
		LCZ0
		RTN
**********************************************************************
* Output:	A[A] = @stk1
* Alters:	C[A]
**********************************************************************
=a=stk1		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		RTN
**********************************************************************
* Output:	
* Alters:	C
* Desc:		back to RPL just after GOSUB call
**********************************************************************
=ModRPL:	C=RSTK			Help subroutine to pack code
		GOVLNG	=GETPTREVALC
RPL

* ====================================================================
* System RPL utilities
* ====================================================================

* --------------------------------------------------------------------
* Desc:		3PICK 3PICK 3PICK
* --------------------------------------------------------------------
NULLNAME 3DUP
::
  3PICK 3PICK 3PICK
;

* --------------------------------------------------------------------
* Desc:		#3+ ROLL
* --------------------------------------------------------------------
NULLNAME #3+ROLL
::
  #3+ ROLL
;

* --------------------------------------------------------------------
* Desc:		2DROP TRUE
* --------------------------------------------------------------------
NULLNAME 2DROPTRUE
::
  2DROP TRUE
;

**********************************************************************
* Desc:		Elimine les symboles imbriques 
* Stack:	( objet -> symbolique )
**********************************************************************
*NULLNAME RMSYMext
*::
*  ZEROSWAP
*  ' ::					( meta, objet -> meta )
*      DUPTYPESYMB? NOTcase SWAP#1+
*      INNERCOMP reversym psh		( o1, ..., on, #n, meta )
*      get1 ZERO_DO (DO)			( o1,...,on, meta )
*         get1 1GETLAM EVAL
*      LOOP
*    ;
*
*					( meta vide, objet, prog )
*  DUP1LAMBIND EVAL ABND			( meta )
*  DUP#0_DO (DO)				( a1, ..., ak, #k )
*      SWAPDUP 				( a1, ..., ak-1, #k, ak, ak )
*      EQ: xFCNAPPLY			( a1, ..., ak-1, #k, ak, flag )
*      IT :: 4ROLL ONE SYMBN 4UNROLL ;
*      DUPEQ: xNEG			( a1, ..., ak-1, #k, ak, flag )
*      IT
*        :: 3PICK EQ: xNEGNEG NOT?SEMI
*           ROTDROP SWAP#1-SWAP
*           ISTOP@ #1- ISTOPSTO
*        ;
*      OVER #1+UNROLL
*  LOOP
*  SYMBN
*;

**********************************************************************
* Desc:		Find << depth and return ultimate c of an irrq
* Stack:	( obj --> # c )
**********************************************************************
NULLNAME IRRQ#ULTIMATE
::
  ZEROSWAP			( # obj )
  [BEGIN]
	DUPTYPEIRRQ?
  [WHILE]
       IRRQULTIMATELP
  [REPEAT]
;

LABEL IRRQULTIMATELP
::
  SWAP#1+SWAP FOUR NTHCOMPDROP
;


**********************************************************************
* Desc:		Compare objects by type and then by CRC
* Stack:	( obj1, obj2 -> obj1, obj2, flag )
* Note:		flag is true if obj1 is less complex than obj2 (obj1>obj2)
*		if obj1 or obj2 is an irrq, find first ultimate
*		type of obj1 and obj2. If these ultimate types
*		are equal sort is done by comparing the << depth
**********************************************************************
NULLNAME LESSCOMPLEX?
::
  OVER IRRQ#ULTIMATE XEQTYPE		( o1 o2 #1 c1 t1 )
  4PICK IRRQ#ULTIMATE XEQTYPE		( o1 o2 #1 c1 t1 #2 c2 t2 )
  4ROLL 2DUP %=				( o1 o2 #1 c1 #2 c2 t2 t1 ?= )
  case2drop COMPULTIMATE=
					( o1 o2 #1 c1 #2 c2 t2 t1 )
  ( * different type, note: one of them is a zint if objs where c of irrq * )
  6UNROLL 5UNROLL 4DROP			( o1 o2 t1 t2 )
  %>					( o1 o2 flag )
  ( * %> is used because zint type is 28, complex type is 9, list is 5 * )
;

LABEL COMPULTIMATE=
::					( o1 o2 #1 c1 #2 c2 )
  ( * same ultimate type, compare depth * )
  4ROLLROT				( o1 o2 c1 c2 #1 #2 )
  2DUP#= case2drop COMPULTIMATE==
					( o1 o2 c1 c2 #1 #2 )
  #< UNROT2DROP				( o1 o2 flag )
;

LABEL COMPULTIMATE==
::
  ( * same type and same depth, compare object complexity * )
  ( * for integers, c1>c2 is the usual > * )
  					( o1 o2 c1 c2 )
  2DUP EQUALNOTcase COMPDIFFERENT	( -> o1 o2 ? )
					( o1 o2 c1 c2 )
  2DROP 2DUP EQUAL caseTRUE 		( -> o1 o2 true )
					( o1 o2 )
  2DUP COMPDIFFERENT			( -> o1 o2 ? )
;

LABEL COMPDIFFERENT
* c1, c2 -> ? [assumes c1 != c2 ]
::					( c1 c2 )
  DUPTYPEZ? case COMPZNLT?		( -> ? )
  dLISTcase LISTCOMPARE
					( c1 c2 )
  SWAP OCRC ROT OCRC			( n1 cr1 n2 cr2 )
  4ROLLROT				( cr1 cr2 n1 n2 )
  2DUP#= case2drop :: HXS<HXS %0<> ;	( -> ? )
  #< UNROT2DROP				( ? )
;

LABEL COMPZNLT?
::
  QSub ZIsNeg?
;

LABEL LISTCOMPARE
* l1, l2 -> flag
::
  OVER LENCOMP OVER LENCOMP		( l1 l2 #l1 #l2 )
  2DUP#= NOTcase :: #< UNROT2DROP ;	( -> flag )
  ( * same length, compare first distincts elements * )
  2DROP					( l1 l2 )
  ( * search first distinct element * )
  BEGIN					( l1 l2 )
     OVER CARCOMP OVER CARCOMP		( l1 l2 l1.1 l2.1 )
     2DUP EQUAL				( l1 l2 l1.1 l2.1 ? )
  WHILE
    :: 2DROP SWAP CDRCOMP SWAP CDRCOMP ;	( l1' l2' )
  REPEAT
					( l1 l2 l1.1 l2.1 )
  2SWAP 2DROP LESSCOMPLEX? 		( l1.1 l2.1 ? )
  UNROT2DROP				( ? )
;

**********************************************************************
* Desc:		Add the C-part of all irrquads of object to the list.
* Stack:	( ob {} --> {}' )
**********************************************************************
NULLNAME LISTIRRQ
CODE
listirrq	GOSUBL	swapml
		GOSUBL	a=stkwc0
		LC(5)	=DOLIST
		?A#C	A
		GOYES	listirrq1
		A=PC
		LC(5)	(listirrqlist!)-(*)
listirrqbr	A=A+C	A
		PC=(A)
listirrq1	C=A	W
		LCIRRQ
		?A#C	A
		GOYES	listirrq2
		A=PC
		LC(5)	(listirrqirrq!)-(*)
		GOTO	listirrqbr
listirrq2	LA(5)	=DROP
		PC=(A)
ENDCODE

LABEL listirrqlist!
::
  INNERCOMP get1 SWAP
  ZERO_DO (DO)
     LISTIRRQ
  LOOP
;

LABEL listirrqirrq!
::
  FOUR NTHCOMPDROP AppendList
;


**********************************************************************
* Desc:		Various constants
* Note: 	caution: these constants are "covered"
*		if you are using them be sure to return an uncovered result
*		on the stack when exiting
**********************************************************************

LABEL BINT80000
# 80000

NULLNAME LIST1i-1-i
{ Z1 SYMBOL xi ; Z-1 SYMBOL xi xNEG ; }

NULLNAME LIST10-10
{ Z1 Z0 Z-1 Z0 }

LABEL EXPPI3LIST
{
  Z-1
  SYMBOL Z1 xi Z3 x\v/ x* x+ Z2 x/ ;
  SYMBOL Z1 xi Z3 x\v/ x* x- Z2 x/ xNEG ;
}

LABEL EXPPI4LIST
{
  Z1
  SYMBOL Z1 xi x+ Z2 x\v/ x* Z2 x/ ; 
}

LABEL EXPPI6LIST
{
  Z1
  SYMBOL xi Z3 x\v/ x+ Z2 x/ ;
  SYMBOL Z1 xi Z3 x\v/ x* x+ Z2 x/ ;
}


* --------------------------------------------------------------------
* Desc:		Table of special COS values (k*pi/12)
* Stack:	( --> {} )
* --------------------------------------------------------------------
NULLNAME TABLECOSext
{
  Z1				( cos 0 )
  ZERO				( cos pi/12 not in the table )
  sqrt32			( cos 2*pi/12=pi/6 )
  sqrt22			( cos 3*pi/12=pi/3 )
  onehalf
  ZERO
  Z0				( cos 6*pi/12=pi/2 )
  ZERO
  minusonehalf
  minussqrt22
  minussqrt32 
  ZERO
  Z-1				( cos pi )
  ZERO
  minussqrt32 
  minussqrt22 
  minusonehalf
  ZERO
  Z0				( cos 3*pi/2 )
  ZERO
  onehalf
  sqrt22			
  sqrt32
  ZERO
}

**********************************************************************
* Desc:		Table of special TAN values (k*pi/12)
* Stack:	( --> {} )
**********************************************************************
NULLNAME TABLETANext
{
  Z0
  ZERO
  sqrt33
  Z1
  sqrt3
  ZERO
  INFINIext
  ZERO
  minussqrt3
  Z-1 
  minussqrt33
  ZERO
}

LABEL sqrt32 
SYMBOL Z3 x\v/ Z2 x/ ;

LABEL sqrt22
SYMBOL Z2 x\v/ Z2 x/ ;

LABEL onehalf
SYMBOL Z1 Z2 x/ ;

LABEL minusonehalf
SYMBOL Z-1 Z2 x/ ;

LABEL minussqrt22
SYMBOL Z2 x\v/ Z2 x/ xNEG ;

LABEL minussqrt32 
SYMBOL Z3 x\v/ Z2 x/ xNEG ;

LABEL sqrt33
SYMBOL Z3 x\v/ Z3 x/ ;

LABEL sqrt3
SYMBOL Z3 x\v/ ;

LABEL minussqrt3
SYMBOL Z3 x\v/ xNEG ;

LABEL minussqrt33
SYMBOL Z3 x\v/ Z3 x/ xNEG ;
	
NULLNAME DROPZ1
:: DROP Z1 ;

NULLNAME DROPZ0
:: DROP Z0 ;

LABEL Z15
:: ZINT 15 TOTEMPOB ;

LABEL Z30
:: ZINT 30 TOTEMPOB ;

LABEL Z45
:: ZINT 45 TOTEMPOB ;

LABEL Z60
:: ZINT 60 TOTEMPOB ;

LABEL Z90
:: ZINT 90 TOTEMPOB ;

LABEL Z120
:: ZINT 120 TOTEMPOB ;

* ====================================================================
* Routines to handle infinity
* ====================================================================

**********************************************************************
* Desc:		Test if object contains infinity
* Stack:	( ob --> ob flag )
**********************************************************************
NULLNAME TESTINFINI
::
  DUPTYPESYMB?
  NOTcase
    :: INFINIext
       CARCOMP
       OVER EQUAL NOTcaseFALSE
       symcomp TRUE
     ;
  POSINFext #0<>
;

NULLNAME INFINIext
:: unsignedinf SYMBN ;

NULLNAME MINUSINFext
:: minusinf SYMBN ;

NULLNAME PLUSINFext 
:: plusinf SYMBN ;

NULLNAME ?ext
:: metaundef SYMBN ;

* The following two find the 1st occurrance of infinity or undef
* ( ob --> ob #pos )

NULLNAME POSINFext
:: 
  DUPTYPESYMB? NOTcase ZERO 
  ' ROMPTR x\9F OVER ListPos 
;

NULLNAME POSUNDEFext
:: 
   DUPTYPESYMB? NOTcase ZERO
   ' ROMPTR x? OVER ListPos 
;

* ====================================================================
* Constants and meta involving PI
* Note: these constants are safe (not covered)
* ====================================================================

NULLNAME pisur2
:: metapi/2 SYMBN ;

NULLNAME pisur-2
:: meta-pi/2 SYMBN ;

NULLNAME pi
:: metapi SYMBN ;

NULLNAME metapi
:: 'xPI ONE ;

NULLNAME 'xPI
:: ' xPI ;

NULLNAME metai
:: 'xi ONE ;

NULLNAME 'xi
:: ' xi ;
		
NULLNAME ipi
:: metaipi SYMBN ;

NULLNAME metaipi
:: 'xi 'xPI 'x* THREE ;

LABEL droppi
:: 
  drop ckpi
;

LABEL ckpi
::
  RAD? case metapi 
  Z180 ONE 
;
	
NULLNAME meta-pi
:: metapi metaneg ; 

LABEL drop-pi
:: droppi metaneg ;

LABEL metapi/'R
:: 'xPI 'R ' x/ THREE ;

NULLNAME metapi/2
:: metapi/'R Z2 ;

LABEL droppi/2
:: 
  drop 
  ckpi/2
;

LABEL ckpi/2
::
  RAD? case metapi/2 
  Z90 ONE
;

NULLNAME metapi/4
:: metapi/'R Z4 ; 

LABEL droppi/4
:: 
  drop ckpi/4
;

LABEL ckpi/4
::
  RAD? case metapi/4 
  Z45 ONE
;

LABEL ckpi/3
::
  RAD? case :: metapi/'R Z3 ;
  Z60 ONE
;

LABEL ck2pi/3
::
  RAD? NOTcase :: Z120 ONE ;
  Z2 ONE metapi metamult Z3 ONE metadiv 
;

LABEL ckpi/6
::
  RAD? case :: metapi/'R Z6 ;
  Z30 ONE
;

NULLNAME meta-pi/2
:: metapi/2 metaneg ; 

LABEL drop-pi/2
:: droppi/2 metaneg ;

NULLNAME meta-pi/4
:: metapi/4 metaneg ; 

LABEL drop-pi/4
:: droppi/4 metaneg ;

NULLNAME pifois2
:: metapi*2 SYMBN ;

NULLNAME deuxipi
:: metai metapi*2 metamult SYMBN ;

NULLNAME metapi*2
:: Z2 metapi #1+ addt: x* ;

NULLNAME base_ln
:: meta_e SYMBN ;

NULLNAME meta_e
:: ' xe ONE ;
	

* ====================================================================
* Various utilities
* ====================================================================

**********************************************************************
* Desc:		Extract in list2 all occurrances of the 1st object
*		of list, the remaining objects are stored in list1.
* Stack:	( list --> list1 list2 )
* Note:		list1 = list-list2
**********************************************************************
NULLNAME NEXTPext
::
  NULL{}
  SWAPDUP LENCOMP #>1 NOT?SEMI
  SWAPDROP				( liste )
  INNERDUP				( o1, ..., on, #n, #n )
  get1 ONE				( o2, ..., on, #n, #n, o1, #1 )
  ROT #1-
  ZERO_DO (DO)				( o2, ..., on, #n, o1, #m )
     ROT				( o2, ..., on, o1, #m, #n )
     get1				( o3, ..., on, o1, #m, #n, o2 )
     4PICKOVER				( o3, ..., on, o1, #m, #n, o2, o1, o2 )
     ::
        EQUALcasedrp #1-UNROT		( --> o3, ..., on, #n-1,o1,#m)
					( o3, ..., on, o1, #m, #n, o2 )
        4UNROLL 			( o3, ..., on, o2, o1, #m, #n )
        UNROT #1-			( o3, ..., on, o2, #n, o1, #m-1 )
     ;
					( o3, ..., on, o2, #n, o1, #m )
     #1+
  LOOP
					( o2, ..., on, #n, o1, #m )
  NDUPN {}N
  SWAP#1-SWAP OVER#2+UNROL
  {}N SWAP
;

**********************************************************************
* Desc:		Insert object into list at given position.
*		The position must be < than length of the list.
*		If the position is zero, >TCOMP is used.
* Stack:	( {} ob #pos --> {}' )
**********************************************************************
NULLNAME INSERT{}N
::
  DUP#0=csedrp >TCOMP
  ROT INNERCOMP get1			( ob v1...vk #k #pos )
  SWAP#1+				( ob v1...vk #pos #k+1 )
  DUPROT #-SWAP				( ob v1...vk #k+1-pos #k+1 )
  get1					( v1...vk #k+1-pos #k+1 obj )
  ROT #2+UNROLL {}N
;

**********************************************************************
* Desc:		Suppress multiple occurrances in the list.
* Stack:	( {} --> {}' )
**********************************************************************
NULLNAME COMPRIMext
::
  DUPNULL{}? ?SEMI
  INNERCOMP reversym
  NULL{} SWAP
  ZERO_DO (DO)
     SWAP AppendList
  LOOP
;

