INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE global.s
INCLUDE keydefs.h

**********************************************************************
* EXPORT:
*
*   PSEUDODIV	( Q2, Q1 -> a, Q2*a div Q1, Q2*a mod Q1 )
*		a is s.t.  Q2*a div Q1, Q2*a mod Q1 are Q objects (no fraction)
*
*   CDIV2	( c2, c1 -> c2 div c1, c2 mod c1 )
*		eucl. div. for Gauss integers
*
*   QUOText	( Q2 Q1 --> Q2/Q1 )
*		works even if Q2 mod Q1 != 0
*
*   NEWDIVext   ( o2 o1 -> o2 div o1, o2 mod o1 )
*		like DIVext but accepts rational inputs
*
*   DIVext	( Q2 Q1 --> Q2 div Q1, Q2 mod Q1 )
*
*   DIV2LISText	( 0 P2 P1 --> P2 div P1, P2 mod P1 )
*
*   DIVOBJext   ( { o1 ... on } , obj  -> { o1/obj ... on/obj } )
*
*   DIVMETAOBJ  ( o1, ..., on, #n, obj -> { o1/obj ... on/obj } )
*
*   LOPDext     ( { o1 ... on }, obj -> { o1 div obj, ..., on div obj } )
*		Division is a call to QUOText
*
*   QUOTOBJext  ( a_a-1, ..., a0, bb_1, ..., b0, #b, #a , flag -> r, q )
*		SRPL euclidean division utility
*		computes the remainder r only if flag is TRUE 
*
*   DIVISIBLE?	( Q2 Q1 --> Q2/Q1 TRUE / FALSE )
*		Tests if Q1 divides Q2
*
*   DIVISTRAPERR 
*		(traps error of DIVISIBLE?)
*
*   FastDiv?    ( P, Q -> [ P div Q, P mod Q, TRUE | P, Q, FALSE ] )
*		Returns FALSE in complex mode else tries sparse rep. division
*
*   DISTDIVext  ( P, Q -> [ P div Q, P mod Q, TRUE | P, Q, FALSE ] )
*		sparse representation division
**********************************************************************

**********************************************************************
* Desc:
* Stack:	( o2, o1 -> o2*a1.n^, o1, a1.n^ )
**********************************************************************
NULLNAME PSEUDOPREP
CODE

* teste si obj1 est une liste

		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	12
		R0=A
		D1=D1-	5
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A=C	A
		GOYES	newdiv1
newdiv0		GOVLNG	=zint1
newdiv1		A=R0
		C=A	W
		LCZ1
		?A=C	W
		GOYES	newdiv0
		D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A#C	A
		GOYES	newdiv0
		A=PC
		LC(5)	(pseudoprep!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL pseudoprep!
::					( l1 l2 )
  OVER LENCOMP OVER LENCOMP		( l1 l2 #l1 #l2 )
  2DUP#< case2drop Z1
  #-+1 OVER CARCOMP 			( l1 l2 # a1 )
  INTERNFLOAT? case2drop Z1			( -> l1 l2 1 )
					( l1 l2 # a1 )
  SWAP RP#				( l1 l2 a1.n^ )
  ONE>POLY DUP				( l1, l2, {a1.n^}, {a1.n^} )
  4UNROLLROT QMul			( {a1.n^}, l2, l1*a1^n )
  SWAPROT				( l1*a1.n^, l2, {a1.n^} )
;

**********************************************************************
* Desc:
* Stack:	( Q2, Q1 -> a, Q2*a div Q1, Q2*a mod Q1 )
**********************************************************************
NULLNAME PSEUDODIV
::
  PSEUDOPREP				( o1*a, o2, a )
  UNROT QDivRem				( a, o1*a div o2, o1*a mod o2 )
;

NULLNAME IDIV2
::
  CK&DISPATCH1
  zintzint IDIV2Z
  any      CDIV2ext
;

LABEL IDIV2Z
* like ZDIVext but insure that z2 and r have the same sign:
* if z1=q*z2+r
* then z1/z2=q+r/z2
* q is the floor of z1/z2 if r and z2 have the same sign
::					( z1 z2 )
  DUPUNROT ZDIVext			( z2 q r )
  num#0=case ROTDROP			( return q r if r=0 )
  3PICK ZIsNeg? OVER ZIsNeg?		( z2 q r ? ? )
  XOR NOTcase ROTDROP			( -> q r )
					( z2 q r )
  UNROT Z1 QSub				( r z2 q-1 )
  UNROT QAdd				( q'=q-1 r'=r+z2 )
;

**********************************************************************
* Desc:
* Stack:	( o2, o1 -> o2 div o1, o2 mod o1 )
**********************************************************************
NULLNAME BESTDIV2
::
  CK&DISPATCH1
  zintzint ZDIVext
  any      NEWDIVext
;
**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME CDIV2ext
::
  SWAPDUP CK1Cext			( b, a, a )
  ROT CK1Cext				( a, a, b )
  CMODext				( a, b, a mod b )
  ROTOVER RSUBext			( b, a mod b, a - a mod b )
  ROT RDIVext SWAP			( a div b, a mod b )
;

**********************************************************************
* Desc:		euclidean quotient of 2 objets (works even if o2 mod o1=0)
* Stack:	( o2, o1 -> o2 div o1 )
**********************************************************************
NULLNAME QUOText
LABEL quotext!
::
  CK&DISPATCH1
  2LIST   QUOT2LIST
  EIGHTY  DIVOBJext		( liste, objet ) 
  list    2DROPZ0		( objet, liste )
  any     RDIVext
;

LABEL QUOT2LIST
::
  2DUPEQ case2drop Z1
						( A=l1, B=l2 )
  FastDiv? caseDROP
  SWAPINCOMP get1 INNERCOMP		( a_a-1...a0 #a bb_1...b0 #b )
  CODE
		A=DAT1	A
		LC(5)	=ONE
		?A=C	A
		GOYES	quotlist1
		LA(5)	=get1
		PC=(A)
quotlist1	D1=D1+	5	( casedrop )
		D=D+1	A
		GOSBVL	=semiml
* a_a-1, ..., a0, #a, b0 
		GOTO	divmetaobj
  ENDCODE
					( A a_a-1..a0 bb_1...b0 #b #a )
  FALSE QUOTOBJext			( r, q )
;

**********************************************************************
* Desc:		euclidean division, obj2 and obj1 may be fractions of
* 		returns a fraction of Q
* Stack:	( obj2, obj1 -> obj2 div obj1, obj2 mod obj1 )
**********************************************************************
NULLNAME NEWDIVext
::
  2DUP EQUAL case2drop Z1Z0
  num#0=case :: DROP ?ext SWAP ;

* division euclidienne rationnelle
* a1^ * n2 = n1 * q + r
* donc n2/d2 = n1/d1 * [q d1/ (d2*a1^) ] + r /(d2*a1^)

  FXNDext 				( n2/d2 n1 d1 )
  ( * test if deno length is 1 to avoid infinite recursion * )
  SWAP DUPCKLEN{} #1=case NEWDIV1
					( n2/d2 d1 n1 )
  SWAPROT FXNDext			( n1, d1, n2, d2 )
  SWAP 4ROLL				( d1, d2, n2, n1 )
  PSEUDOPREP				( d1, d2, o2*a1.n^, o1, a1.n^ )
  4ROLL RMULText UNROT			( d1, d2*a1.n^, o2*a1.n^, o1 )
  QDivRem				( d1, d2*a1.n^, quot, mod )
  3PICK RDIVext				( d1, d2*a1.n^, quot, mod/d2*a1^ )
  4UNROLLROT				( mod/d2*a1^, d2*a1.n^, quot, d1 )
  RMULText SWAP RDIVext			( mod/d2*a1^, d1*quot/d2*a1^ )
  SWAP
;

LABEL NEWDIV1
::					( n2/d2 d1 n1 )
  ( * length=1 hence mod is 0 and quot is n2*d1/n1*d2 * )
  ROT FXNDext				( d1 n1 n2 d2 )
  4ROLLROT QMul				( n1 d2 d1*n2 )
  UNROT QMul				( d1*n2 n1*d2 )
  ( * test again for length=1 * )
  DUPCKLEN{} #1=case NEWDIV11
  RDIVext Z0				( d1*n2/n1*d2 0 )
;

LABEL NEWDIV11
::					( n {d} )
  OVER TYPELIST? NOTcase :: DUPTYPELIST? ITE NDXFext QDiv Z0 ;
  CKCARCOMP				( n d )
  					( n d )
  >TCOMP LPGCDext			( n&d g )
  ' RDIVext LOP1ext			( n&d/g )
  REWRITEASQ FXNDext DROP		( n&d )
  INNERCOMP #1-SWAP OVER#2+UNROLL	( d meta-n )
  {}POLY SWAP ONE>POLY 			( n d )
  mult2conj! NDXFext Z0			( n/d 0 )
;

**********************************************************************
* Desc:		Polynomial Euclidean division of 2 objects
*		dispatchs to DIV2LISText for list polynomials
* Stack:	( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
**********************************************************************
NULLNAME QDivRem
::
  Z0 UNROT
  CK&DISPATCH1
  2LIST  DIV2LISText
  EIGHTY
     ::					( Z0, liste, objet )
       FXNDext				( Z0, liste, obj-n, obj-d )
       DUP 4ROLL RMULText		( Z0, obj-n, obj-d, liste*obj-d )
       ROT				( Z0, obj-d, liste*obj-d, obj-n )
       NOTLISTcase
          :: DIVOBJext SWAPDROPSWAP ;
       4ROLLDROP QDivRem		( obj-d, liste*obj-d/obj-n, mod )
       ROT DIVOBJext
     ;
  list
     ::					( Z0, objet, liste )
       SWAPFXND				( Z0, liste, obj-n, obj-d )
       DUP 4ROLL RMULText		( Z0, obj-n, obj-d, liste )
       3PICK TYPELIST? case
       ::				( Z0, obj-n, obj-d, liste )
         4ROLLDROP ROTSWAP		( obj-d, obj-n, liste )
         QDivRem ROT RDIVext
       ;
					( Z0, obj-n, obj-d, liste )
       DUPLENCOMP #1= NOTcasedrop NDXFext
       SWAPDROP NEWTRIMext NDXFext SWAP
     ;
  any :: RDIVext SWAP ;
;

**********************************************************************
* Desc:		euclidean division, l1 and l2 are list polynomials 
*		test first if l1=l2
*		then tries fast division, if it fails switch to SRPL division
* Stack:	( Z0, l1, l2 -> l1 div l2, l1 mod l2 )
**********************************************************************
NULLNAME DIV2LISText
*:: SHALT
CODE
div2list	GOSBVL	=SAVPTR
		D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		C=DAT1	A
		D1=A	-> stk2
		D0=C	-> stk1
		GOSBVL	=EQUAL?
		GOC	div2listneq
		GOSBVL	=GETPTR
		D=D+1	A
		D1=D1+	10	-> 0
		LA(5)	=Z1
		C=DAT1	A
		DAT1=A	A
		D1=D1-	5
		DAT1=C	A
		GOVLNG	=Loop
div2listneq	
*		D0=D0+	5
*		A=DAT0	W
*		C=A	W
*		LCZ1
*		?A#C	W
*		GOYES	div2listext
*		D0=D0+	12
*		GOSBVL	=SKIPOB
*		A=DAT0	A
*		LC(5)	=SEMI
*		?A#C	A
*		GOYES	div2listext
*		GOSBVL	=GETPTR
*		A=PC
*		LC(5)	(div2listh!)-(*)
*		GOTO	div2listbr
div2listext	GOSBVL	=GETPTR
		A=PC
		LC(5)	(div2listext!)-(*)
div2listbr	A=A+C	A
		PC=(A)
ENDCODE
*; ( test )


* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
*LABEL div2listh!
*::					( Z0, A, b -> A div B, A mod B )
*
* ( B est de la forme { 1 b }, on applique horner )
* OVER INNERCOMP			( 0, A, b, a0, ..., an, #n+1 )
* DUP#1= casedrop DROP
* get1 METAHORNext			( 0, A, b0, ..., bn-1, #n+1, bn )
* OVER #1+UNROL #1-{}N 2SWAP 2DROP
*;

* --------------------------------------------------------------------
* Desc:
* Stack:	( Z0, A, B -> A div B, A mod B )
* --------------------------------------------------------------------
LABEL div2listext!
::		
  FastDiv? case ROTDROP

* step 1 of SRPL division

  OVER INNERCOMP get1 INNERCOMP

  ( Z0, A, a_a-1, ..., a0, #a, bb_1, ..., b0, #b )

* if length[B]= 1, then -> divmetaobj, else -> get1

  CODE
div2list0	A=DAT1	A
		LC(5)	=ONE
		?A=C	A
		GOYES	div2list1
		LA(5)	=get1
		PC=(A)
div2list1	D1=D1+	5	( casedrop )
		D=D+1	A
		GOSBVL	=semiml
* ( Z0, A, a_a-1, ..., a0, #a, b0 )
		GOSBVL	=a=stkwc1
		?A#C	W
		GOYES	div2list2
* Z0, A, a_a-1, ..., a0, #a, bb_0: on recupere #a pour NDROP
		D=D+1	A
		D1=D1+	5
		GOSBVL	=POP#
		GOSBVL	=ndropml
* Z0, A
		LA(5)	=SWAP
		PC=(A)
div2list2	
* Z0, A, a_a-1, ..., a0, #a, bb_0
		A=PC
		LC(5)	(divmetaunrot!)-(*)
		A=A+C	A
		PC=(A)
  ENDCODE

  ( Z0, A, a_a-1, ..., a0, bb_1, ..., b0, #b, #a )

  2DUP#> 

  CODE
		A=DAT1	A
		LC(5)	=TRUE
		?A#C	A
		GOYES	+
		D1=D1+	5	pour case :: #+ NDROP ; TRUE )
		D=D+1	A
		GOSBVL	=semiml
		GOSBVL	=POP2#
		A=A+C	A
		GOSBVL	=ndropml
		GOVLNG	=Loop	
+		DAT1=C	A
quotobj		A=PC
		LC(5)	(quotobjext!)-(*)
quotbranch	A=A+C	A
		PC=(A)	
  ENDCODE
					( Z0, A, r, q )
  ROTDROP ROTDROPSWAP			( q, r )
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL	divmetaunrot!
::
  DIVMETAOBJ UNROTDROP
;

**********************************************************************
* Desc:		division of all elements of a list by obj
*		tests if obj=1
* Stack:	( { o1 ... on } , obj  -> { o1/obj ... on/obj } )
**********************************************************************
NULLNAME DIVOBJext
ASSEMBLE
=divobjext!
RPL
::
  CODE
	GOSBVL	=a=stkwc1
	?A#C	W		obj<>1?
	GOYES	+
	GOSBVL	=semiml		
	GOVLNG	=DropLoop	si obj=1 f/obj=f
+	D1=D1+	5		f=liste?
	A=DAT1	A
	AD1EX
	C=DAT1	A
	AD1EX
	D1=D1-	5
	LA(5)	=DOLIST
	?A=C	A
	GOYES	++
* new code, otherwise returned depth is wrong
	LA(5)	=SWAPONE 
	PC=(A)
* old code was
*	GOSBVL	=semiml
*	GOVLNG	=rdiv		f<>liste, on appelle rdiv
* end change
++	LA(5)	=SWAPINCOMP
	PC=(A)
  ENDCODE

  get1			( o1, ..., on, #n, o )
  DIVMETAOBJ
;

**********************************************************************
* Desc:		division of all elements of a meta by o
*		tests if o=1
* Stack:	( o1, ..., on, #n, o -> { o1/o, ..., on/o } )
**********************************************************************
NULLNAME DIVMETAOBJ
CODE
divmetaobj	GOSBVL	=a=stkwc1	si o=1 on fait juste {}N
		?A=C	W
		GOYES	+
		A=PC
		LC(5)	(divmetaobj!)-(*)
		A=A+C	A
		PC=(A)
+		D1=D1+	5
		D=D+1	A
		LA(5)	={}POLY
		PC=(A)
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL divmetaobj!
::
  OVER
  ZERO_DO (DO)			( o1, ..., on , #n, o )
     ROTOVER RDIVext
     DUPTYPESYMB? divflag TestSysFlag 
     ANDcase ErrUndefRes
     3PICK #2+UNROLL
  LOOP
  DROP {}POLY
;

**********************************************************************
* Desc:		LOPDext calls QUOText for the division, unlike
*		DIVOBJ which calls RDIVext
* Stack:	{ o1 ... on }, obj -> { o1 div obj, ..., on div obj }
**********************************************************************
NULLNAME LOPDext
CODE
lopd		D1=D1+	5
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		D1=D1-	5
		LC(5)	=DOLIST
		?A#C	A
		GOYES	lopdquot
		A=PC
		LC(5)	(lopdext!)-(*)
lopdbr		A=A+C	A
		PC=(A)
* si stk2 n'est pas une liste -> quot
lopdquot	A=PC
		LC(5)	(quotext!)-(*)
		GOTO	lopdbr
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL lopdext!
::
  SWAPINCOMP get1 OVER
  ZERO_DO (DO)			( o1, ..., on , #n, o )
     ROTOVER QUOText NEWTRIMext
     3PICK #2+UNROLL
  LOOP
  DROP {}POLY
;

**********************************************************************
* Desc:		SRPL euclidean division: step 2
*		computes the remainder r only if flag is TRUE 
* Stack:	a_a-1, ..., a0, bb_1, ..., b0, #b, #a , flag -> r, q 
**********************************************************************
NULLNAME QUOTOBJext
LABEL quotobjext!
::
  UNROT
  2DUPSWAP #-+1 TOTEMPOB
  ONE TOTEMPOB
  Z0

  ( a_a-1, ..., a0, bb_1, ..., b0, false, #b, #a, #a-b=i, #0=j, q  -> r, q )

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL divdeb!
CODE
* on decremente j, -> si necessaire i, ?fini, sinon calcul de q et j=#b
	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A=#j )
	A=A-1	A
	?A=0	A
	GOYES	div0
	DAT1=A	A
	D1=C
	GOTO	div10
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q
div0	R0=C	A
	CD1EX
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	CD1EX
	DAT1=A	A	( #j=#b )
	R1=A	A	( R1=#b )
	C=R0	A
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A	( #i decremente )
	D1=C
	GONC	div2
	A=D0
	LC(5)	(divfin!)-(divdiv!)
=D0=A+C_lp	A=A+C	A
	D0=A
	GOVLNG	=Loop
* calcul de q=a/b
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div2	C=R1	A	( R1=#b )
	C=C+C	A	( C=2*#b )
	C=A+C	A	( C=2*#b+#i )
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R1	A
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	GOVLNG	=rdiv

* rappelle a, b, q sur la pile
* q_a-b-1, ..., q_i, a_i+b-1, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div10	GOSUB	div?c
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R0	A	( c=#j )
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	LC(5)	2
	GOSUB	divpick	( pick q )
	A=D0
	LC(5)	(divmul!)-(divdiv!)
	GOTO	D0=A+C_lp
divpick	D=D-1	A
	GONC divp1
	GOSBVL	=GARBAGE1
divp1	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	( A= 5*c )
	C=D1
	C=C+A	A
	CD1EX		( D1 pointe sur c_c, C sur le sommet de la pile )
	A=DAT1	A	( A= @c_c )
	CD1EX
	D1=D1-	5
	DAT1=A	A	( copie de c_c au sommet de la pile )
	RTN
* #b, #a, #i, #j, q -> semblable; r0=#j, r1=#b, c=#i+#j+#b
div?c	C=D1
	D1=D1+	5	( calcul i+j+b )
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( r0= #j )
	D1=C
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R1=A	A	( r1=#b )
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( a=#i )
	D1=C
	C=R0	A
	A=A+C	A
	C=R1	A
	C=A+C	A	( c=#i+#j+#b )
	RTN
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL divdiv!

( q_q-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, newq )
CODE
		A=DAT1	A
		LC(5)	=ZERO
		?A#C	A
		GOYES	divdiv!1
divdiv!0	A=PC
		LC(5)	(divzero!)-(*)
		A=A+C	A
		PC=(A)
divdiv!1	GOSBVL	=a=stk1
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	divdiv!0
divdiv!2	A=DAT1	A
		D1=D1+	5
		DAT1=A	A	( q=newq )
		D1=D1-	5
* on teste si flag=false et i=1 -> fini
		C=D1
		D1=D1+	15
		D1=D1+	15
		A=DAT1	A
		D1=C
		LC(5)	=FALSE
		?A#C	A
		GOYES	div19
		C=D1
		D1=D1+	15
		A=DAT1	A
		D1=A
		D1=D1+	5
		A=DAT1	A
		D1=C
		?A=0	A
		GOYES	div20
div19		A=D0
		LC(5)	(divmul!)-(divdeb!)
		A=A-C	A
		D0=A
		GOTO	divrep	( newq -> a_i+j=a_i+b )
div20		A=D0
		LC(5)	(divfin!)-(divmul!)
		A=A+C	A
		D0=A
		GOTO	divrep
ENDCODE

( q_q-1...q_i+1 a_i+b...a0 bb_1...b0 flag #b #a #i #j q newq )


* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL divmul!

  RMULText
  RSUBext
( q_q-1...q_i+1 a_i+b-1...a0 bb_1...b0 flag #b #a #i #j q a )
  CODE
	A=D0
	LC(5)	(divfin!)-(divdeb!)
	A=A-C	A
	D0=A
* on remplace stk_i+j+b+4 par le sommet de pile qu'on detruit
divrep	D1=D1+	5
	GOSUB	div?c
	C=C+CON	A,5
	A=C	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	C=D1
	C=C+A	A
	D1=D1-	5
	A=DAT1	A
	D1=D1+	5
	CD1EX
	DAT1=A	A
	CD1EX
	D=D+1	A
	GOVLNG	=Loop
  ENDCODE
  ( q_q-1...q_i+1 a_i+b-1...a0 bb_1...b0 flag #b #a #i #j q )

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
  LABEL divfin!
  ( q_q-1...q_0 a_b-2...a0 bb_1...b0 flag #b #a #i #j q )
  3DROP ROT
  NOTcase
    :: ( flag= false, on a juste besoin du quotient )
       ( q_q-1, ..., q_0, a_b-2, ..., a0, bb_1, ..., b0, #b, #a )
       CODE
		GOSBVL	=POP2#	A=#b, C=#a
		A=A-1	A	
		R0=A.F	A	R0=#b-1
		R1=C.F	A	R1=#a
		A=A+A	A
		A=A+1	A
		GOSBVL	=ndropml
		GOSBVL	=SAVPTR
		A=R1.F	A
		C=R0.F	A
		A=A-C	A	#a-#b+1
		GOVLNG	=PUSH#ALOOP
       ENDCODE
       >POLYTRIM			( q )
    ;
				( q_q-1...q_0 a_b-2...a0 bb_1...b0 #b #a )
  OVER#2+UNROL
  DUPDUP #2+UNROLL NDROP	( q_q-1...q_0 a_b-2...a0 #a #b )
  #1- DUPUNROT #- OVER#2+UNROL
  >POLYTRIM
  OVER#2+UNROL >POLYTRIM		( r, q )
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL divzero!
* division impossible, on renvoie un quotient symbolique et un reste nul
::
  divflag TestSysFlag
  NOTcase
  CODE
		GOTO	divdiv!2
  ENDCODE

  ( traiter les quotients invalides par ERRSET/ERRTRAP )
  ErrUndefRes

* RDROP 4DROP #+ NDROP DROP
* ZERO Z0
;

**********************************************************************
* Desc:		returns TRUE and quotient if b divides a, otherwise
*		returns FALSE
* Stack:	( a, b -> [ a/b, TRUE | obj, FALSE ] )
**********************************************************************
NULLNAME DIVISIBLE?
::
  divflag TestSysFlag
  divflag SetSysFlag
  Z0 2SWAP				( flag, 0, a, b )
  DEPTH 1LAMBIND
  ERRSET DIV2LISText
  ERRTRAP DIVISTRAPERR
  ABND					( flag, a/b, a mod b )
  divflag 4ROLL ITE_DROP ClrSysFlag	( a/b, a mod b )
  NEWTRIMext Z0 EQUAL
;

**********************************************************************
* Desc:		returns TRUE and quotient if b divides a, otherwise
*		returns FALSE
* Stack:	( a, b -> [ a/b, TRUE | FALSE ] )
**********************************************************************
NULLNAME QDiv?
::
  DIVISIBLE? NOTcase DROPFALSE TRUE
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
LABEL DIVISTRAPERR
::	
  ERROR@ #304 ( Undef Res Error ) #<>case ERRJMP
  DEPTH #3+ 1GETABND #- NDROP
  divflag SWAP ITE_DROP ClrSysFlag
  ZEROFALSE RDROP
;

**********************************************************************
* Desc:		Eucl. Division
*		Assume P and Q have integer or Gauss integer coeff
*		returns FALSE in complex mode or if sparse short
*		division fails
* Stack:	P, Q -> [ P div Q, P mod Q, TRUE | P, Q, FALSE ]
**********************************************************************
NULLNAME FastDiv?
::
  COMPLEX? caseFALSE
  DISTDIVext
;

**********************************************************************
* Desc:		Step by step euclidean division for small integers
* Stack:	( z1 z2 -> q r )
**********************************************************************
NULLNAME POTENCEext
::
  ( * test sizes of zint * )
  DupZIsNeg? case IDIV2
  DUP z1milliard ZNLT?			( z1 z2 z2<10^9? )
  NOTcase ZDIVext
					( z1 z2 )
  OVER DupZIsNeg? casedrop IDIV2
  z1milliard ZNLT?
  NOTcase ZDIVext

  ( * sizes are OK, do it step by step * )
					( z1 z2 )
  2DUP ZQUOText				( z1 z2 quot )

  BlankDA12 DO>STR
  DUPLEN$ 4PICK DO>STR DUPLEN$		( A B $Q LENQ $A LENA )
  ROT ZERO
  3LAMBIND				( 1= LINE3; 2=LENQ; 3=LENA )
					( A B $Q $A )
  "|" &$ 3PICK DO>STR &$ DISPROW1

  "          " ONE 3GETLAM SUB$
  "|" &$  "__________" &$ DISPROW2

  DUPLEN$ #1+_ONE_DO (DO)
     DUPONE INDEX@ SUB$
     DUP palparse DROP
     ZINT 10
     ISTOP-INDEX #1- RP# QMul		( A; B; $Q; $QT; QT )
     4PICK QMul 5PICK SWAP QSub		( A; B; $Q; $QT; R )
     DO>STR
     DUPLEN$ 3GETLAM SWAP#-
     "         " ONE ROT SUB$ SWAP&$	( A; B; $Q; $QT; $R )
     "|" &$   
     INDEX@ #1= ITE
       :: DUP1PUTLAM SWAP&$ DISPROW3 ;
       :: 1GETLAM ROT &$ DISPROW3
          INDEX@ #2+ SEVEN #MIN DISPN
       ;
     NoClockWaitForKey 2DROP
  LOOP
  ABND
  DROP					( A B )
  ZDIVext				( q r )
;

LABEL z1milliard
ZINT 1000000000

LABEL NoClockWaitForKey
:: ClrDA1IsStat WaitForKey ;

**********************************************************************
* Desc:		Step by step euclidean division for univar poly
* Stack:	( A B -> Q R )
**********************************************************************
NULLNAME PDIV2ext
::
  BlankDA12
  "Division A=BQ+R"      DISPROW1
  "A: " 3PICK DO>STR &$  DISPROW2
  "B: " OVER DO>STR &$   DISPROW4
  "Press a key to go on" DISPROW7
						( A, B )
  DUP CDRCOMP					( A, B, B' )
  DUPNULL{}? casedrop :: CARCOMP RDIVext Z0 ;
  SWAP CARCOMP					( A, B', bk )
  3PICK LENCOMP 3PICK LENCOMP			( A, B', bk, #a, #b-1 )
  2DUP#> NOTcase2drop :: 2DROP Z0 SWAP ;
  #- NULL{}					( A, B', bk, #a-b+1, Q )
  SWAP
  ZERO_DO (DO)					( A, B', bk, Q )
     4ROLL DUP CDRCOMP SWAP CARCOMP		( B', bk, Q, A', ak )
     4PICK CAS/					( B', bk, Q, A', ak/bk )
     ROTOVER >TCOMP				( B', bk, A', ak/bk, newQ )
     "Q: " OVER DO>STR &$ DISPROW5		( B', bk, A', ak/bk, newQ )
     UNROT					( B', bk, newQ, A', ak/bk )
     5PICK CAS*					( B', bk, newQ, A', ak/bk*B' )
     INNERCOMP
     Z0 ISTOP-INDEX #1- NDUPN top& {}N		( B' bk newQ A' ak/bk*B'&0s )
     CAS-						( B', bk, newQ, newA )
     "R: " OVER DO>STR &$ DISPROW6
     NoClockWaitForKey 2DROP				( B', bk, newQ, newA )
     4UNROLL 					( newA, B', bk, newQ )
  LOOP
						( newA, B', bk, newQ )
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  "Q" >TAG 
ASSEMBLE
	ENDIF	f39
RPL
  4UNROLL 2DROP					( Q, R )

* on enleve les 0 non sgnificatifs de R

* Better check CARCOMP only once, and then if there is a zero
* do INNERCOMP and remove all zeros.

  [BEGIN]
     DUP CARCOMP Z0 EQUAL
  [WHILE]
    CDRCOMP
  [REPEAT]
  DUPNULL{}? casedrop Z0
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  "R" >TAG
ASSEMBLE
	ENDIF	f39
RPL
;
