INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE	Solve and isolate

**********************************************************************
* ISOL1		( symb, idnt -> idnt symb )
*		like built-in xISOL
* ISOLALL	( symb, idnt -> idnt list )
*		internal SOLVE, return the list of solutions
*
* ISOL2ext	( symb, idnt -> symb )
*		( symb, idnt -> {} )
*		like ISOL1 if isolflag is set
*		otherwise returns the list of all found solutions
*
* BEZOUTMSOLV	( { symb },  { idnt } -> { idnt }, { solutions } )
*		multivariate solver
*		The symbolics must be polynomial w.r.t. the idnt
*		Does not work for under or over determined systems
*		or if Bezout reduction fails because of polynomials
*		that are not prime together
*
* ROOT{}N	( meta -> {} )
*		Like {}N but strip tags
*
* MHORNER	( P, { r1, ..., rk }, # -> P[r1, ..., rk] )
*		Evaluation of a multivariate polynomial if #=0
*		If #!=0, P is embedded in # lists
*
* MHORNER1	( P, { r1, ..., rk } -> P[r1, ..., rk] )
*		Evaluation of a multivariate polynomial
**********************************************************************


**********************************************************************
* Desc:		Replacement for built-in ISOL command.
* Stack:	( symb id --> id symb' )
* Note:		pour les noyaux cela en fonctionne que si
*		l'expression est polynom.
**********************************************************************
NULLNAME ISOL1
::
  ISOL2S
  DUPNULL{}? NOT?SEMI
  ISOLERR
;


LABEL ISOL2S
::
  isolflag TestSysFlag case ISOL2ext
  isolflag SetSysFlag 
  ISOL2ext 
  isolflag ClrSysFlag
;

**********************************************************************
* Desc:		Internal SOLVE
* Stack:	( symb id --> id {} )
**********************************************************************
NULLNAME ISOLALL
::
  isolflag TestSysFlag NOTcase ISOL2ext
  isolflag ClrSysFlag
  ISOL2ext
  isolflag SetSysFlag
;

**********************************************************************
* Desc:		Like ISOL1 if isolflag is set.
*		Otherwise returns the list of all found solutions.
* Stack:	( symb id --> symb' )
*		( symb id --> {} )
**********************************************************************
NULLNAME ISOL2ext
::
  SETRAD 

  ( r2...rn prg #n r1 -> r2...rn prg #n r1 | r2...rn r1' prg #n+1 r1 )

  ONE 1LAMBIND		( LAM1 keep a counter for the integer variable ni )
  isol1!
  ABND
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( eq or list of eqs, kernel --> kernel, root or list of roots )
* --------------------------------------------------------------------
LABEL isol1!
::
  IDNTLAM? IT REWRITEFORSOLVE				( eq var )
  SWAP DUPNULL{}? ?SEMI
  { x^ xLNP1 xEXPM xLOG xALOG } 
  { EXPAND^ LNP12LN EXPM2EXP LOG2LN ALOG2EXP } 
  MEVALext
  CKINNERCOMP				( noyau eq1...eqn #n )
  DUP #1-SWAP				( noyau eq1...eqn #n-1 #n )
  ZERO_DO (DO)
    get1 				( noyau eq2...eqn #n-1 eq1 )
    spliteq!				( noyau eq2...eqn #n-1 eq11...eq1m #m )
    get1 #+-1				( noyau meta-eq' )
    LOOP
  #1+ get1 NULL{} ROT			( eq1...eqn noyau res #n )
  ZERO_DO (DO)
    ROT 3PICK				( eq1...eqn-1 noyau res eqn noyau )
    ISOLSEARCH				( eq1...eqn-1 noyau res noyau res )
    SWAPDROP				( eq1, ..., eqn-1, noyau, res, res )
					( * if ISOL then res is not a list * )
    DUPTYPELIST? ITE &COMP >TCOMP
    LOOP				( noyau, res )
  isolflag TestSysFlag NOT?SEMI		( -> noyau, res )
  DUPTYPELIST? NOT?SEMI	
  DUPLENCOMP #2= NOTcase CARCOMP
  TWO NTHCOMPDROP
; 

LABEL ISOLSEARCH
( symb, noyau -> noyau res )
( find noyau s.t. symb is 0 )
::				( symb noyau )
  OVER j#0=case :: SWAPDROP ?ext ;
  SWAPDUP LISTOPext LVARDext	( noyau symb lvar )
  3PICK				( noyau symb lvar noyau )

  ( * place en tete de lvar le noyau * )

  OVER				( noyau symb lvar noyau lvar )

  ( * invert the list to research dependency in ascending order * )

  INNERCOMP reversym {}N	( noyau symb lvar noyau lvar_rev )
  SWAP depend?!			( noyau symb lvar [var true | false] )
  NOTcase2drop NULL{}		( -> noyau {} )
  2DUP EQUALPOSCOMP		( symb lvar var # )
  ROTDUP CARCOMP		( symb var #pos lvar var1 )
  UNROT PUTLIST CDRCOMP		( symb var lvar-var1 )
  2DUPSWAP depend?!		
		( symb var lvar_without_1st_element [ var true | false ] )

  IT :: DROP isolflag TestSysFlag ?SEMI
        TRANSCERROR
        ( 2 var depend of noyau -> transcendental equation error )
        ;
  SWAP>HCOMP			( noyau symb lvar )
  ONE RFACT2ext			( noyau lvar num/deno meta-roots/mults )
  DUP#0=csedrp :: SWAPDROP j#0=case ?ext NULL{} ;
  ZEROSWAP #2/			( * remove multiplicities * )
  ZERO_DO (DO)
    get1 DROP #1+
  LOOP
				( * remove tagged roots * )
				( noyau lvar meta-root num/deno )
  get1 FXNDext DROP 		( noyau lvar meta-root num )
  UNITROOT{}N SWAP		( noyau roots-l lvar )
  DUP CARCOMP UNROT CDRCOMP	( noyau, 1st var, liste racines, lvar' )
  ONE UNROT VAL2ext		( noyau, 1st var, liste racines )
  DUPNULL{}? case SWAPDROP	( noyau, 1st var, liste racines )
  SWAP3PICK EQUALcasedro ASSUMERESTRICT	( -> noyau, liste_racines )
				( noyau, rootlist, 1st var )
  DUPTYPESYMB? NOTcase INTERNALERR	( * should not occur * )
				( noyau rootlist 1st var )
  EXPR> 			( noyau rootlist arg1...argn %n op )
  DUPEQ: rpnXROOT case2drop ISOLXROOT	( -> )
				( noyau rootlist arg1...argn %n op )
  SWAP %1 %= 			( noyau rootlist arg1...argn op ?unary )
  NOTcase NONUNARYERR		( * non unary op. not recognized * )
				( noyau, rootlist, arg, op )
  DUPEQ: xFCNAPPLY 		( noyau, rootlist, arg, op ?userfcn )
  case :: BINT34 ERABLEERROR ;	( * user fcn not recognized * )

  ( * applies inverse of operator to the list of roots * )
        			( noyau rootlist newsymbvar op )
  ISOLACTION ISOLOPER		( noyau rootlist newsymbvar op {} {} )
  ROT ' EQ POSCOMP 		( noyau rootlist newsymbvar {} # )
  DUP#0=csedrp :: BINT35 ERABLEERROR ;	( * operator not recognized * )
  NTHCOMPDROP			( noyau rootlist newsymbvar prg )
  APPLYINVTOROOTLIST
;


LABEL UNITROOT{}N
* meta num -> list_root
::
  ( * first try if the whole poly is composite * )
  PRONDQ? DUP Z1 EQUAL		( meta num z ? )
  case2drop UNITROOT{}NF
  ( * whole poly is composite * )
				( meta num z )
  OBJ>R OBJ>R 			( meta )
  NDROPZERO R>OBJ R>OBJ		( null-meta num z )
  PRONDQ {}N			( meta )
;

LABEL UNITROOT{}NF
* whole poly is not composite, try each factor
::				( meta )
  DUP#0=csedrp NULL{}
  DUP #1-SWAP
  ZERO_DO (DO)			( o1, ..., on, #n-1 )
     get1 DUPTYPETAG?
     ITE tryunitroot SWAP
  LOOP
  #1+ {}N
;

LABEL tryunitroot
* o1...on-1 #n tagged -> meta 
::
  SWAP#1-SWAP STRIPTAGS			( o1..on-1 #n-1 list )
  PRONDQ?				( o1..on-1 #n-1 list z )
  num#1=case 2DROP
  PRONDQ
;

LABEL PRONDQ
* meta list z -> meta
::
					( meta list degree )
  ( * make y=x^k change of var * )
  Z># 2LAMBIND				( meta )
  ZERO 2GETLAM LENCOMP 1GETLAM 		( meta #0 #q*n+1 #n )
  #/ SWAPDROP #1+			( meta #0 # )
  ZERO_DO (DO)
    2GETLAM 1GETLAM INDEX@ #* #1+ 	( meta-root meta list # )
    NTHCOMPDROP SWAP#1+			( meta-root meta )
  LOOP
  {}N					( meta shrinked-list )
  NULL{} ONE RFACT2ext 			( meta meta-root&mult )
  REMOVEMULTIPLICITY {}N UNROT2DROP	( meta list-of-root )
  DUPNULL{}? casedrop ABND		( -> meta )
  					( meta list-of-root )
  DUPLENCOMP SWAP >R			( meta # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP			( meta-root root )
    1GETLAM NthROOT top&		( meta-root )
  LOOP
  ABND					( meta )
;

LABEL PRONDQ?
* obj -> obj z
* returns always 1 in approx mode
::
  EXACT? NOTcase Z1
  NOTLISTcase Z1
  DUPINCOMP pulldrop			( meta list an..a1 #n )
  DUP #>Z 1LAMBIND ONESWAP		( meta list an..a1 count #n )
  ZERO_DO (DO)				( meta list an..a1 count )
    SWAP countlp
  LOOP 					( meta list #1 )
  DROP 1GETABND				( meta list degree )
;

LABEL NthROOT
* root #n -> meta-of-nthroot
::
  OVER TYPETAGGED? case2drop ZERO
  DUPUNROT TWO #/ DROP 			( #n root #rem )
  #0=
  ITE :: TRUE SWAP COMPLEX? ?SEMI POSITIFext ?SEMI 3DROP RDROP ZERO ;
      :: POSITIFext DUPUNROT ?SEMI QNeg ;
				        ( #n >=0? root )
  3PICK #>Z ONE				( #n ? root n #1 )
  ROT SYMBINCOMP addtXROOT 	        ( #n ? n-th-root-meta )
  get1 ?SKIP MetaNeg MYCKSYMBN		( #n n-th-root )
  COMPLEX? NOTcase NthROOTREAL
					( #n n-th-root )
  ( * generate and multiply exp[2*i*k*pi/n] * )
  ONE ROTDUP #>Z 1LAMBIND		( meta-root #n )
  ONE_DO (DO)				( meta )
    OVER SYMBINCOMP 			( meta-root meta )
    metaipi meta2* 			( meta-root meta meta-2*i*pi )
    INDEX@ #>Z 1GETLAM ' x/ THREE	( meta-root meta meta-2*i*pi meta-k/n )
    metamult metasimp addtEXP metamult	( meta-root meta' )
    CKSYMBN UNROT #1+			( meta-root' )
  LOOP
  ABND					( meta-root )
;

LABEL NthROOTREAL
* #n, n-th-root -> meta 
* if #n is odd returns n-th root only else return n-th root and opposite
::				( #n n-th-root ) 
  SWAP TWO #/ DROP		( n-th-root #n_mod_2 )
  #1=case ONE			( -> )
  DUP QNeg SWAP TWO		( -> )
;

LABEL countlp
* count a1 -> count
::
  j#0=case #1+
  #>Z 1GETLAM ZGcd 1PUTLAM ONE
;

LABEL ISOLXROOT
* isol n-th root of expr
::				( noyau rootlist expr n )
  ' x^ 2Ob>Seco			( noyau rootlist expr prg )
  APPLYINVTOROOTLIST
;

LABEL APPLYINVTOROOTLIST
( noyau rootlist newsymbvar prg -> noyau rootlist )
::				( noyau rootlist newsymbvar prg )
  ROT INNERCOMP get1 SWAPDUP
  ZERO_DO (DO)
    get1 3PICK			( r2, ..., rn, prg, #n, r1, prg )
    EVAL UNROT
  LOOP
  SWAPDROP			( noyau, newsymb, meta-liste op^-1[racines] )

  ( * write the new equations we have to solve * )

  get1 SWAPDUP
  ZERO_DO (DO)			( rac1, ..., racn, newsymb, #n )
    get1
    3PICK x-ext UNROT
  LOOP
  SWAPDROP {}N			( noyau, liste newsymb-op^-1[racines] )

  ( * recursive call to ISOL * )

  SWAP isol1!			( noyau, rootlist )
;


**********************************************************************
* Desc:		Split equation to solve in several equations
* Stack:	( eq -> eq1, ..., eqn, #n )
**********************************************************************
LABEL spliteq!
::					( eq )
  DUPTYPESYMB? NOTcase ONE		( -> eq #1 )
  DUP EXPR>				( eq arg1...argn %n op )
  DUPEQ: x= case2drop spliteq=
  DUPEQ: x/ case2drop spliteq/
  DUPEQ: xNEG case2drop spliteqNEG
  EQ: x* NOTcase spliteqnot*
					( eq arg1 arg2 #2 )
  DROP ROTDROP				( arg1 arg2 )
  spliteq!				( arg1 meta-eq2 )
  get1 spliteq!				( meta-eq2 meta-eq1 )
  top&					( meta-eq )
;

LABEL spliteq=
:: 					( eq arg1 arg2 )
  ROTDROP x-ext spliteq!		( -> meta-eq )
;

LABEL spliteq/
::					( eq arg1 arg2 )
  ( * keep only numerator * )
  DROPSWAPDROP				( arg1 )
  spliteq!				( meta-eq )
;

LABEL spliteqNEG
::					( eq arg )
  SWAPDROP spliteq!
;

LABEL spliteqnot*
:: COERCE NDROPONE ;


********************************************
* Testing x dependency
*********************************************
LABEL depend?!
::
  ' depend? 2Ob>Seco Find1stTrue
;

LABEL depend?
( obj, noyau -> true/false )
( test ? obj depend du noyau )
::				
  2DUP EQUAL case2drop TRUE
  SWAP				( noyau, objet symb )
  RLVARext
  SWAPDROPSWAP EQUALPOSCOMP #0<>
;


**********************************************************************
* Desc:		Return idnt (content should be an integer) or %0
*		depending on isolflag mode
* Stack:	( -> idnt )
*		( -> %0 )
**********************************************************************
LABEL varlam1!
::
  isolflag TestSysFlag case Z0
  1GETLAM DUP#1+ 1PUTLAM
ASSEMBLE
	IF	f39
RPL
  UNCOERCE
ASSEMBLE
	ELSE	f39
RPL
  #>Z 
ASSEMBLE
	ENDIF	f39
RPL
  DO>STR CHR_n >H$ $>ID
;

LABEL realvarlam1!
::
  isolflag TestSysFlag case Z0
  1GETLAM DUP#1+ 1PUTLAM
ASSEMBLE
	IF	f39
RPL
  UNCOERCE
ASSEMBLE
	ELSE	f39
RPL
  #>Z 
ASSEMBLE
	ENDIF	f39
RPL
  DO>STR CHR_x >H$ $>ID
  DUP ADDTOREAL
;

LABEL ISOLOPER
{
   xLN xEXP x\v/
   xCOS xACOS xSIN xASIN xTAN xATAN 
   xCOSH xACOSH xSINH xASINH xTANH xATANH
   xCONJ xABS
   xLOG xALOG
}


LABEL ISOLACTION
{
   xEXPext			( xLN )
   ISOLEXP			( xEXP )
   ISOLSQRT			( x\v/ )
   ISOLCOS			( xCOS )
   xCOSext			( xACOS )
   ISOLSIN			( xSIN )
   xSINext			( xASIN )
   ISOLTAN			( xTAN )
   xTANext			( xATAN )
   ISOLCOSH			( xCOSH )
   xCOSHext			( xACOSH )
   ISOLSINH			( xSINH )
   xSINHext			( xASINH )
   ISOLTANH			( xTANH )
   xTANHext			( xATANH )
   SYMRCONJ			( xCONJ )
   ISOLABS			( xABS )
   ALOG2EXP			( xLOG )
   ISOLALOG			( xALOG )
}

LABEL ISOLSQRT
::
  ( * if arg<0 no solution else return the square * )
  DUP ZSIGNE Z-1 EQUALNOTcase xSQext
  ISOLNOSOL
;

LABEL 2picst+
::
  varlam1!
  pifois2 x*ext x+ext
;

LABEL ISOLCOS
:: 
  xACOSext 2picst+
  ( * adds 2 roots to the list * )
  UNROT #1+ 3PICK RNEGext
;

LABEL ISOLSIN
:: 
   xASINext			
   varlam1!
   pifois2 x*ext x+ext
   UNROT #1+ pi 4PICK x-ext
;

LABEL ISOLTAN
:: 
  xATANext			
  varlam1!      
  pi x*ext x+ext
;

LABEL 2ipicst+
::
  COMPLEX? NOT?SEMI
  varlam1! deuxipi x*ext x+ext
;

LABEL ISOLEXP
::
  CKLN 2ipicst+
;

LABEL ISOLALOG
::
  ISOLEXP SYMBINCOMP metaln10 MetaDiv CKSYMBN
;

LABEL ISOLCOSH
:: 
  xACOSHext 2ipicst+
  UNROT #1+ 3PICK RNEGext
;

LABEL ISOLSINH
::
  xASINHext
  COMPLEX? NOT?SEMI
  2ipicst+
  UNROT #1+ ipi 4PICK x-ext
;

LABEL ISOLTANH
::
  xATANHext
  COMPLEX? NOT?SEMI
  varlam1! ipi x*ext x+ext
;

LABEL ISOLABS
::
  ( * if <0 no solution, else 2 sol in real mode and a circle in cmplx mode * )
  DUP ZSIGNE Z-1 EQUALcase ISOLNOSOL
  COMPLEX? case ISOLCABS UNROT #1+ 3PICK RNEGext
;

LABEL ISOLNOSOL
::
  DROP #1- ROT
;

LABEL ISOLCABS
:: SYMBINCOMP 'xi realvarlam1! 'x* THREE addtEXPonly MetaMul CKSYMBN ;

**********************************************************************
* Desc:		MSOLVER polynomial par Bezout,
* Stack:	( Lpoly Lidnt -> Lidnt sols )
* Note:		If no extension in Lpoly, calls ALG48 GSOLVE
*		Otherwise, solves by Bezout "Gaussian" elimination:
*		in this case:
*		- if system seems underdetermined, Lidnt is truncated
*		- then the system must be exactly determined 
*		  and polynomials must be prime together
**********************************************************************
NULLNAME BEZOUTMSOLV
::
					( lpoly lidnt )

  OVER LENCOMP OVER LENCOMP #<case SETDIMERR
  ( * one unknown only -> usual SOLV * )
  DUPLENCOMP 
  DUP#0=csedrp SETSIZEERR
  #1=case BEZOUT1VAR

  LIDNTLVAR				( { poly } lidnt lvar )

* ( * test if syst is not polynomial wrt lidnt, should call numeric solver! * )
  CKPOLYSYST
* lvar should not contain symb depending on lidnt except those of lidnt

  ROTSWAP VXXLext
  EXACT? NOTcase :: BINT36 ERABLEERROR ;

					( lidnt, lvar, lpoly )

 ( * lam1=temporary flag, lam2=Lpoly, lam3=Lvar, lam4=Lidnt * )

  TRUE 4NULLLAM{} BIND

 ( * suppress denominators * )

  2GETLAM			( lpoly )
  ' :: FXNDext DROP DUPTYPELIST? NcaseSIZEERR ;
  1LAMBIND
  LISTSECOext
  ABND				( lpoly' )

  ( * if more unknown than poly to solve, reduce number of unknowns * )

  3GETLAM ONE 3PICK LENCOMP SUBCOMP 4PUTLAM
				( lpoly )

ASSEMBLE
	IF	fALG48FCTR
RPL
  
  CheckPNoExt case ALG48MSOLV	( -> lidnt, Lsols )
	
ASSEMBLE
	ENDIF
RPL
				( lpoly )
	
  ONE				( meta-lpoly )


  4GETLAM LENCOMP

  ( * step 1: Bezout reduction * )

  ONE_DO (DO)				( meta of list of poly-l )
    BEZOUTMSOLVLP
  LOOP
					( meta )
  1GETLAM case METAMSOLV
  ( * can not solve: display intermediate state * )
  BEZOUTDISP
  NDROP 4GETLAM ABND NULL{}		( -> Lidnt, Lsol )
  BINT76 GETERABLEMSG FlashWarning
;

LABEL BEZOUT1VAR
:: 					( {poly} {idnt} )
ASSEMBLE
	IF	f39
RPL
  SWAPDUP
ASSEMBLE
	ELSE	f39
RPL
  SWAP 
ASSEMBLE
	ENDIF	f39
RPL
  FLAGLGCD 				( {idnt} {poly} gcd )
  SWAPDROPSWAP CARCOMP ISOLALL 		( idnt lsols )
  SWAP ONE[]N 
  SWAP' ONE[]N 1LAMBIND LISTSECOext ABND
;

LABEL BEZOUTMSOLVLP
::
      ( * object length sorting * )
					( meta )
      OVER' ISSHORTER? SortList		( meta list )

      INNERCOMP				( meta, p1, ..., pk, #k )
      DUP#1= ITE BEZOUTR1 BEZOUTNR1
					( meta, p1, ..., pk, #k-1 )
      SWAPDROP
      1GETLAM NOTcase :: NDROP ExitAtLOOP ;
      {}N				( meta, list of poly )
      SWAP#1+				( meta' )
;

LABEL ISSHORTER?
::				( o1, o2 -> flag )
  OCRC				( o1, #l2, checksum )
  DROPSWAP OCRC			( #l2, #l1, checksum )
  DROPSWAP #<			( #l1<#l2? )
;

LABEL BEZOUTR1
::
  OVER DUPTYPELIST? caseDROP
					( ..., p1, #1, p1 )
  ROT CARCOMP UNROT
  LENCOMP #1= ?SEMI
  FALSE1PUTLAM
;

LABEL BEZOUTNR1
::					( p1, ..., pk, #k )
  ( * first find a non constant polynomial pk * )
  DUP
  ZERO_DO (DO)				( p1..pk #k )
    BEZOUTNR1LP				( p1..pk #k | p1..pk-1 #k p )
  LOOP
  DUPTYPEBINT? case :: #1- FALSE1PUTLAM ;

  SWAP					( p1..pk-1 p #k )
  #1-DUP				( p1..pk-1 p #k-1 #k-1 )
  ZERO_DO (DO)				( p1, ..., pk-1, p, #l )
    get1 CKCOEFF 3PICK EGCDext 2DROP	( p2, ..., pk-1, p, #l, d )
    DUPTYPELIST? 
    ITE BEZOUTNR1_1 UNROT		( p2, ...., pk-1, d', p, #l )
  LOOP
;

LABEL BEZOUTNR1LP
::
  INDEX@ #2+ ROLL			( p1..pj-1 pj+1..pk #k pj )
  ( * no irrq allowed at this level in the reduction process * )
  CKCOEFF
  CONSTANTPOLY? NOTcase ExitAtLOOP	( -> p1..pk-1 #k p )
  					( p1..pj-1 pj+1..pk #k pj )
  INDEX@ #2+UNROLL			( p1..pk #k )
;

LABEL CONSTANTPOLY?
* Q -> Q flag
* test if Q is constant with respect to the main var
::
  NOTLISTcase TRUE
  DUPLENCOMP #1=
;

LABEL BEZOUTNR1_1
::
  DUP CARCOMP SWAP		( p2, ..., pl, p, #l, d', d )
  DUPLENCOMP #1= casedrop UNROT
  SWAPDROP UNROT
  FALSE1PUTLAM
  ExitAtLOOP
;

LABEL FALSE1PUTLAM
:: FALSE 1PUTLAM ;


LABEL CKCOEFF
* check that obj is not an irrq with non cst value
:: 
  DUPTYPEIRRQ? NOT?SEMI 
  DUP QXNDext UNROT2DROP	( irrq c )
  TYPELIST? case NONPOLYSYST	( -> err )
				( cst_irrq )
;

LABEL BEZOUTDISP
::
  stepflag TestSysFlag NOT?SEMI
	
  ( * unable to solve, let's display state if flag is ON * )

  dup				( meta, meta )
  3GETLAM SWAPDUP
  ZERO_DO			( meta, l1, ..., ln, lvar, #n )
    get1 ONESWAP 4PICK VAL2ext	( meta, l2, ..., ln, lvar, #n, l1' )

    ( * adds 0 to create a matrix * )

    INNERCOMP Z0 INDEX@ NDUPN top& []N 
    UNROTSWAP CDRCOMP
  SWAPLOOP
  SWAPDROP []N				( meta, {} )
  XGROBext SCROLLext			( meta )
;

LABEL METAMSOLV
* step 2, resolution if possible starting from last list of poly
* meta -> list of solutions
* LAM4-1 must be bound
::						( meta )
  #1-SWAP					( meta, lpoly )
  MSOLVROOT					( meta { solutions } )
  OVER						( meta Lsols # )
  DUP#0=csedrp SWAPDROP				( -> Lsols )
  ZERO_DO (DO)					( meta Lsols )
     SWAP#1- UNROT				( meta lpoly Lsols )
     BEZOUTMS1					( meta lpoly lnewsol )
     SWAPDROP					( meta lnewsol )
  LOOP
						( meta lsols )
  OVER#2+UNROLL NDROP				( lsols )
  MSOLVEND					( lidnt, lsols )
;

LABEL MSOLVROOT
* Lpoly -> roots
* look for exact extension roots
::						( Lpoly )
  LPGCDext SWAPDROP				( gcd )
  EXTROOT
;

LABEL EXTROOT
* poly -> roots
* look for exact extension roots
::
  ( * if we have a non cst irrq then error * )
  CKCOEFF
  ( * if answer is undef then it's invalid * )
  ?ext EQUALcasedro NULL{}
  Z0 EQUALcasedro {?ext}
  EVIDENText DROP ROOT{}N			( Lroots )
;

LABEL {?ext}
:: ?ext ONE{}N ;

* poly -list, list of val for still known values -> new list of val
LABEL BEZOUTMS1
::
  DUPNULL{}? ?SEMI		( meta lpoly Lsols )
  INNERCOMP get1		( meta sol1...soln #n lpoly )
  NULL{} ROT			( meta sol1...soln lpoly newlsol #n )
  ZERO_DO (DO)			( sol1...soln lpoly newlsol )
    OVER 4PICK			( sol1...soln lpoly newlsol lpoly soln )
    TWO MHORNER			( sol1...soln lpoly newlsol leval )
    MSOLVROOT			( sol1...soln lpoly newlsol lsoln.0 )
    4ROLL SWAPINCOMP		( sol1...soln-1 lpoly lsols soln meta-soln.0 )
    BEZOUTMS2			( sol1...soln-1 lpoly newlsols )
  LOOP				( meta' lpoly lsols_new )
;

LABEL BEZOUTMS2
::				( lsols soln meta-soln.0 )
  DUP#0= case2DROP		
  get1				( .meta-soln.0 soln )
  DUPTYPELIST? ?SKIP ONE{}POLY	( .meta-soln.0 soln )
  SWAPDUP			( .soln.0.1...soln.0.k  soln #k #k )
  ZERO_DO (DO)			( .soln.0.1...soln.0.k  soln #k )
    get1 3PICK			( .soln.1.1...soln.0.k  soln #k soln.0.1 soln )
    SWAP>HCOMP UNROT		( .soln.1.1...soln.0.k soln.0.1' soln #k  )
  LOOP				( .soln.0.1...soln.0.k  soln #k )
  SWAPDROP {}POLY &COMP		( newlsols )
;

LABEL MSOLVEND
::					( lsols )
  ( * preparation for VAL1 * )
  4GETLAM SWAPDUP NULLCOMP? ?SEMI	( -> lidnt lsols )
  3GETLAM 2PUTLAM 			( lsols )

  DUP >R LENCOMP			( # )
  ZEROSWAP				( meta-sols # )
  ZERO_DO (DO)				( meta-sols )
    RSWAP 'R RSWAP			( meta-sols solk )
    MSOLVENDLOOP			( meta-sols solk )
    SWAP#1+				( meta-sols )
  LOOP					( meta-sols )
  ABND {}N				( lsols )
;

LABEL MSOLVENDLOOP
::					( solk )
    ( * reset depth for VAL1 * )
    ONE 1PUTLAM
    DUP >R LENCOMP ZEROSWAP		( meta-solk # )
    ZERO_DO (DO)
      RSWAP 'R RSWAP			( meta-solk solk.k )
      ( * replace undef by the variable itself * )
      MSOLVREP?BYVAR SWAP#1+		( meta-solk )
      ( * adjust depth for VAL1 * )
      1GETLAM #1+ 1PUTLAM		( meta-solk )
    LOOP				( meta-solk )
    []N
;

LABEL MSOLVREP?BYVAR
::					( internal_obj )
  ?ext OVER EQUALNOTcase VAL1		( -> user_obj )
  DROP 2GETLAM 1GETLAM NTHCOMPDROP	( -> var )
;

**********************************************************************
* Desc:
* Stack:	( meta of roots -> list of roots )
* Note:		drop tagged roots
**********************************************************************
NULLNAME ROOT{}N
::
  DUP#0=csedrp NULL{}
  DUP #1-SWAP
  ZERO_DO (DO)			( o1, ..., on, #n-1 )
     get1 DUPTYPETAG?
     ITE DROP#1- SWAP
  LOOP
  #1+ {}N
;

**********************************************************************
* Desc:
* Stack:	( poly-l, { r1, ..., rk }, # -> P[r1, ..., rk] )
* Note:		top-level call poly-l might be a matrix
**********************************************************************
NULLNAME MHORNER
::
  DUP#0=csedrp MHORNER1
  #1- SWAPROT 
  CK&DISPATCH1
  list MHORNERCOMP
  matrix MHORNERCOMP
  any UNROT2DROP
;

LABEL MHORNERCOMP
::
  DUP OBJ>R				( # {r} list/matrix )
  INNERCOMP get1			( #, p1, ..., pk, #k, { r } )
  rotomo				( p1, ..., pk, #k, { r }, # )
  3PICK ZERO_DO (DO)
     3PICK #3+ ROLL			( p2, ..., pk, #k, { r }, #, p1 )
     3PICK3PICK MHORNER		( p2, ..., pk, #k, { r }, #, p1' )
     4UNROLL
  LOOP
					( p1', ..., pk', #k, { r }, # )
  2DROP 				( meta )
  dup METADENOLCM 			( meta lcm )
  SWAPDUP
  ZERO_DO (DO)				( o1..on lcm #n )
    get1 3PICK RMULText			( o2..on lcm #n o1*lcm )
    ( * note that RMULText here forbid embedded matrices * )
    UNROT
  LOOP
  SWAPDROP 				( meta )
  R>OBJ TYPELIST? case >POLYTRIM []N
;

**********************************************************************
* Desc:
* Stack:	( P, { r } -> P[..r..] )
**********************************************************************
NULLNAME MHORNER1
::
  NOTLISTcase MHORNER0
  OVER TYPELIST? NOTcaseDROP
  INNERCOMP 				( P r1..rn #n )
  DUP#1= casedrop MHORNER0		( -> P[r] )
  #1-{}N				( P r1 { r2 ... rk } )
  ' MHORNER1 2Ob>Seco 1LAMBIND		( P r1 )
  SWAP LISTSECOext ABND			( r1 {} )
  SWAP MHORNER0
;

LABEL MHORNER0
::					( P r )
  ?ext EQUALcasedro NOP			( -> return P if r is undefined )
  HORNER1ext ONE>POLY			( -> P[r] at the right depth )
;
**********************************************************************

