INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Trim

**********************************************************************
* EXPORT:
*
* TRIMext	( obj -> obj )
*		trim object, if object is a list returns always a list
*
* TRIMOBJext	( Q -> Q' )
*		trim object
*
* NEWTRIMext	( Q -> Q )
*		recursively tests if Q is a list of one constant element
*		This is much faster than TRIMOBJext and sufficient for
*		the output of qarth.s programs which are trimmed on the fly
*
* >POLYTRIM	( meta -> {} )
*		equivalent to {}POLY TRIMOBJext
*
* ELMGext	( obj -> obj )
*		replace by 0 all objects that are in norm < EPS
**********************************************************************

**********************************************************************
* Desc:		Remove unnecessary zeros from polynomial
* Stack:	( Q --> Q' )
**********************************************************************
NULLNAME TRIMext
LABEL trimext!
::
  ::
    CK&DISPATCH1
    list  TWO
    seco  ONE
    symb  ONE
    any   ZERO
  ;

 DUP#0=csDROP
 SWAP

* ====================================================================
* Desc:		Trim polynomial
* Stack:	( ob --> ob' )
* ====================================================================
NULLNAME PTrim
NULLNAME TRIMOBJext ( obj -> obj )
CODE
trimobj		C=DAT1	A	( adresse sommet de la pile )
		CD1EX		( mise dans D1 )
		A=DAT1	10	( A= prologue etendu du 1er objet )
		CD1EX
		LC(5)	=DOINT
		?A#C	A
		GOYES	+
		GOVLNG	=Loop
+		LC(5)	=DOLIST
		?A#C	A
		GOYES	notlist

* c'est une liste, est-elle vide?

trimlist	P=	5
		LC(5)	=SEMI
		P=	9
		?A#C	WP
		GOYES	trimlist!11
		P=	0
=droppushhxs0	D=D+1	A
		D1=D1+	5
		LA(5)	=Z0
		PC=(A)
trimlist!11	P=	0
		A=PC
		LC(5)	(trimlist!)-(*)
trimrpl		A=A+C	A
		PC=(A)

notlist		LC(5)	=DOSYMB
		?A#C	A
		GOYES	notsymb
		A=PC
		LC(5)	(trimsymb!)-(*)
		GOTO	trimrpl
notsymb		LC(5)	=DOECMP
		?A#C	A
		GOYES	notecmp
trimecmp	A=PC
		LC(5)	(trimecmp!)-(*)
		GOTO	trimrpl
notecmp		LC(5)	=DOEREL
		?A#C	A
		GOYES	notereal
		A=PC
		LC(5)	(trimereal!)-(*)
		GOTO	trimrpl
notereal	LC(5)	=DOREAL
		?A#C	A
		GOYES	notreal
		A=PC
		LC(5)	(trimreal!)-(*)
		GOTO	trimrpl
notreal		LC(5)	=DOCMP
		?A#C	A
		GOYES	notcmp
		A=PC
		LC(5)	(trimnumcmp!)-(*)
		GOTO	trimrpl
notcmp		LC(N)	10
		CON(5)	=DOCOL
		CON(5)	=x<<
		P=	9
		?A#C	WP
		GOYES	notirrq
		P=	0
trimirrq	A=PC
		LC(5)	(trimirrq!)-(*)
		GOTO	trimrpl
notirrq		P=	5
		LC(5)	=DOINT
		P=	9
		?A#C	WP
		GOYES	trimnot
		P=	0
		A=PC
		LC(5)	(trimcmp!)-(*)
		GOTO	trimrpl
trimnot		P=	0
trimlistloop	GOVLNG	=Loop
ENDCODE

  SWAP#1- #0=?SEMI
  NOTLISTcase ONE{}POLY
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL trimlist!
::	
  INNERCOMP trimmeta!
;


LABEL trimmeta!
::					( o1, ..., on, #n )
  #1- 
  ( on teste si le 1er element est nul -> drop et trimmeta!, sinon SWAP )

  get1 TRIMOBJext			( o2, ..., on, #n-1, o1 )

  ( si #n-1=0, alors on renvoie o1 ou { o1 } selon la nature de o1 )

  CODE
		D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		LC(5)	=ZERO
		?A#C	A
		GOYES	trimlist!12
* #n-1=0: #n-1, o1 -> swapdrop
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		DAT1=A	A
* o1
		GOSBVL	=semiml
		GOVLNG	=onetopoly
* ( o2, ..., on, #n-1, o1 )
trimlist!12	GOSBVL	=a=stkwc0
		?A=C	W
		GOYES	trimlist!13
		LA(5)	=SWAPDUP
		PC=(A)
trimlist!13	GOSBVL	=semiml
		D=D+1	A
		D1=D1+	5	( drop )
trimmeta	A=PC		
		LC(5)	(trimmeta!)-(*)
		GOTO	trimrpl
  ENDCODE

					( o2, ..., on, o1, #n-1, #n-1 )
  ZERO_DO	
       get1 TRIMOBJext 
  SWAPLOOP
  #1+ {}POLY
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL trimsymb!
::
  INNERDUP
  #1-SWAP ZERO_DO 
     get1 TRIMOBJext
  SWAPLOOP
  #1+ SYMBN

* simplification du symbolique resultant

  FXNDext SIMPNDXFext

* fin de simplif du symbolique resultant

;

* --------------------------------------------------------------------
* Desc:		Trim extended complex number.
* Stack:	( ecomplex -> ecomplex / ereal )
* --------------------------------------------------------------------
LABEL trimecmp!
::	
  DUP
  C%%>%% %%0= NOTcaseDROP
  SWAPDROP
;

* --------------------------------------------------------------------
* Desc:		Trim extended real number.
* Stack:
* --------------------------------------------------------------------
LABEL trimereal!
::
   %%0 EQUALcasedro Z0
;

* --------------------------------------------------------------------
* Desc:		Trim real number.
* Stack:
* --------------------------------------------------------------------
LABEL trimreal!
::
  %0 EQUALcasedro Z0
;

* --------------------------------------------------------------------
* Desc:		Trim complex number. (Bernard, what it C%im=0 ?)
* Stack:
* --------------------------------------------------------------------
LABEL trimnumcmp!
::
  C%0 EQUALcasedro Z0
;

* --------------------------------------------------------------------
* Desc:		Trim irreducible quadratic number.
* Stack:	( Zir --> Z' )
* --------------------------------------------------------------------
LABEL trimirrq!
::
  INNERCOMP #5= NOTcase INTERNALERR
  DROP 4ROLLDROP
  THREE ZERO_DO (DO)
      TRIMOBJext UNROT
  LOOP
  NDXQext
;

* --------------------------------------------------------------------
* Desc:		Trim Gaussian integer.
* Stack:
* --------------------------------------------------------------------
LABEL trimcmp!
::
  INNERCOMP #2= NOTcase INTERNALERR
  IRXCext
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME NEWTRIMext
CODE
=newtrim	C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	newtrim+
		A=PC
		LC(5)	(newtrimsymb!)-(*)
		GOTO	newtrimbranch
newtrim+	LC(5)	=DOLIST
		?A=C	A
		GOYES	newtrimlist0
		LC(5)	=DOCOL
		?A=C	A
		GOYES	newtrimseco
		LC(5)	=DOECMP
		?A#C	A
		GOYES	newtrimlist1
		GOLONG	trimecmp
newtrimlist1	GOVLNG	=Loop
newtrimlist0	A=DAT1	A	( test si length=1 )
		AD0EX
		R0=A	A	( R0=sauvegarde de D0 )
		D0=D0+	5	( skip list prolog )
		GOSBVL	=SKIPOB
		C=DAT0	A
		A=R0	A	
		AD0EX		( restaure D0 )
		LA(5)	=SEMI
		?A#C	A
		GOYES	newtrimlist1
		A=PC
		LC(5)	(newtrimlist!)-(*)
newtrimbranch	A=A+C	A
		PC=(A)
newtrimseco	GOLONG	trimobj
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL newtrimsymb!
::
  DUPLENCOMP #1= NOT?SEMI
  CARCOMP
  CK&DISPATCH1
  real  NOP
  zint  NOP
  any   symcomp
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL newtrimlist!	
::
  CARCOMP NEWTRIMext ONE>POLY
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME >POLYTRIM
CODE
newtrimmeta	A=DAT1	A
		AD1EX		( D1=@#n )
		D1=D1+	5
		C=DAT1	A	( C=#n )
		AD1EX
		A=0	A
		?A#C	A
		GOYES	newtrim1
		GOLONG	droppushhxs0	
newtrim1	A=A+1	A
		?A#C	A
		GOYES	newtrim11
		D1=D1+	5
		D=D+1	A
		GOVLNG	=onetopoly
newtrim11	A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A	( A= 5*C )
		C=D1
		C=C+A	A
		CD1EX		( D1= @@stkn, C=@sommet de la pile )
		A=DAT1	A	( A= @@stkn )
		AD1EX		( D1 = @stkn )
		A=DAT1	W	( A= stkn )
		CD1EX		( D1= @ sommet pile )
		LC(5)	=DOEREL
		?A#C	A
		GOYES	newtrim13
newtrim12	A=PC
		LC(5)	(newtrimfloat!)-(*)
		GOTO	newtrimbr
newtrim13	LC(5)	=DOECMP
		?A=C	A
		GOYES	newtrim12
		LCZ0
		P=	10
		?A=C	WP
		GOYES	newtrim2
		P=	0
		LA(5)	={}POLY
		PC=(A)
newtrim2	P=	0
		A=PC
		LC(5)	(newtrim3!)-(*)
newtrimbr	A=A+C	A
		PC=(A)
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL newtrim3!
::					( o1, ..., on, #n!=#0 )
  #1- get1
  CODE
	D1=D1+	5
	D=D+1	A
	GOLONG	newtrimmeta
  ENDCODE
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL newtrimfloat!
::
  {}POLY TRIMOBJext
;

**********************************************************************
* Desc:		Trim small numbers (less than epsilon)
* Stack:	( obj --> obj' )
**********************************************************************
NULLNAME ELMGext
::
  RCLEPS
  ' ELMG
  2LAMBIND
  1GETLAM EVAL ABND
;

LABEL ELMG
::
    CK&DISPATCH1
      ereal  ELMGEREAL
      ecmp   ELMGECMP
      real   ELMGREAL
      TWO    ELMGCMP
      list   LISTSECOext
      symb   LISTSECOext
      arry   ELMGARRY
      ZERO   NOP
;

LABEL ELMGEREAL
:: 
  DUP %%>% %ABS
  2GETLAM %< casedrop %%0
;

LABEL ELMGECMP
:: 
  C%%>%%
  ELMGEREAL SWAP
  ELMGEREAL SWAP
  %%0 EQUALcasedro NOP E%%>C%%
;

LABEL ELMGREAL
:: 
   DUP %ABS
   2GETLAM %< casedrop %0
;

LABEL ELMGCMP
:: 
  C%>%				( re, im )
  SWAPDUP			( im, re, re )
  %ABS 2GETLAM %<		( im , re, re<eps? )
  ITE %0 DUP
  SWAPDROPSWAP			( re ou %0, im )
  DUP %ABS
  2GETLAM %< caseDROP %>C%
;

LABEL ELMGARRY
:: 
  dMATRIXcase LISTSECOext
  DUP xABS 2GETLAM %< NOT?SEMI
  %0 xCON
;

**********************************************************************
