	STITLE CAS2 Library User Words
	
INCLUDE keydefs.h
INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2extdec.h

INCLUDE global.s

* Check in HeaderCAS2 that ADDTOREAL is FlashPtr 7,14
* and QPiZ 7,115
	
**********************************************************************
* Desc:		Add name to the list of real assumed variables
* Stack:
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME ADDTOREAL
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  sym :: CKINEQUALITY DUP ADDTOREAL ;
ASSEMBLE
	ELSE	f39
RPL
  CK1&Dispatch
  sym ADDTOREAL
ASSEMBLE
	ENDIF	f39
RPL
; 

* Room for new commands of Erable
* so that internal ordering of NULLNAME does not change
	
*NULLNAME CASRESERVED0
**********************************************************************
* Desc:		Discrete summation with respect to the current var
* Stack:	( sym --> sym )
**********************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME SIGMAVX
::
  CK1&Dispatch
  sym SUMVX
;

*NULLNAME CASRESERVED1
**********************************************************************
* Desc:		Discrete summation
* Stack:	( sym id --> sym )
* Mupad		sum
**********************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME SIGMA
::
  CK2&Dispatch
  symidnt SUM
  symsymb :: CARCOMP xSIGMA ;
;

*NULLNAME CASRESERVED2
**********************************************************************
* Desc:		Digamma function
* Stack:	( %x --> %Psi(x) )
* Maple:	Psi(x)
**********************************************************************

ASSEMBLE
	CON(3)	0
RPL
xNAME Psi
::
  CK1&Dispatch
  real %PSI
  cmp  C%PSI
  sym  SYMPSI
;

*NULLNAME CASRESERVED3
**********************************************************************
* Desc:		n-th derivative of the digamma function
* Stack:	( sym/% int  --> Psi(sym/%,int) )
* Mupad:	psi(x,n)
**********************************************************************

ASSEMBLE
	CON(3)	0
RPL
xNAME PSI
::
  CK2&Dispatch
  2REAL        %PSIN
  THIRTYTHREE  C%PSIN
  SYMREAL      SYMPSIN
  SYMSYM       SYMPSIN
;

*NULLNAME CASRESERVED4
**********************************************************************
* Desc:		Resultant of two polynomials
* Stack:	( sym1 sym2 --> resultant )
**********************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME RESULTANT
::
  CK2&Dispatch
  SYMSYM FLAGRESULTANT
;

*NULLNAME CASRESERVED5
**********************************************************************
* Desc:		Bernouilli numbers
* Stack:	( Z --> Z' )
**********************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME IBERNOULLI
::
  CK1&Dispatch
  zint IBERNOULLI
  real IBERNOULLI
;

* NULLNAME CASRESERVED6
**********************************************************************
* Desc:		Gamma function
* Stack:	( %x --> %Gamma(x) )
* Maple:	GAMMA(x)
**********************************************************************
ASSEMBLE
	CON(3)	0
RPL
xNAME GAMMA
::
  CK1&Dispatch
  real %GAMMA
  cmp  C%GAMMA
  sym  SYMGAMMA
;

*NULLNAME CASRESERVED7
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME qr
::
  CK1&Dispatch
  matrix FLAGQR
  list :: LIST2MATRIX FLAGQR ;
;

*NULLNAME CASRESERVED8
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME GRAMSCHMIDT
::
ASSEMBLE
	IF	f39
RPL
  CK0 BINT96 ERABLEERROR
ASSEMBLE
	ELSE	f39
RPL
  CK2&Dispatch
  # 48 ( arry seco ) CKGRAMSCHMIDT
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED9
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME SYST2MAT
::
  CK2&Dispatch
  2ARRY SYST2MAT
  2LIST :: 2LIST2MATRIX SYST2MAT MATRIX2LIST ;
;

*NULLNAME CASRESERVED10
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME CHOLESKY
::
  CK1&Dispatch
  arry CHOLESKY
  list :: LIST2MATRIX CHOLESKY ;
;


*NULLNAME CASRESERVED11
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME DIAGMAP
::
  CK2&Dispatch
  # 48 MATOP
  # 4A MATOP
;

*NULLNAME CASRESERVED12
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME ISOM
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  matrix :: QPI CKISOMETRIE ;
  list :: LIST2MATRIX QPI CKISOMETRIE ;
ASSEMBLE
	ELSE	f39
RPL
  CK1&Dispatch
  matrix CKISOMETRIE
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED13
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME MKISOM
::
ASSEMBLE
	IF	f39
RPL
  CK2&Dispatch
  zint MKISOMETRIE
  real :: OBJINT? NcaseSIZEERR SWAP QPI SWAP MKISOMETRIE ;
ASSEMBLE
	ELSE	f39
RPL
  CK2&Dispatch
  zint MKISOMETRIE
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED14
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME KER
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  arry :: QPI KER ;
  list :: LIST2MATRIX QPI KER ;
ASSEMBLE
	ELSE	f39
RPL
  CK1&Dispatch
  arry KER
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED15
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME IMAGE
::
  CK1&Dispatch
  arry IMAGE
  list :: LIST2MATRIX IMAGE ;
;

*NULLNAME CASRESERVED16
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME BASIS
::
  CK1&Dispatch
  list BASISpatch
  arry BASISpatch
;

*NULLNAME CASRESERVED17
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME IBASIS
::
  CK2&Dispatch
  2LIST IBASIS
;

*NULLNAME CASRESERVED18
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME AUGMENT
::
  CK2&Dispatch
  2LIST &COMP
  EIGHTY >TCOMP
  SIXTYFOUR  AUGMENT	( matrix+any )
  FORTYEIGHT :: 'EvalNoCK: x+ ;	( str+any )
;

*NULLNAME CASRESERVED19
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME PMINI
::
  CK1&Dispatch
  matrix PMINI
;

*NULLNAME CASRESERVED20
ASSEMBLE
	CON(3)	000
RPL
xNAME CYCLOTOMIC
::
  CK1&Dispatch
  zint CYCLOTOMICsafe
  real CYCLOTOMICsafe
;

*NULLNAME CASRESERVED21
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME STURM
::
  CK1&Dispatch
  symb FLAGSTURM
;

*NULLNAME CASRESERVED22
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME STURMAB
::
ASSEMBLE
	IF	f39
RPL
  CK3&Dispatch
  # AAA :: STURMAB SWAPDROP ;
  # A11 :: 2QPI STURMAB SWAPDROP ;
ASSEMBLE
	ELSE	f39
RPL
  CK3&Dispatch
  # AAA STURMAB
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED23
ASSEMBLE
        CON(1)  0*(hasFORM)+0*(hasINTG)+0*(hasWHERE)+0*(hasVUNS)
        CON(1)  0*(hasDER)+0*(hasINV)+0*(hasCOLCT)+0*(hasEXPND)
        CON(1)  0*(hasHELP)+0*(hasPDATA)
RPL
xNAME FDISTRIB
::
  CK1&Dispatch
  sym FDISTRIB
;

**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

*ASSEMBLE
*        CON(5)  =DOHSTR
*        REL(5)  +
*        CON(1)  0
*        CON(1)  pdOP		Operator
*        CON(1)  pdLP		Open parenthesis
*        CON(1)	pdQE		Quoted Expression
*        CON(1)  pdRP		Close parenthesis
*        CON(1)  0
*+
*RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)


*NULLNAME CASRESERVED24
ASSEMBLE
        CON(1)  0*(hasFORM)+0*(hasINTG)+0*(hasWHERE)+0*(hasVUNS)
        CON(1)  0*(hasDER)+0*(hasINV)+0*(hasCOLCT)+0*(hasEXPND)
        CON(1)  0*(hasHELP)+0*(hasPDATA)
RPL
xNAME DISTRIB
::
  CK1&Dispatch
  sym DISTRIB
;

**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

*ASSEMBLE
*        CON(5)  =DOHSTR
*        REL(5)  +
*        CON(1)  0
*        CON(1)  pdOP		Operator
*        CON(1)  pdLP		Open parenthesis
*        CON(1)	pdQE		Quoted Expression
*        CON(1)  pdRP		Close parenthesis
*        CON(1)  0
*+
*RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)

*NULLNAME CASRESERVED25
( rewrite exp to power )
ASSEMBLE
        CON(3)        000
RPL
xNAME EXP2POW
::
  CK1&Dispatch
  sym EXP2POW
;

*NULLNAME CASRESERVED26
ASSEMBLE
        CON(3)        000
RPL
xNAME POWEXPAND
::
  CK1&Dispatch
  sym POWEXPAND
;

*NULLNAME CASRESERVED27
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME TAN2CS2
::
  CK1&Dispatch
  sym FLAGTAN2CS2
  matrix FLAGTAN2CS2
  real NOP
  cmp NOP
;

*NULLNAME CASRESERVED28
**********************************************************************
* Name:		xCIRC
* Desc:
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME CIRC
::
  CK2&Dispatch
  2LIST :: SWAP QPI CKPERMext SWAP QPI CKPERMext CIRCext ;
;

*NULLNAME CASRESERVED29
**********************************************************************
* Name:		xC2P
* Desc:
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME C2P
::
  CK1&Dispatch
  list C2Pext
;

*NULLNAME CASRESERVED30
**********************************************************************
* Name:		xP2C
* Desc:		( permutation -> decomposition en cycles, signature )
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME P2C
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  list 
  :: 
    QPI CKPERMext P2Cext ROTDROP DROP
  ;
ASSEMBLE
	ELSE	f39
RPL
  CK1&Dispatch
  list 
  :: 
    CKPERMext P2Cext ROTDROP 
  ;
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED31
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME MSLV
::
  CK3&Dispatch
ASSEMBLE
	IF	f39
RPL
  # 444 :: MSLV UNROT2DROP ;
  # 555 :: ROT LIST2MATRIX UNROT 2LIST2MATRIX MSLV MATRIX2LIST UNROT2DROP ;
ASSEMBLE
	ELSE	f39
RPL
  # 444 MSLV
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED32
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME DOMAIN
::
ASSEMBLE
	IF	f39
RPL
  CK0 BINT96 ERABLEERROR
ASSEMBLE
	ELSE	f39
RPL
  CK1&Dispatch
  sym DOMAIN
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED33
ASSEMBLE
	CON(3)	000
RPL
xNAME SIMPLIFY
::
  CK1&Dispatch
  sym FLAGSIMPLIFY
  real NOP
  cmp NOP
  matrix FLAGSIMPLIFY
;

*NULLNAME CASRESERVED34
ASSEMBLE
	CON(3)	000
RPL
xNAME DROITE
::
  CK2&Dispatch
  symsym DROITE
  cmpcmp DROITE
;

*NULLNAME CASRESERVED35
ASSEMBLE
        CON(1)  0*(hasFORM)+0*(hasINTG)+0*(hasWHERE)+0*(hasVUNS)
        CON(1)  0*(hasDER)+0*(hasINV)+0*(hasCOLCT)+0*(hasEXPND)
        CON(1)  0*(hasHELP)+1*(hasPDATA)
RPL
xNAME STORE
::
  CK2&Dispatch
  idnt STORE
  symb :: CARCOMP 'EvalNoCK: ROMPTR xSTORE ;
;
        

**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  +
        CON(1)  0
        CON(1)  pdOP		Operator
        CON(1)  pdLP		Open parenthesis
        CON(1)  pdEX		General Expression
        CON(1)	pdCM		Comma
        CON(1)	pdQN		Quoted Name
        CON(1)  pdRP		Close parenthesis
        CON(1)  0
+
RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)

        
        

*NULLNAME CASRESERVED36
ASSEMBLE
ASSEMBLE
        CON(1)  0*(hasFORM)+0*(hasINTG)+0*(hasWHERE)+0*(hasVUNS)
        CON(1)  0*(hasDER)+0*(hasINV)+0*(hasCOLCT)+0*(hasEXPND)
        CON(1)  0*(hasHELP)+1*(hasPDATA)
RPL
xNAME DEF
::
  CK1&Dispatch 
  symb 
  :: 
ASSEMBLE
	IF	f39
RPL
  InCASApplication? NOT?SEMI 
ASSEMBLE
	ENDIF	f39
RPL
  DUP DODEFINE 
  ;
;

**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  +
        CON(1)  0
        CON(1)  pdOP		Operator
        CON(1)  pdLP		Open parenthesis
        CON(1)	pdQE		Quoted Expression
        CON(1)  pdRP		Close parenthesis
        CON(1)  0
+
RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)

*NULLNAME CASRESERVED37
ASSEMBLE
         CON(3)  000
RPL
xNAME ASSUME
::
  CK1&Dispatch
  idnt :: 	' ID ALLREAL OVER EQUAL		( id ? )
  		NOTcase :: DUP ADDTOREAL ;
  		allrealflag SetSysFlag
		;
  sym  :: CKINEQUALITY DUP ADDTOREAL ;
; 


*NULLNAME CASRESERVED38
ASSEMBLE
         CON(3)  000
RPL
xNAME UNASSUME
::
  CK1&Dispatch
  idnt :: ' ID ALLREAL OVER EQUAL 		( id ? )
          case :: allrealflag ClrSysFlag ;
          ISIDREAL? NOT?SEMI REMOVEFROMASSUME DROP 
          ;
  symb :: CARCOMP xUNASSUME ;
; 

*NULLNAME CASRESERVED39
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME REWRITE
::
  CK0
  REWRITEMENU MENUCHOOSE
;

*NULLNAME CASRESERVED40
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME INTEGER
::
  CK0
  INTEGERMENU MENUCHOOSE
;

*NULLNAME CASRESERVED41
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME CONSTANTS
::
  CK0
  CONSTANTSMENU MENUCHOOSE
;

*NULLNAME CASRESERVED42
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME HYPERBOLIC
::
  CK0
  HYPERBOLICMENU MENUCHOOSE
;

*NULLNAME CASRESERVED43
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME MODULAR
::
  CK0
  MODULARMENU MENUCHOOSE
;

*NULLNAME CASRESERVED44
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME POLYNOMIAL
::
  CK0
  POLYNOMIALMENU MENUCHOOSE
;

*NULLNAME CASRESERVED45
ASSEMBLE
*	IF	f39
*	CON(3) 	000
*	ELSE	f39
	CON(1)	8
*	ENDIF	f39
RPL
xNAME TESTS
::
  CK0
  TESTSMENU MENUCHOOSE
;

*NULLNAME CASRESERVED46
ASSEMBLE
	CON(1)	8
RPL
xNAME MATHS
::
  CK0
  chooseflag SysITE FALSE MENUCHOOSE?
ASSEMBLE
	IF 	f39
RPL
  casedrop :: MATHSMENU "Maths menu" TOTEMPOB OVER CHOOSE>$ 
              %2 Ck&DoChoose %0= casedrop CASNULL::
              COERCE 
              DUP#1= case2drop FLASHPTR xCASCFG
              #1- NTHCOMPDROP EVAL
              ;
ASSEMBLE
	ELSE	f39
RPL
  case :: "Maths menu" TOTEMPOB MATHSMENU %1 4ROLL EVAL %0= ?SEMI EVAL ;
ASSEMBLE
	ENDIF	f39
RPL
  MATHSMENU InitMenu
;

*NULLNAME CASRESERVED47
ASSEMBLE
	CON(3)	0
RPL
xNAME COLLECT
::
  CK1&Dispatch
  sym FLAGSYMCOLCT
;

*NULLNAME CASRESERVED48
ASSEMBLE
        CON(1)  0*(hasFORM)+0*(hasINTG)+0*(hasWHERE)+0*(hasVUNS)
        CON(1)  0*(hasDER)+0*(hasINV)+0*(hasCOLCT)+0*(hasEXPND)
        CON(1)  0*(hasHELP)+1*(hasPDATA)
RPL
xNAME UNASSIGN
::
  CK1&Dispatch
  idnt 
  ::
ASSEMBLE
	IF	f39
RPL
	InCASApplication? NOT?SEMI
ASSEMBLE
	ENDIF	f39
RPL
	DUP@ NOT?SEMI ( idnt value ) SWAP PURGE 
  ;
  symb :: CARCOMP 'EvalNoCK: ROMPTR xUNASSIGN ;
;


**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  +
        CON(1)  0
        CON(1)  pdOP		Operator
        CON(1)  pdLP		Open parenthesis
        CON(1)	pdQN		Quoted Name
        CON(1)  pdRP		Close parenthesis
        CON(1)  0
+
RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)


*ASSEMBLE
*	IF	f39
*RPL
*NULLNAME xHELP ( CASRESERVED49 )
*ASSEMBLE
*	ELSE	f39
*RPL
ASSEMBLE
	CON(1)	8
RPL
xNAME HELP
::
  CK0
  CASHELPMAIN 
;
*ASSEMBLE
*	ENDIF	f39
*RPL

*NULLNAME CASRESERVED50
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME CASCMD
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  any :: CKSYMB40 case %1 %0 ;
*  CK0 BINT96 ERABLEERROR
ASSEMBLE
	ELSE	f39
RPL
  CK0
  HELPSTR
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED51
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME PUSH
::
ASSEMBLE
	IF	f39
RPL
  CK1&Dispatch
  any :: InCASApplication? NOTcase PUSHVSTACK ;
ASSEMBLE
	ELSE	f39
RPL
  ( * save current environment * )
  CK0 SAVECURENV
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED52
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME POP
::
ASSEMBLE
	IF	f39
RPL
  CK0 InCASApplication? case %0 POPVSTACK REPLACEZBYR
ASSEMBLE
	ELSE	f39
RPL
  ( * restore current environment * )
  CK0 RESTORECURENV
ASSEMBLE
	ENDIF	f39
RPL
;

*NULLNAME CASRESERVED53
ASSEMBLE
	CON(3) 	000
RPL
xNAME DEGREE
::
  CK1&Dispatch
  sym DEGREE
  real DEGREE
  cmp DEGREE
;

*NULLNAME CASRESERVED54
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME DEDICACE
::
  CK0
  "A tous les HP-Users!" TOTEMPOB
;

*NULLNAME CASRESERVED55
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME POTENTIAL
::
  CK2&Dispatch
  2matrix FLAGPOTENTIAL
;

*NULLNAME CASRESERVED56
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME VPOTENTIAL
::
  CK2&Dispatch
  2matrix FLAGVPOTENTIAL
;

*NULLNAME CASRESERVED57
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME GBASIS
::
  CK1&Dispatch
  matrix FLAGGROEBNER
;

*NULLNAME CASRESERVED58
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME GREDUCE
::
  CK3&Dispatch
  #A44 FLAGGBREDUCE
;

**miscdoc+*********************************************************************
** algebraic function property list elements
**+miscdoc*********************************************************************

** help data (if present)   ( Textbook data )


* parse data (if present)

ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  +
        CON(1)  0
        CON(1)  pdOP		Operator
        CON(1)  pdLP		Open parenthesis
        CON(1)	pdQN		Quoted Name
        CON(1)  pdRP		Close parenthesis
        CON(1)  0
+
RPL
        
* derivative (if present)

     
* inverse (if present)

        
* COLCT data (if present)

        
* EXPND data (if present)

        
* FORM menu (if present)

        
* Integral Data (if present)

        
* WHERE Building Data (if present)

        
* very-unsyminner Data (if present)

*NULLNAME CASRESERVED59
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME LOCAL
::
  CK1&Dispatch
  lam  USERBIND 
  sym   USERBIND 
  list  USERBIND 
;

*NULLNAME CASRESERVED60
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME UNBIND
::
  CK0 USERUNBIND
;
	
*NULLNAME CASRESERVED61
ASSEMBLE
	CON(3) 	000
RPL
xNAME EXP2HYP
::
  CK1&Dispatch
  sym EXP2HYP
;

*NULLNAME CASRESERVED62
**********************************************************************
* Desc: Recall the CAS reserved variable VX
* Stack: None -> VX
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME RCLVX
::
  CK0
  RCLVX
;

*NULLNAME CASRESERVED63
**********************************************************************
* Desc: Save an object into CAS reserved variable VX
* Stack: Global Name -> None
**********************************************************************
ASSEMBLE
	IF	f39
	CON(3) 	000
	ELSE	f39
	CON(1)	8
	ENDIF	f39
RPL
xNAME STOVX
::
  CK1&Dispatch
  id STOVX
;



NULLNAME CASRESERVED64

NULLNAME CASRESERVED65

NULLNAME CASRESERVED66

NULLNAME CASRESERVED67

NULLNAME CASRESERVED68

NULLNAME CASRESERVED69

NULLNAME CASRESERVED70

NULLNAME CASRESERVED71

NULLNAME CASRESERVED72

NULLNAME CASRESERVED73

NULLNAME CASRESERVED74

NULLNAME CASRESERVED75

NULLNAME CASRESERVED76

NULLNAME CASRESERVED77

NULLNAME CASRESERVED78

NULLNAME CASRESERVED79

NULLNAME CASRESERVED80

NULLNAME CASRESERVED81

NULLNAME CASRESERVED82

NULLNAME CASRESERVED83

NULLNAME CASRESERVED84

NULLNAME CASRESERVED85

NULLNAME CASRESERVED86

NULLNAME CASRESERVED87

NULLNAME CASRESERVED88

NULLNAME CASRESERVED89

NULLNAME CASRESERVED90

NULLNAME CASRESERVED91

NULLNAME CASRESERVED92

NULLNAME CASRESERVED93

NULLNAME CASRESERVED94

NULLNAME CASRESERVED95

NULLNAME CASRESERVED96

NULLNAME CASRESERVED97

NULLNAME CASRESERVED98

NULLNAME CASRESERVED99

