INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

**********************************************************************
* EXPORT:
*
* LAPext	( symb -> symb )
*		Laplace transform for Polynomials*exp/sin/cos	
*		Returns LAP() otherwise
*		To improve: Recognize delta functions
*
* ILAPext	( symb -> symb )
*		Inverse Laplace transform for rational fractions
*		Delta functions for the integral part
*		To improve: recognizing LAP()
**********************************************************************

**********************************************************************
* Desc:		Laplace transform for polynomial*exp/sin/cos.
*		Returns LAP() for unknown transforms.
* Stack:	( symb --> symb' )
* Note:		To improve: Recognize delta functions
**********************************************************************
NULLNAME LAPext
::
  COMPLEX? Z0 RCLVX ZEROZERO 'NOP

DEFINE cmplxflag 6GETLAM
DEFINE intlap 5GETLAM
DEFINE varvx 4GETLAM
DEFINE argtrig 3GETLAM
DEFINE varnx 2GETLAM
DEFINE typetrig 1GETLAM
DEFINE cmplxflag! 6PUTLAM
DEFINE intlap! 5PUTLAM
DEFINE varvx! 4PUTLAM
DEFINE argtrig! 3PUTLAM
DEFINE varnx! 2PUTLAM
DEFINE typetrig! 1PUTLAM

  ' NULLLAM SIX NDUPN DOBIND		( symb )
  ( * quick test for Heaviside and Dirac delta functions * )
  ' xFCNAPPLY OVER ListPos		( symb # )
  #0= ITE LAP LAPHEAV
  cmplxflag ?SKIP CLRCOMPLEX
  ABND
;

LABEL LAPHEAV
::					( symb )
  ( * find 1st Heaviside functions? * )
  LVARXNXext				( symb x lvarnx lvarx )
  UNROT2DROP ' Heaviside? Find1stTrue	( symb varx true | symb false )
  NOTcase LAPDELTA
					( symb heaviside )
  arglinear? NOTcase :: 3DROP LAPDELTA ;
  					( symb h arg a )
  ANNULEARG				( symb h b/a )
  UNROT 2DUP				( b/a symb h symb h )
  Z1 MEVALext				( b/a symb h alpha+beta )
  UNROT Z0 MEVALext			( b/a alpha+beta beta )
  DUPUNROT x-ext			( b/a beta alpha )
  varvx DUP 5PICK x-ext REPLACE2BY1	( b/a beta alpha|X=X-b/a )
  LAPHEAV ROT 				( beta LAP[alpha|X=X-b/a] b/a )
  varvx x*ext xEXPext x*ext		( beta LAP[alpha|X=X-b/a]*EXP[b/a*X] )
  SWAP LAPHEAV x+ext			( lap )
;

LABEL arglinear?
* test that the fcn arg is linear and returns a
* fcn -> arg-fcn a cst?
::
  DUPINCOMP 4UNROLL3DROP #3- CKSYMBN	( fcn arg-fcn )
  DUP varvx DIRECTDERIV			( fcn arg-fcn a )
  DUP varvx DIRECTDERIV
  j#0=case7 TRUE
  FALSE					( fcn arg-fcn a cst? )
;

LABEL ANNULEARG
::					( arg a )
  SWAP varvx Z0 REPLACE2BY1		( a b )
  SWAP x/ext				( b/a )
;

LABEL Heaviside?
* ob -> ?
::
  DUPTYPESYMB? NOTcase DROPFALSE
  DUP LASTCOMP EQ: xFCNAPPLY NOTcase DROPFALSE
  DUPLENCOMP #2- NTHCOMPDROP		( fcn-name )
  DUPTYPESYMB? NOTcase DROPFALSE
  CARCOMP ' ID Heaviside EQUAL		( ? )
;

LABEL LAPDELTA
::					( symb )
  LVARXNXext UNROT2DROP			( symb lvarx )
  ' Delta? Find1stTrue			( symb varx true | symb false )
  NOTcase LAP				( -> )
  					( symb varx )
  arglinear? NOTcase :: 3DROP LAP ;
					( symb delta arg-delta a )
  ANNULEARG				( symb delta b/a )
  UNROT 'ID210 MEVALext			( b/a symb )
  'ID210 linear?			( b/a symb alpha ? )
  NOTcasedrop :: SWAPDROP LAP ;
					( b/a symb alpha )
  SWAP 'ID210 Z0 REPLACE2BY1		( b/a alpha beta )
  5GETLAM Z0 5PUTLAM			( b/a alpha beta #_deriv )
  varvx SWAP x^ext			( b/a alpha beta X^ )
  ROT varvx 				( b/a beta X^ alpha vx )
  5PICK QNeg REPLACE2BY1 x*ext		( b/a beta X^*alpha|X=-b/a )
  ROT varvx x*ext xEXPext x*ext		( beta X^*alpha*exp )
  SWAP LAPDELTA x+ext
;

LABEL Delta?
* ob -> ?
* put number of derivatives in lam5
::
  DUPTYPESYMB? NOTcase DROPFALSE
  DUP LASTCOMP EQ: xFCNAPPLY NOTcase DROPFALSE
  DUPLENCOMP #2- NTHCOMPDROP		( fcn-name )
  DUPTYPESYMB? NOTcase DROPFALSE
  CARCOMP DUPTYPEIDNT? NOTcase DROPFALSE
  ID>$ DUP 				( $-name )
  DUPLEN$ DUP #5- SWAP 			( $ $ #-5 # )
  SUB$ "Delta" EQUAL			( $ ? )
  NOTcase DROPFALSE			( -> )
					( $ )
  ( * check number of d1 * )
  DUPLEN$ FIVE #- #2/			( $ #$ )
  DUP #>Z 5PUTLAM DUP#0=csedrp DROPTRUE	( ok )
					( $ #$ )
  TRUE SWAP
  ZERO_DO (DO)				( $ ? )
    DROPDUP INDEX@ #2* #1+ DUP#1+ SUB$	( $ $$ )
    "d1" EQUAL 				( $ ? )
    DUP ?SKIP ExitAtLOOP
  LOOP
  SWAPDROP				( -> ? )
;

LABEL linear?
::					( symb var )
  2DUP DIRECTDERIV SIMPLIFY		( symb var symb' )
  DUPROT DIRECTDERIV			( symb symb' symb" )
  j#0=case7 TRUE			( -> symb a true )
  FALSE					( -> symb a false )
;

LABEL LAP
::					( symb )	
* argtrig=argument de SIN/COS ou 0, 
* typetrig=NOP si trigk=1, SYMRE si COS et SYMSIN si SIN
  Z0 intlap!
  cmplxflag IT EXPLNext
  LINEXPA				( ?cmplex, meta trig-tcoef )
  SETCOMPLEX
  #2/ Z0 SWAP
  ZERO_DO (DO)			( ?complex trig1 tcoef1...trign tcoefn alg )
     UNROTSWAP			( ?complex trig1 tcoef1... alg tcoefn trign )
     LAPLP1			( trig1 tcoef1... alg tcoefn typetrig argtrig )
     argtrig! typetrig!		( trig1 tcoef1... alg tcoefn )
     LINEXPext #2/ 		( trig1 tcoef1... oldalg arg1 coef1 .. #n )
     Z0 SWAP
     ZERO_DO (DO)		( ..oldalg arg1 coef1.. argn coefn alg )
        UNROTSWAP		( ..oldalg arg1 coef1.. alg coefn argn )
        argtrig x+ext		( ..oldalg arg1 coef1.. alg coefn argexp )

	( * first check linearity of argexp with respect to vx * )
        DUP varvx DIRECTDERIV
        DUP varvx DIRECTDERIV	( ..oldalg arg1.. alg coefn argexp a a' )

        ( * check for rational fraction wrt vx * )
	LAPLP2			( ..oldalg arg1.. alg coefn argexp a ?ok )

        ( * if it's a poly, add to alg, if not add to intlap * )
	LAPLP3			( ..oldalg arg1.. alg )
     LOOP			( .. oldalg alg )
     x+ext
   LOOP				( alg' )
  ADDINTLAPPART			( alg" )
;

LABEL LAPLP1
* checks trigonometric type
( trig-symb -> typetrig argtrig )
::					( trig-symb )
  num#1=case7 :: DROP 'NOP Z0 ;		( -> NOP 0 )
  INNERCOMP addt*			( s1, ..., sin|cos, x*, # )
  'xi 4UNROLLROT			( s1, ..., i, x*, #, SIN|COS )
  EQ: xCOS ITE 'RE 'IM			( s1, ..., i, x*, #, IM|RE )
  OVER#2+UNROL SYMBN			( IM|RE argtrig )
;

LABEL 'IM
:: ' xIMext ;

LABEL 'RE
:: ' xREext ;

LABEL LAPLP2
* checks that coefn is a rational fract/vx
::					( coefn argexp a a' )
  j#0=case7 LAPLP2OK
  FALSE
;

LABEL LAPLP2OK
::  					( coefn argexp a )

  ( argexp est lineaire, on teste si coefn est une fraction rat/vx )

  3PICK LVARXNXext
  4ROLLDROP				( coefn argexp a x varnx varx )
  UNROT varnx!				( coefn argexp a varx x )
  OVER NULLCOMP?			( coefn argexp a varx x ?varx={} )
  case2drop TRUE			( -> coefn argexp a TRUE )
  ONE{}N EQUAL				( coefn argexp a flag )
;

LABEL LAPLP3
::					( alg coefn argexp a ?ok )
  NOTcasedrop LAPLPNOT

					( alg cofn argexp a )
  varvx OVER x-ext 			( alg cofn argexp a x-a )
  3PICK ROT varvx CASSYM* CASSYM- 	( alg cofn argexp x-a b=argexp-a*x )
  LVARext VXXLext       		( alg cofn argexp x-a varb b )
  DUP RREext				( alg cofn argexp x-a varb b re[b] )
  ZEROSWAP 4PICK VAL2ext xEXPext      ( alg cofn argexp x-a varb b exp[re[b]] )
  SWAP RIMext
  ZEROSWAP 4ROLL VAL2ext	      ( alg cofn argexp x-a exp[re[b]] im[b] )
  DUP xCOSext SWAP xSINext
  metai SYMBN x*ext
  x+ext x*ext				( alg cofn argexp x-a exp[b] )
  SWAP4PICK				( alg cofn argexp exp[b] x-a cofn )
  varnx varvx >HCOMP VXXLext	      ( alg cofn argexp exp[b] x-a var coef-l )
  FXNDext ZEROSWAP 4ROLL VAL2ext      ( alg cofn argexp exp[b] x-a num-l deno )

  ( * check now that deno does not depend on vx * )
  varvx Contains? SWAPDROP	    ( alg cofn argexp exp[b] x-a num-l deno ? )
  case2drop :: 2DROP LAPLPNOT ;
  
  UNROT				    ( alg cofn argexp exp[b] deno x-a num-l )
  DUPTYPELIST? ?SKIP ONE{}POLY
  ONESWAP varnx VAL2ext
  INNERCOMP get1		( ...exp[b] deno an..a0 #n x-a )
  Z0 ROT
  ZERO_DO (DO)			( ...exp[b] deno an..a0 x-a newalg )
    OVERINDEX@ #1+
    UNCOERCE x^ext		( ...exp[b] deno an..a0 x-a newalg x-a^k+1 )
    4ROLL INDEX@ #>Z
    factzint x*ext
    SWAP x/ext		( ...exp[b] deno an..a1 x-a newalg a0/[x-a^k+1]/k! )
    x+ext
  LOOP
				( ...alg cofn argexp exp[b] deno x-a newalg )
  SWAPDROPSWAP NDXFext		( ...alg cofn argexp exp[b] newalg/deno )
  x*ext UNROT2DROP		( ...alg exp[b]*newalg/deno )
  typetrig cmplxflag ITE EVAL :: REALEVAL7 EVAL ;		
				( ...alg RE|IM|NOP[exp[b]*newalg/deno] )
  x+ext				( ...alg )
;

LABEL LAPLPNOT
::				( ... alg coefn argexp )
  xEXPext x*ext 
  typetrig EVAL 
  intlap x+ext intlap!
;

LABEL ADDINTLAPPART
::					( alg )
  intlap num#0=case7 DROP		( -> alg )
					( alg intlap )
  varvx 'IDt DUP4UNROLL MEVALext	( alg t intlap )
  OVER varvx x*ext			( alg t intlap t*x )
  RNEGext xEXPext x*ext			( alg t intlap*exp[-xt] )
  Z0 INFINIext
  ROT 4ROLL symcomp
  ' x\.S_ALGEBRAIC FIVE get1		( meta-int symb )
  SYMBINCOMP metaadd SYMBN		( -> alg' )
;


**********************************************************************
* Desc:		Inverse Laplace transform for rational fractions.
*		Delta functions for the integral part.
* Stack:	( symb --> symb' )
* Note:		To improve: Recognizing LAP()
**********************************************************************
NULLNAME ILAPext
::					( obj )
  ( * first linearize exp * )
  LINEXPext				( meta-argexp/coeff )
  RCLVX 1LAMBIND
  #2/ Z0 SWAP ZERO_DO (DO)		( ... argexp coefarg res )
    UNROT ILAPLP x+ext
  LOOP
  ABND
;

LABEL ILAPLP
::
  SWAP					( coefarg argexp )
  ( * is exp linear? * )
  DUP 1GETLAM DIRECTDERIV SIMPLIFY		( coefarg argexp a )
  DUP 1GETLAM DIRECTDERIV 			( coefarg argexp a a' )
  j#0=case7 ILAPLPOK
  DROP xEXPext x*ext ILAPNRAT 
;

LABEL ILAPLPOK
::					( coefarg argexp a )
  DUP 1GETLAM x*ext			( coefarg argexp a a*x )
  ROTSWAP x-ext SIMPLIFY		( coefarg a b )
  xEXPext ROT				( a exp[b] coefarg )
  ' ILAPNRAT ' ILAPRAText LINEARAPPLY	( a exp[b] symb )
  1GETLAM DUP 5PICK x+ext
  2DUP EQUAL ITE 2DROP REPLACE2BY1	( a exp[b] symb' )
  x*ext 1GETLAM ROT 			( exp[b]*symb' x a )
  num#0=case7 2DROP			( -> exp[b]*symb' )
  x+ext SYMBINCOMP			( ilap meta-x+a )
  ID Heaviside ONE SYMBN 		( ilap meta-x+a heaviside )
  ONE ' xFCNAPPLY			( ilap meta-x+a heaviside #1 fcnapply )
  4ROLL #3+ SYMBN x*ext			( ilap*heaviside )
;

LABEL ILAPNRAT
::
  SYMBINCOMP				( meta )
  SYMBOL ROMPTR xILAP ; TOTEMPOB
  ONE ' xFCNAPPLY			( meta ilap one fcnapply )
  4ROLL #3+ SYMBN			( symb )
;

* ====================================================================
* Desc:			Inverse Laplace of rational fraction
* Stack:		fr -> ILAP[fr]
* ====================================================================
NULLNAME ILAPRAText
::
  LVARXNXext				( fr x lvarnx lvarx )
  DUPNULL{}? case2drop
  :: OBJ>R				( fr )
     SYMBINCOMP R>OBJ			( meta x )
     SYMBOL ID Delta ; TOTEMPOB
     ONE ' xFCNAPPLY			( meta x delta one fcnapply )
     FOUR metamult			( meta )
     CKSYMBN				( symb )
ASSEMBLE
	IF	f39
RPL
  InCASApplication? ?SEMI
  DUP Z0 EQUAL ?SEMI
  BINT99 ERABLEERROR
ASSEMBLE
	ENDIF	f39
RPL
  ;

  3PICK ONE{}N EQUAL			( fr x lvarnx lvarx={x}? )
  NOTcase2drop ILAPNRAT
					( fr x lvarnx )
  ( * binds 1=depth, 2=lvar, 3=x, 4=fk, 5=fk', 6=a, 7=b, 8=g, 9=? * )
  OVER >TCOMP				( fr x lvarnx&x )
  DUPLENCOMP #1+ ONE MKPOLY			( fr x lvarnx&x internal-x )
  COMPLEX? ZEROZERO ZEROZERO ZEROZERO 
  TEN ROLL TEN ROLL ROT			( fr intern-x ? 0 0 0 0 0 x lvarnx 0 )
  ' NULLLAM TEN NDUPN DOBIND		( fr )
  2GETLAM 3GETLAM >HCOMP SIX PFext
  ( lvar, quotient, num1, deno1, f1, m1, ..., numk, denok, fk, mk, #4k )
  ILAPRAT				( lvar quotient symb )

  ( creer les fonctions delta et derivees )

  SWAP ILAPDELTA SWAPDROP		( symb )
  ABND
;

LABEL ILAPRAT
::					( n1 d1 f1 m1...nk dk fk mk #4k )
  DUP#0=csedrp Z0			( -> symb )
  Z0ONE ROT FOUR #/ SWAPDROP		( n1 d1 f1 m1...nk dk fk mk meta #k )
  ZERO_DO (DO)				( n1 d1 f1 m1...nk dk fk mk meta )
    get1 OBJ>R get1 			( n1 d1 f1 m1...nk dk meta fk )
    DUP 4PUTLAM PDer 5PUTLAM 		( n1 d1 f1 m1...nk dk meta )
    get1 OBJ>R get1 			( n1 d1 f1 m1...meta nk )
    R>OBJ R>OBJ %ABSCOERCE		( n1 d1 f1 m1... meta nk dk #mk )
    DUP#1= ?SKIP ILAPABG		( n1 d1 f1 m1... meta nk dk #mk )
    ILAPFK				( n1 d1 f1 m1... meta meta-add )
    MetaAdd				( n1 d1 f1 m1... meta )
  LOOP
  CKSYMBN				( -> symb )
;

LABEL ILAPABG
* find a,b,g / g=a*fk+b*fk'
::
  4GETLAM 5GETLAM REGCDext		( g a b )
  7PUTLAM 6PUTLAM 8PUTLAM		( )
;

LABEL ILAPFK
* nk dk #mk -> meta
:: 
  DUP#1= casedrop ILAPFK1
  					( nk dk #mk )
  ( * ILAP[nk/dk*fk^mk]=ILAP[nk'/dk'*fk^mk-1]+ x*ILAP[nk"/dk"*fk^mk-1] * )
  ( * g=a*fk+b*fk', u=a*nk rem fk, v=b*nk rem fk' * )
  ( * nk'/dk'=u+v'/[mk-1], nk"/dk"=v/[mk-1] * )
  #1- SWAPROT				( #mk-1 dk nk )
  ( * first remove entiere part of nk div fk * )
  4GETLAM PSEUDODIV			( #mk-1 dk newdk quot newnk )
  2SWAP QMul 				( #mk-1 quot newnk dk*newdk )
  SWAPDUP 				( #mk-1 quot dk*newdk nk nk )
  6GETLAM QMul 5GETLAM 			( #mk-1 quot dk nk a*nk fk' )
  NEWDIVext SWAPDROP			( #mk-1 quot dk nk u )
  4ROLL 8GETLAM QMul QAdd		( #mk-1 dk nk u+quot*g )
  SWAP 7GETLAM QMul 4GETLAM		( #mk-1 dk u b*nk fk )
  NEWDIVext SWAPDROP			( #mk-1 dk u v )
  FXNDext OVER PDer			( #mk-1 dk u vn vd vn' )
  ROT 10GETLAM QMul			( #mk-1 dk u vd vn' vn*x )
  QAdd SWAP 				( #mk-1 dk u vn'+vn*x vd )
  5PICK #>Z QMul 			( #mk-1 dk u vn'+vn*x vd*mk-1 )
  NDXFext QAdd				( #mk-1 dk u+[vn'+vn*x]/vd*mk-1 )
  FXNDext ROT QMul 8GETLAM QMul		( #mk-1 nk' dk'=dk*deno*g )
  ROT ILAPFK				( -> meta )
;

LABEL ILAPFK1
::					( nk dk )
  CKCARCOMP				( nk dk )
  4GETLAM DUPLENCOMP			( nk dk fk #l )
  DUP #2= casedrop ILAPFKREAL
  #3= NcaseSIZEERR
  					( nk dk fk )
  SETCOMPLEX DEG2ext CARCOMP		( nk dk root )
  5GETLAM SWAP HORNext ROTDROP		( nk dk root fk'[root] )
  4ROLLROT HORNext ROTDROP		( dk fk'[r] r nk[r] )
  2SWAP QMul QDiv			( r residu )
  SWAP ILAPEXP				( symb )
;

LABEL ILAPFKREAL
* ILAP[n/d/[fk1*x+fk2]]=n/[d*fk1]*exp[-fk2/fk1*x]
::					( nk dk fk )
  INCOMPDROP OVER QNeg QDiv		( nk dk fk1 -fk2/fk1 )
  4UNROLL QMul SWAP CKCARCOMP SWAP QDiv VAL1M	( -fk2/fk1 meta )
  get1 VAL1M 3GETLAM ONE MetaMul	( meta meta*x )
  addt: xEXP MetaMul			( -> meta ) 
;


* ====================================================================
* Desc:
* Stack:
* ====================================================================
NULLNAME ILAPDELTA
::				( lvar symb partie_entiere )
  FXNDext OBJ>R			( lvar symb partie_entiere_num )
  ILAPDELTANUM			( lvar symb alg )
  R>OBJ 4PICK SWAP R2SYM	( lvar symb alg den )
  x/ext x+ext			( lvar symb )
;

LABEL ILAPDELTANUM
::				( lvar symb partie_entiere_num )
  DUP Z0 EQUAL ?SEMI		( -> lvar symb 0 )
  CKINNERCOMP DUP#0= casedrop Z0 ( -> lvar symb 0 )
				( lvar symb meta_partie_entiere_num )
  "d1" "Delta"
  Z0 4ROLL
  ZERO_DO (DO)			( on..o0 prefix nom_actuel alg )
    OVER OBJ>R 4ROLL VAL1M	( on..o1 prefix nom_actuel alg meta-o0 )
    3GETLAM SYMBINCOMP
    R>OBJ $>ID symcomp		( on..o1 prefix nom_actuel alg meta x 'name' )
    ONE ' xFCNAPPLY 4ROLL #3+
    MetaMul			( on..o1 prefix nom_actuel alg m-o0*delta[x] )
    get1 SYMBINCOMP psh 
    MetaAdd CKSYMBN		( on..o1 prefix nom_actuel alg )
    UNROT OVERSWAP &$ ROT	( on..o1 prefix nom_actuel alg )
  LOOP
  UNROT2DROP			( lvar symb alg )
;

* ====================================================================
* Desc:
* Stack:	( ck, rk -> meta-ck*exp[rk*x] )
* ====================================================================
NULLNAME ILAPEXP
::
  num#0=case7 ONE			( -> z0 #1 )
  9GETLAM NOTcase ILAPEXPSC
					( ck rk )
  SWAP VAL1M get1			( rk meta-ck )
  3GETLAM ONE MetaMul VAL1M addtEXP	( meta-ck meta-EXP )
  MetaMul
; 

* ====================================================================
* Desc:
* Stack:
* ====================================================================
NULLNAME ILAPEXPSC
::					( ck rk )
  SWAP Z2 QMul VAL1M get1		( meta-ck rk )
  VAL1M 				( meta-ck meta-rk )
  3GETLAM ONE MetaMul addtEXP		( meta-ck meta-exp )
  MetaMul CLRCOMPLEX xSYMRE		( -> meta )
;
**********************************************************************

