INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

	STITLE Sign of a function

* POSITIFext	( obj -> obj, flag )
*		Tries to determine if obj is positive
*		In internal representation, this depends on increaseflag
*		(x-1 is positive if increaseflag is cleared, negative otherwise)
*		because x is assumed to tend to +infinity or 0

**********************************************************************
* Desc:		Try to determine if ob is positive.
*		In internal representation, this depends on
*		increaseflag so that x-1 is positive if increaseflag
*		is cleared, negative otherwise, because x is assumed
*		to tend to +infinity or zero.
* Stack:	( ob --> ob flag )
**********************************************************************
NULLNAME POSITIFext 
LABEL positif!
::
  DUP						( obj, obj )

  DUPTYPESYMB? case positifsym1!

  LABEL positifext!
  CODE
positifext	C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		C=A	W
		LC(5)	=DOINT
		?A#C	A
		GOYES	positif1
positifz	LA(5)	=positifz!
		PC=(A)
positif1	LC(5)	=DOLIST
		?A#C	A
		GOYES	positif2
		LA(5)	=positiflist!
		PC=(A)
positif2	LC(5)	=DOSYMB
		?A#C	A
		GOYES	positif3
		LA(5)	=positifsym2!
		PC=(A)
positif3	LCIRRQ
		?A#C	W
		GOYES	positif4
		LA(5)	=positifirrq!
		PC=(A)
positif4	?A#C	A
		GOYES	positif5
		LA(5)	=positifcmpl!
		PC=(A)
positif5	LC(5)	=DOTAG
		?A=C	A
		GOYES	positif6
		LA(5)	=positifconv!
		PC=(A)
positif6	LA(5)	=positiftag!
		PC=(A)
  ENDCODE
;

* Positivity test for symbolic objects

LABEL positifsym1!
:: 
  FXNDext positifext!
  SWAP positifext!
  XOR NOT
;

LABEL positifsym2!
::
  DUPLENCOMP NTHCOMPDROP EQ: xNEG
  NOT
;

LABEL positifcmpl!
::
  TWO NTHCOMPDROP
  DUPTYPEZ? case positifz!
  DROPTRUE
;

LABEL positifz!
::
  ZIsNeg? NOT
;

LABEL positifirrq!
::
  QABSext SWAPDROP
;

LABEL positiflist!
::
  DUPNULL{}? case DROPTRUE
  increaseflag TestSysFlag
  NOTcase :: CARCOMP positifext! ;
  INNERCOMP DUP#1= casedrop positifext!
  ONE_DO (DO)
     plistloop!
  LOOP
  positifext!
;

LABEL plistloop!
::
  num#0=case7 DROP
  ISTOP-INDEX SWAPOVER #2+UNROLL
  NDROP ExitAtLOOP 
;


LABEL positiftag!	
::
  'EvalNoCK: xOBJ> 			( obj, tagged )
  OVER Z0 EQUAL				( obj, tagged, ?=0 )
  NOTcasedrop positifext!
  SWAPDROP "+" EQUAL
;

LABEL positifconv!
::
  idntlamcase DROPTRUE
  DUPTYPEEXT? case DROPTRUE
  VXXL1ext
  CK&DISPATCH1
  ereal %%0>=
  ecmp  :: C%%>%% DROP %%0>= ; 
  any   positifext!
;


**********************************************************************
* Desc:		Sign of a polynomial or rational expression
* Stack:	( expr -> sign_table )
**********************************************************************
NULLNAME SIGNE1ext
::
  REWRITE1FORSOLVE
  LVARXNXext				( expr x lvarnx lvarx )
* old code
*  ROT prepvarlist			( expr lvarnx lvarx )
  ROTDROP				( expr lvarnx lvarx )
* end change
  DUPLENCOMP ONE 
  #>case TRANSCERROR			( transcendental equation error )
					( expr lvarnx lvarx )
  SWAP NULLCOMP?			( expr lvarx ?lvarnx={} )
  NOTcase :: BINT37 ERABLEERROR ;	( parameters not allowed )
					( expr lvar )
  numfactorflag SetSysFlag
  ZERO RFACT2ext {}N			( lvar obj_interne list_roots )
  DUPNULL{}? casedrop SIGNENOROOT
  ONESWAP NULL{} VAL2ext		( lvar obj_interne liste_racines )
  SWAP FXNDext CKCARCOMP ZSIGNE 		
  SWAP CKCARCOMP ZSIGNE QMul		( lvar liste_roots z )
* sign is always defined DUP Z0 EQUAL case2drop SIGNUNDEF
  Z1 EQUAL ITE { x+ } { x- }		( lvar liste_racines result )
  SWAPINCOMP DUP#0=csedrp SWAPDROP	( -> result )
					( lvar result r1 m1 .. rn mn #2n )
  DUP1LAMBIND #2/ 
  #1+_ONE_DO (DO)			( lvar result r1 m1 .. rn mn )
     %2 %MOD %0= TWO{}N	
     1GETLAM INDEX@#- UNROLL
  LOOP					( lvar result {r1 ?even}..{rn ?even} )
  1GETABND #2/ {}N
  ' SIGNESORT TOTEMPOB SortList		( lvar result list_roots/?even_mult )
  INNERCOMP get1 SWAP
  ZERO_DO (DO)				( {r1 flag1}..{rk flagk} {result} )
    SIGNE1LOOP
  LOOP
					( lvar resultat )
  MINUSINFext >HCOMP
  PLUSINFext >TCOMP

  ( modifs du signe en fonction de la 1ere var de lvar )

  SWAP CARCOMP DUPTYPESYMB?		( signe var ? )
  NOTcaseDROP				( -> signe )

  ( * support for var of length>2 here * )
					( signe var ? )
  INNERCOMP #1-SWAP OVER#2+UNROLL CKSYMBN  ( signe op var' )
  SWAP SIGNELIST EQLookup		( signe var [ op FALSE | seco TRUE ] )
  NOTcase TRANSCERROR
  					( signe var seco )
  SWAP IDNTLAM? casedrop EVAL
					( signe seco var )
  LINEAIRE?				( signe seco var a ? )
  NOTcase TRANSCERROR
					( signe seco var a )
  DUP RCLVX x*ext ROT x-ext SIMPLIFY	( signe seco a -b )
  SWAP ZSIGNECK				( signe seco -b a ? )
  5ROLL 5ROLL EVAL			( -b a ? signe )
  2SWAP ' x+ext SWAP' x/ext FOUR ::N	( ? signe :: -b + a / ; )
  SIGNEEVAL!				( ? signe )
  SWAP ?SEMI				( -> signe )
  INNERCOMP reversym {}N		( -> signe )
;

LABEL SIGNENOROOT
::					( lvar internal_obj )
  R2SYM 				( obj )
  ZSIGNE  				( z )
  Z0 EQUALcasedro SIGNUNDEF
  Z1 EQUAL ITE SIGNPLUS SIGNMOINS
;

LABEL SIGNESORT
( { r1 flag } { r2 flag } -> flag )
* sort objects by numerical asc. order
::
  CARCOMP CASCRUNCH
  DUPTYPEREAL? NOTcase2drop TRUE
  SWAP CARCOMP CASCRUNCH
  DUPTYPEREAL? NOTcase2drop TRUE
  %<
;

LABEL SIGNE1LOOP
( {r ?even} {result} -> {result} )
::
  SWAPINCOMP DROPOVER CASCRUNCH
  TYPEREAL?			( {result} rk flagk ?reel )
  NOTcase2DROP
				( {result} rk flag )
  3PICK CARCOMP SWAP		( {result} rk signe flagk )
  ?SKIP
  CODE
	A=DAT1	A
	LC(5)	=x+
	?A#C	A
	GOYES	write
	LC(5)	=x-
write	DAT1=C	A
	GOVLNG	=Loop
  ENDCODE			( {result} rk signe )
  SWAP TWO{}N
  SWAP &COMP
;

LABEL SIGNELIST
{ 
  xLN SIGNELN
  xEXP SIGNEEXP
  xSIN SIGNESIN
  xCOS SIGNECOS
  xTAN SIGNETAN
  x\v/ SIGNESQRT
  xATAN SIGNEATAN
  xABS SIGNEABS
}


**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME SIGNEext
::
  increaseflag SWITCHOFF
  SYMBINCOMP
  METASIGNE
;

LABEL METASIGNE
( meta -> signe )
::
  M1st*case SIGNE*
  M1st/case SIGNE*
  M1st^case SIGNE^
  M1stNEGcase SIGNENEG
  CKSYMBN SIGNE1ext
;

LABEL SIGNENEG
::
  pulldrop METASIGNE
  SIGNMOINS SIGNMULText
;
	
LABEL SIGNE^
::
  pulldrop larg					( meta1 meta2 )
  CKSYMBN
  OBJINT? NOTcasedrop :: NDROP SIGNUNDEF ;
						( meta1 z )
  Z2 ZMod Z1 EQUAL				( meta1 flag )
  case METASIGNE

  ( * for a positive exponent we call METASIGNE anyway * )
  ( * because the 0's must be in the signe table * )
  METASIGNE

  ( * and now we replace all x- by x+ )
  ' REPLACE-BY+
  TOTEMPOB 1LAMBIND LISTSECOext ABND
;

LABEL REPLACE-BY+
CODE
		A=DAT1	A
		LC(5)	=x-
		?A#C	A
		GOYES	signelp
		LC(5)	=x+
		DAT1=C	A
signelp		GOVLNG	=Loop
ENDCODE

LABEL SIGNE*
::
  plDRPpZparg					( meta1 meta2 )
  METASIGNE OBJ>R				( meta1 )
  METASIGNE R>OBJ 				( signe1 signe2 )
  SIGNMULText
;

**********************************************************************
* Desc:		Return undefined signe table
* Stack:
**********************************************************************
NULLNAME SIGNUNDEF
:: MINUSINFext ?ext PLUSINFext THREE{}N ;

**********************************************************************
* Desc:		Return always positif signe table
* Stack:
**********************************************************************
NULLNAME SIGNPLUS
:: MINUSINFext ' x+ PLUSINFext THREE{}N ;

**********************************************************************
* Desc:		Return always negatif signe table
* Stack:
**********************************************************************
NULLNAME SIGNMOINS
:: MINUSINFext ' x- PLUSINFext THREE{}N ;

**********************************************************************
* Desc:		Return ln of a signe table
* Stack:	( signe -> signe )
**********************************************************************
NULLNAME SIGNELN
::
  SIGNEEVAL xEXPext >SIGNE
;

**********************************************************************
* Desc:		Return exp of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNEEXP
::
  Z0 SIGNELEFT SIGNEEVAL CKLN
;

**********************************************************************
* Desc:		Return sin of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNESIN
::
  DUP OBJ>R Z-1 Z0 SUBSIGNE SIGNEEVAL xASINext	( [-pi/2 0] )
  DUP SIGNEEVAL MOINSPI-x 			( [-pi/2 0] [-pi/2 -pi] )
  INNERCOMP reversym pulldrop 
  get1 INNERCOMP pulldrop top&			( -pi..-pi/2.. )
  R>OBJ Z0 Z1 SUBSIGNE SIGNEEVAL xASINext	( -pi..-pi/2.. [0 pi/2] )
  DUPINCOMP pulldrop get1 SIGNEEVAL PI-x	( -pi.. 0.. [pi pi/2] )
  INNERCOMP reversym top& top& {}N		( -pi..pi )
  >SIGNE SIGNE>
;

LABEL MOINSPI-x
:: metapi metaneg get1 SYMBINCOMP MetaSub metasimp CKSYMBN ;

LABEL PI-x
:: metapi get1 SYMBINCOMP MetaSub metasimp CKSYMBN ;

**********************************************************************
* Desc:		Return cos of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNECOS
::
  Z-1 Z1 SUBSIGNE SIGNEEVAL xACOSext	( [pi 0] )
  DUP SIGNEEVAL xNEG			( [pi 0] [-pi 0] )
  INNERCOMP pulldrop get1 		( -pi.. [pi 0] )
  INNERCOMP reversym top& {}N		( [-pi..pi] )
  >SIGNE SIGNE>
;

LABEL SIGNEABS
::
  Z0 SIGNELEFT
  DUP SIGNEEVAL xNEG			( [0 inf] [0 -inf] )
  INNERCOMP reversym pulldrop get1
  INNERCOMP top& {}N			( [-inf inf] )
;

**********************************************************************
* Desc:		Return tan of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNETAN
::
  SIGNEEVAL xATANext
  >SIGNE SIGNE>
;

**********************************************************************
* Desc:		Return atan of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNEATAN
::
  pisur2 DUP SYMNEG SWAP SUBSIGNE
  SIGNEEVAL xTANext
  ( * replace unsigned inf with signed inf * )
  INNERCOMP pulldrop PLUSINFext SWAP		( o1..on-1 on' #n-1 )
  get1 DROP MINUSINFext OVER#2+UNROLL #1+ {}N	( o1'..on' #n )
;

**********************************************************************
* Desc:		Return sqrt of a signe table
* Stack:
**********************************************************************
NULLNAME SIGNESQRT
::
  Z0 SIGNELEFT SIGNEEVAL xSQ >SIGNE
;

**********************************************************************
* Desc:		Evaluate runstream op on a signe table
* Stack:	table -> table
**********************************************************************
LABEL SIGNEEVAL
::
  'R SIGNEEVAL!
;

LABEL SIGNEEVAL!
* signtab prg -> signtab
::
  1LAMBIND
  INNERCOMP #1-DUP #2/
  ZERO_DO				( o1, ..., o2n+1, #2n )
     get1
     1GETLAM EVAL
     HSECO2RCext
     SWAP get1
  SWAPLOOP
  get1
  1GETABND EVAL
  SWAP#1+ {}N
;

**********************************************************************
* Desc:		Truncate a signe table
* Stack:	table min max -> table
**********************************************************************
NULLNAME SUBSIGNE
::
  UNROT SIGNELEFT SWAP SIGNERIGHT
;

**********************************************************************
* Desc:		place obj a la fin d'une sous-liste de signe
* Stack:	( table obj -> table )
**********************************************************************
NULLNAME SIGNERIGHT
::					( table obj )
  DUPROT INNERCOMP SWAPDROP		( obj obj o1..on+1 #n+2 )
  SWAP 1LAMBIND				( obj obj o1..on #n+2 )
  #2- get1				( obj o1..on #n obj )
  CASCRUNCH SWAP			( obj o1..on obj #n )
  BEGIN					( obj, o1, ..., on, obj, #n )
    DUP#1= ITE
       FALSE
       :: 3PICK CASCRUNCH 3PICK %>= ;
  WHILE					( obj o1..on obj #n )
    ROTDROP ROT 1PUTLAM			( obj o1..on-2 obj #n )
    #2- 				( obj o1..on-2 obj #n-2 )
  REPEAT
  SWAPDROP				( obj o1..on-2 #n-2 )
  get1 1GETABND 			( o1..on-2 #n-2 obj signe )
  UNROTSWAP #2+ {}N
;

**********************************************************************
* Desc:		place obj en tete d'une sous-liste de signe
* Stack:	( table obj -> table )
**********************************************************************
NULLNAME SIGNELEFT
::
  DUPROT INNERCOMP
  get1 CASCRUNCH SWAP			( obj, o1, ..., on, obj, #n )
  get1 DROP #1- get1 1LAMBIND #1-	( obj, o3, ..., on, obj, #n-2 )
  BEGIN
     DUP#1= ITE
       FALSE
       :: DUP #2+PICK CASCRUNCH 3PICK %<= ;
  WHILE
     get1 DROP
     #1- get1 1PUTLAM
     #1-
  REPEAT
  SWAPDROP
  1GETABND OVER#2+UNROL #2+ {}N
;

**********************************************************************
* Desc:		Prepend { -infinity ? } to a signe table
* Stack:	table -> table
**********************************************************************
NULLNAME >SIGNE
::
* { MINUSINFext ?ext } SWAP &COMP
  ?ext >HCOMP MINUSINFext >HCOMP
;

**********************************************************************
* Desc:		Append { ? +infinity } to a signe table
* Stack:	table -> table
**********************************************************************
NULLNAME SIGNE>
::
* { ?ext PLUSINFext } &COMP
  ?ext >TCOMP PLUSINFext >TCOMP
;

**********************************************************************
* Desc:		"Multiplies" 2 tables of signe
* Stack:	( table2 table1 -> table )
**********************************************************************
NULLNAME SIGNMULText
::
  CK2NOLASTWD
  PLUSINFext
  DUP 4ROLL DUPLENCOMP SWAP PUTLIST
  SWAPROT   DUPLENCOMP SWAP PUTLIST
  2DUPSWAP LENCOMP SWAP LENCOMP
  4NULLLAM{} BIND
  MINUSINFext ONE THREE THREE			( metares; a; b )
  BEGIN
     4GETLAM 3PICK #1- NTHCOMPDROP    
     3GETLAM 3PICK #1- NTHCOMPDROP
     CODE
		A=DAT1 A
		D1=D1+ 5
		D=D+1  A
		C=DAT1 A
		?A#C   A
		GOYES  +
		LC(5)  =x-
		?A#C   A
		GOYES  lp
		LA(5)  =x+
dlp		DAT1=A	A
lp		GOVLNG =Loop
+		LC(5)  #80000
		?A>C   A
		GOYES  dlp
npm		A=DAT1 A
		?A>C   A
		GOYES  lp
		LA(5)  =x-
		GOTO   dlp
     ENDCODE
						( metares, a; b; res )
     4UNROLLROT #2+ UNROT
     4GETLAM 3PICK NTHCOMPDROP
     3GETLAM 3PICK NTHCOMPDROP
     2DUP 
     ::
       EQUALcase
       ::
         DROP 4UNROLL				( metares, a; b )
         #2+ SWAP #2+ SWAPDUP 
         1GETLAM #>
       ;
       ::
         4PICK 2GETLAM #= caseTRUE
         3PICK 1GETLAM #= caseFALSE
         2DUP CASCRUNCH
         SWAP CASCRUNCH %<
       ;
						( metares, a; b, A; B; ?A<B )
       NOTcasedrop
       :: 4UNROLL SWAP #2+ SWAP FALSE ;
       SWAPDROP 4UNROLL #2+ FALSE
    ;
  UNTIL
  2DROP ABND {}N
;
**********************************************************************
* --------------------------------------------------------------------
* Desc:		Return sign of an expression
* Stack:	obj -> obj flag
* Note:		error if unable to find sign
* --------------------------------------------------------------------
NULLNAME ZSIGNECK
::
  DUP ZSIGNE
  Z1 EQUALcasedro TRUE
  Z-1 EQUALcasedro FALSE
  SIGNEERROR
;

NULLNAME SIGNEERROR
::
  BINT54 ERABLEERROR
;

* --------------------------------------------------------------------
* Desc:		Return sign of an expression
* Stack:	obj -> zint
* Note:		zint=1 for +, -1 for -, 0 for undef
*		Expression does not need to be polynomial/rational
* --------------------------------------------------------------------
NULLNAME ZSIGNE
::
  num#0=case7 NOP
  CK&DISPATCH1
  TAGGED ZSIGNETAG
  real ZSIGNE%
  cmp DROPZ0
  idnt ZSIGNESYM
  lam ZSIGNESYM
  zint ZSIGNEZ
  symb ZSIGNESYMB
  list ZSIGNELIST
  seco ZSIGNESECO
  EXT ZSIGNEEXT
  ereal ZSIGNE%%
  ecmp DROPZ0
;

LABEL ZSIGNEEXT
* sign of a unit object: unit -> zint
::
  U>nbr ZSIGNE%
;

LABEL ZSIGNETAG
::
  TAG>				( obj string )
  { "+" "-" } TOTEMPOB ListPos	( obj # )
  DUP#0=csedrp ZSIGNE
				( obj # )
  SWAPDROP #1=case Z1 Z-1
;

LABEL ZSIGNE%
::
  %0> case Z1 Z-1
;

LABEL ZSIGNE%%
::
  %%0> case Z1 Z-1
;

LABEL ZSIGNEZ
::
  ZIsNeg? case Z-1 Z1
;

LABEL ZSIGNESYMB
::
  INNERCOMP zsigne
;

* --------------------------------------------------------------------
* Desc:		Return sign of a meta symbolic
* Stack:	meta -> zint
* Note:		zint=1 for +, -1 for -, 0 for undef
*		Expression does not need to be polynomial/rational
*		zsigne is not a strict rigorous comparison
* --------------------------------------------------------------------
NULLNAME zsigne
::				( meta )
  ( * check for inf/undef first * )
  1metaundef#			( meta #_undef )
  #0= NOTcase NDROPZ0		( sign of undef is 0 )
  1metainf#			( meta #_inf )
  #0=case zsigne1
				( meta )
  DUP #2= NOTcase NDROPZ0
  DROPSWAPDROP			( xNEG or xNEGNEG )
  EQ: xNEG case Z-1 Z1
;

LABEL approxmetasimp7
:: SYMBN APPROXCOMPEVAL SYMBINCOMP ;

LABEL zsigne1
::					( meta )
  DUP#1= casedrop ZSIGNE
  dup EXACT? IT approxmetasimp7		( meta crunched-meta )
  OVER TYPEREAL? 			( meta crunched-meta ? )
  casedrop zsigneapprox
					( meta crunched-meta )
  NDROP					( meta )
*  M1st+case ZSIGNE+
*  M1st-case ZSIGNE-
  M1stNEGcase ZSIGNENEG
  M1st*case ZSIGNE*
  M1st/case ZSIGNE*
  M1st^case ZSIGNE^
  AEQ1stcase xABS NDROPZ1
				( meta )
  COMPLEX? case NDROPZ0
  AEQ1stcase x\v/ NDROPZ1
  AEQ1stcase xEXP NDROPZ1
  AEQ1stcase xLN zsigneln
  ( * try Sturm sequences * )
  CKSYMBN ZSIGNESYM
;

LABEL ZSIGNESYM
::
  sturmflag TestSysFlag casedrop Z0
  DUP LISTOPext LVARDext	( symb lvar )
  DUPNULL{}? case2drop Z0	( -> 0 )
				( symb lvar )
  ( * add here check for interval hypothesis * )
  ( * first trigo var/ln var/abs &exp var/hypertrig var * )
  CARCOMP DUP			( symb var var )
  VARINTERVAL			( symb var low high )
  ( * compute again LVAR * )
  4PICK 3PICK 3PICK THREE 	( symb var low high symb low high #3 )
  LISTOPext LVARDext		( symb var low high lvar )
  4ROLL prepvarlist		( symb low high lvar )
  UNROT PushVStack 		( symb lvar low high )
  ERRSET STURMLSIGN
  ERRTRAP 
  :: PopVStack 4DROP Z0 RDROP ;
  DropVStack
;

LABEL zsigneapprox
:: OVER#2+UNROLL NDROP ZSIGNE% ;

LABEL zsigneln
::				( meta-ln )
  pulldrop metasq-1		( meta^2-1 )
  metasimp zsigne		( -> z )
;

LABEL ZSIGNESECO
::
  DUP CARCOMP 				( seco 1st )
  DUPTYPEZ? case2drop Z0		( -> 0 for a complex )
  EQ: x<< case ZSIGNEIRRQ
					( seco )
  { xi xe xPI } TOTEMPOB ListPos	( # ) 
  DUP#0=case SETSIZEERR
  #1=case Z0
  Z1
;

LABEL ZSIGNEIRRQ
::
  QXNDext				( a b c )
  UNROTDUP ZSIGNE			( c a b zb )
  DUP Z0 EQUAL				( c a b zb ? )
  case2drop 2DROPZ0			( -> Z0 if signe[b]=0 )
					( c a b zb )
  3PICK					( c a b zb a )
  ( * if a=0, return zb as signe * )
  Z0 EQUALcasedro 4UNROLL3DROP
  ZSIGNE 				( c a b zb za )
  2DUP EQUAL 				( c a b zb za zb=za? )
  casedrop 4UNROLL3DROP
					( c a b zb za )
  Z0 EQUAL				( c a b zb ? )
  case2drop 2DROPZ0
					( c a b zb )

  4UNROLL DUP QMul ROT QMul		( zb a b^2*c )
  SWAPDUP QMul QSub			( zb b^2*c-a^2 )
  ZSIGNE 				( zb zb^2c-a^2 )

* if b^2c>a^2, the sign of the irrq is the sign of b

  Z0 EQUALcasedro DROPZ0
  QMul
;

LABEL ZSIGNENEG
::
  pulldrop zsigne QNeg		( -> Z )
;

LABEL ZSIGNE*
::
  plDRPpZparg zsigne
  OVER#2+UNROLL zsigne QMul	( -> Z )
;

*LABEL ZSIGNE+
*::
*  plDRPpZparg			( meta1 meta2 )
*  zsigne OVER#2+UNROLL zsigne	( z2 z1 )
*  OVER EQUAL 			( z2 ? )
*  NOTcasedrop Z0
*;

*LABEL ZSIGNE-
*::
*  plDRPpZparg			( meta1 meta2 )
*  zsigne OVER#2+UNROLL zsigne	( z2 z1 )
*  QNeg OVER EQUAL 		( z2 ? )
*  NOTcasedrop Z0
*;

LABEL ZSIGNE^
::
  COMPLEX? case NDROPZ0
  plDRPpZparg			( meta1 meta2 )
  zsigne 			( meta1 z2 )
  Z1 EQUALcasedro NDROPZ1
  ( * arg is negative, look if meta1 is an even integer * )
				( meta1 z2 )
  3PICK TYPEZ? 			( meta1 z2 ? )
  NOTcasedrop NDROPZ0		( -> 0 )
				( meta1 z2 )
  SWAPDROPSWAP Z2 ZMod 		( z2 exposant_mod_2 )
  Z0 EQUAL NOT?SEMI DROPZ1
;

LABEL ZSIGNELIST
( list -> zint )
::
  RFACTSTEP3			( meta )
  ( * now look for even multiplicities  * )
  Z1 SWAP #2/
  ZERO_DO (DO)			( o1 m1 .. on mn zsigne )
    UNROT %2 %MOD %0=		( o1 m1 ... zsigne on mn_even? )
    ITE DROPZ1 ZSIGNELIST1	( o1 m1 ... zsigne zn )
    QMul
  LOOP
;

LABEL ZSIGNELIST1
( obj -> zint )
:: 
  CK&DISPATCH1 
  list ZSIGNELIST2 
  any ZSIGNE
;

LABEL ZSIGNELIST2
* sign is sign of inside constant or unknown
::
  DUPLENCOMP #1= NOTcase DROPZ0
  CARCOMP ZSIGNELIST1
;
