INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

	STITLE Def and undef summation

* Polynomial, Proper rational functions, hypergeometric
* For polynomials solve system
* For rat functions, partial fraction expansion then
* assemble shifted terms with respect to the maximal power
* of each shift class
* finish by psi functions
* psi=derivative of ln[gamma]
* with two args=n-th derivative of gamma
* Hypergeometric: Gosper algo

**********************************************************************
* Desc:		Find next line in the Pascal triangle
* Stack:	( list  -> list )
* Note:		
**********************************************************************
NULLNAME PASCAL_NEXTLINE
::
  DUPLENCOMP				( line # )
  DUP#1= casedrop :: Z1 >HCOMP ;	( -> line' )
					( line # )
  SWAP 1LAMBIND				( # )
  Z1 ONE ROT				( meta # )
  ONE_DO (DO)				( meta )
    1GETLAM DUPINDEX@ NTHCOMPDROP	( meta line an )
    SWAP INDEX@ #1+ NTHCOMPDROP		( meta an an+1 )
    QAdd SWAP#1+
  LOOP					( meta )
  Z1 SWAP#1+ ABND {}N			( vector )
;

**********************************************************************
* Desc:		Solve P(x+1)-P(x)=Q(x)
* Stack:	( Q  -> P )
* Note:		internal polynomial function
* Algo:		degree of P=degree of Q+1, constant coeff 0
*		If P=Sigma a_k x^k then write linear system for a_k
*		Columns of the matrix of the system are lines
*		of the Pascal triangle without the first element
*		(since we must substract identity matrix to the triangle)
*		a_1 a_2 a_3 ... a_n+1		coeff of Q
*		1   1   1	1	X^0
*		0   2	3	n+1	X^1
*		0   0	3	...	X^2
*		0   0	0	n+1     X^n
**********************************************************************
NULLNAME DELTAPSOLVE
::					( Q )
  ( * construct columns, lam1 contains current Pascal line * )
  DUPCKLEN{}				( Q #n+1 )
  Z1 ONE{}N 1LAMBIND			( Q #n+1 )
  ZEROSWAP				( Q meta-matr #n+1 )
  ZERO_DO (DO)				( Q meta-matr )
    1GETLAM PASCAL_NEXTLINE		( Q meta-matr {} )
    DUPINCOMP				( Q meta-matr {} 1...1 # )
    pulldrop				( Q meta-matr {} 1..k # )
    Z0 ISTOP-INDEX #1- NDUPN		( Q meta-matr {} 1..k # 0..0 # )
    top& []N				( Q meta-matr {} [] )
    UNROT 1PUTLAM #1+			( Q meta-matr )
  LOOP					( Q meta-matr )
  ABND					( Q meta-matr )

  ( * revert Q in asc. power * )
  get1					( meta-matr Q )
  CKINNERCOMP reversym []N		( meta-matr Q )
	
  ( * add to the system and transpose * )
  SWAP#1+ mattran			( meta-syst )
  SOLVEMETASYST NOTcase INTERNALERR	( d meta-sol )
	
  ( * revert solution in desc. power and add constant coeff 0 * )
  reversym Z0 SWAP#1+ >POLYTRIM		( d P*d )
  SWAP ONE>POLY QDiv			( P )

;

**********************************************************************
* Desc:		Solve linear system in meta representation
* Stack:	( meta-matr  -> d meta-sol true | false )
* Note:		meta-sol has been reduced to the same denominator d
**********************************************************************
NULLNAME SOLVEMETASYST
::
  ( * solve system * )
  REDUCEMETASYST				( meta-matrix )
  SOLVECRAMER					( d' meta-s true )
;

**********************************************************************
* Desc:		Reduce linear system in meta representation
* Stack:	( meta-matr  -> meta-matr' )
* Note:		
**********************************************************************
NULLNAME REDUCEMETASYST
::
  NULL{} ONE NOSTEPEVAL7 METAMATRED 2DROP	( reduced-meta-M )
	
  ( * suppress null lines, except first one * )
  BEGIN
    DUP#1= ITE FALSE :: OVER NULLVECTOR? ;
  WHILE
    pulldrop
  REPEAT
;

**********************************************************************
* Desc:		Reduce linear system in meta representation
* Stack:	( meta-matr  -> meta-matr' )
* Note:		does not reduce last column of meta-matr
*		this is useful to solve linear system with parameters
*		in the last column
**********************************************************************
NULLNAME REDUCEMETAPSYST
::
  lastcolflag TestSysFlag case REDUCEMETASYST
  lastcolflag SetSysFlag
  REDUCEMETASYST
  lastcolflag ClrSysFlag
;

**********************************************************************
* Desc:		Solve cramer system
* Stack:	( meta-matr  -> d meta-sol true | false )
* Note:		meta-matr must be fully reduced
*		meta-sol is reduced to the same denominator d
*		flag is FALSE if dimension do not match
**********************************************************************
NULLNAME SOLVECRAMER
::						( meta-matr )
  ( * look if #lines+1=#column * )
  OVER LENCOMP					( meta-matrix #column )
  OVER #1+ #= NOTcase NDROPFALSE
						( meta-matrix )
  ( * find solution * )

  DUP#1+ SWAP#1-SWAP				( meta' #n-1 #n+1 )
  ONE_DO 
    get1 DUP LASTCOMP				( meta'' #n-1 li li.n )
    SWAPINDEX@ NTHCOMPDROP RDIVext		( meta'' #n-1 li.n/li.i )
  SWAPLOOP					( meta-sol )
  #1+ dup METADENOLCM				( meta-s d' )
  SWAPDUP				
  ZERO_DO (DO)
    get1 3PICK RMULText UNROT
  LOOP				
  SWAPOVER #2+UNROLL TRUE			( d' meta-s true )
;

NULLNAME QUOTExSIGMA
::
  ' ROMPTR xSIGMA TOTEMPOB
;
	
**********************************************************************
* Desc:		Internal SUM
* Stack:	( sym idnt -> sym )
* Note:		at this time support only fractions
**********************************************************************
NULLNAME SUM
::					( sym idnt )
  ' FLASHPTR FLAGSUM TOTEMPOB
  CASFLAGEVAL
;

NULLNAME FLAGSUM
::					( sym idnt )
  ( * first compute embedded sums/integrals * )
  SWAP FLAGSEVAL SWAP			( sym idnt )
  RCLVX 1LAMBIND			( sym idnt )
  STOVX					( sym )
  FLAGSUMVX 				( sym )
  1GETABND STOVX
;

**********************************************************************
* Desc:		Internal SUMVX
* Stack:	( sym  -> sym )
* Note:		at this time support only fractions
**********************************************************************
NULLNAME SUMVX
::					( sym )
  ' FLASHPTR FLAGSUMVX TOTEMPOB
  CASFLAGEVAL
;

NULLNAME FLAGSUMVX
::
  ISPOLYNOMIAL? NOTcase NONRATSUM
  RATSUM
;

**********************************************************************
* Desc:		Discrete rational sum
* Stack:	( sym  -> sym )
* Note:	
**********************************************************************
NULLNAME RATSUM
::
  LVARext VX!				( symb lvar )
  ( * lvar=lam6, res=lam5, num=lam4, deno=lam3, fact=lam2, mult=lam1 * )
  DUP Z0 DUPDUP DUPDUP			( symb lvar lvar res 0 0 0 0 )
  ' NULLLAM SIX NDUPN DOBIND
  SEVEN PFext				( lvar quotient num1 deno1 f1 m1...numk denok fk mk #4k )
  RECALCULEDENOK
  SUMPROPERRAT 5GETLAM ABND		( lvar quotient symb )
  UNROT FXNDext				( symb lvar n d )
  SWAP DELTAPSOLVE SWAP QDiv		( symb lvar sigma_n/d )
  R2SYM x+ext				( symb )
;

LABEL RECALCULEDENOK
* recalculate denok=denok*fk^mk and change sign of mk
::
  DUP#0= ?SEMI
  {}N DUP >R LENCOMP			( #4k )
  FOUR #/ SWAPDROP ZEROSWAP		( meta #k )
  ZERO_DO (DO)
    RSWAP 'R'R 'R'R RSWAP		( meta num1 deno1 f1 m1 )
    %CHS 2DUP COERCE			( meta num1 deno1 f1 m1 f1 #m1 )
    RP# 4ROLL QMul UNROT		( meta num1 newdeno1 f1 m1 )
    5ROLL #4+				( meta )
  LOOP
;

LABEL SUMPROPERRAT
* compute proper rational part of a sum
::		( lvar quotient num1 deno1 f1 m1...numk denok fk mk #4k )
  [BEGIN]
    DUP#0=
  NOT_WHILE
    SUMPROPERRATLP
  [REPEAT]
		( lvar quotient #0 )
  DROP
;

LABEL SUMPROPERRATLP
* compute proper rational part of one factor, adding shift class part
::			( num1 deno1 f1 m1...numk denok fk mk #4k )
  #4- 5UNROLL		( num1 deno1 f1 m1...#4k-4 numk denok fk mk )
  1PUTLAM 2PUTLAM 3PUTLAM 4PUTLAM	( meta )
  FINDSHIFTFACTORS			( meta )
	
  4GETLAM j#0=case7 NOP
  ( * add non reducible part of lam4/lam3 to lam5 * )
  ( * if 1st order factor has real root, use psi functions and derivatives * )
  ( * for other factors add a SUM[,VX] term * )
					( meta )
  2GETLAM DUPCKLEN{} #2= 		( meta f ? )
  NOTcasedrop ADDSUMPART
  ( * psi part * )
					( meta f )
  DEG1					( meta root )
  DUP RIMext j#0=case7 ADDPSIPART
					( meta root )
  DROP ADDSUMPART
;

LABEL ADDPSIPART
::					( meta root )
  5GETLAM SYMBINCOMP get1		( meta meta-s root )
  4GETLAM SWAPDUP 4PUTLAM PTAYLext	( meta meta-s num-shifted )
  DUPTYPELIST? ?SKIP ONE{}N
  DUP >R LENCOMP			( meta meta-s #num )
  1GETLAM %ABSCOERCE #1+		( meta meta-s #num #mult )
  ( * set lvar and depth for VAL1M * )
  6GETLAM 2PUTLAM ONE 1PUTLAM		( meta meta-s #num #mult )
  DUPROT #-				( meta meta-s #mult #mult-num )
  DO
    RSWAP 'R RSWAP			( meta meta-s coef )
    3GETLAM CKCARCOMP QDiv 		( meta meta-s coef' )
    VAL1M 				( meta meta-s meta-coef )
    INDEX@ #1= ITE PSIX PSINX		( meta meta-s meta-coef meta-psi )
    MetaMul MetaAdd			( meta meta-s )
  LOOP
  CKSYMBN 5PUTLAM			( meta )
;

LABEL PSIX
::
  RCLVX	ONE				( x #1 )
  4GETLAM VAL1M MetaSub			( meta-x-root )
  sympsi				( meta )
;

LABEL PSINX
::
  RCLVX ONE 				( meta-x )
  4GETLAM VAL1M MetaSub			( meta-x-root )
  INDEX@ #1- #>Z			( meta-x-root n )
  sympsin				( meta )
  INDEX@ #1-DUP #>Z factzint		( meta n n! )
  SWAP TWO #/ DROP			( meta n! n_mod_2 )
  #1= IT QNeg				( meta +/-n! )
  ONE MetaDiv				( meta )
;

LABEL ADDSUMPART
::
  ( * set lvar and depth for VAL1M * )
  6GETLAM 2PUTLAM ZERO 1PUTLAM		( meta )
  5GETLAM SYMBINCOMP			( meta meta-res )
  4GETLAM VAL1M 3GETLAM VAL1M MetaDiv	( meta meta-res lam4/lam3-meta )
  SYMBN SYMB2METASUM MetaAdd		( meta meta-res )
  CKSYMBN 5PUTLAM			( meta )
;

LABEL SYMB2METASUM
::					( symb )
  RCLVX ONESYMBN			( symb x )
  QUOTExSIGMA ONESYMBN
  TWO ' xFCNAPPLY			( symb x 2 sum fcn )
  FIVE					( meta )
;

LABEL FINDSHIFTFACTORS
* find shift class part
::					( meta )
  DUP#0= ?SEMI				( -> meta )
  DUP OVER#2+UNROLL {}N >R		( #4l )
  FOUR #/ SWAPDROP ZEROSWAP		( meta #l )
  ZERO_DO (DO)
    RSWAP 'R'R 'R'R RSWAP		( meta num deno f m )
    FINDSHIFTLP				( meta )
  LOOP
;

LABEL FINDSHIFTLP
::					( meta num deno f m )
  ( * test if f is in the shift class of lam2 * )
  FOUR 3PICK DUPCKLEN{}			( meta num deno f m #4 f #f )
  2GETLAM DUPCKLEN{}			( meta num den f m #4 f #f lam2 #lam2 )
  ROT #=				( meta num den f m #4 f lam2 ? )
  NOTcase2drop top&			( -> meta )
					( meta num den f m #4 f lam2 )
	
  ( * same degree, compute eventual shift * )
  OVER FINDSHIFTP			( meta num den f m #4 f lam2 f.2 )
  OVER FINDSHIFTP			( meta num den f m #4 f lam2 f.2 l.2 )
  QSub OVER LENCOMP #1- #>Z QDiv	( meta num den f m #4 f lam2 shift )

  ( * must be an integer shift * )
  OBJINT? NOTcase :: 3DROP top& ;
	
  ( * now test:	compute Taylor shift of f and compare to lam2 * )
  DUP4UNROLL PTAYLext			( meta n d f m #4 shift f lam2-shift )
  QDiv CSTFRACTION? SWAPDROP		( meta num den f m #4 shift ? )
  NOTcasedrop top&			( -> meta )
	
  ( * same shift class, compare multiplicities * )
					( meta num den f m #4 shift )
  SWAPDROP				( meta num den f m shift )
  OVER 1GETLAM %>			( meta num den f m shift m>lam1? )
	
  ( * store new lam1->lam4 if mult of f is > than of lam2 * )
  ITE SUMRATEXC UNROT2DROP 		( meta num den shift )
	
  ( * shift num and deno of the lowest multiplicity and add to lam4/lam3 * )
  QNeg UNROT QDiv			( meta shift frac )
  DUP3PICK FTAYL			( meta shift frac frac-shifted )
  4GETLAM 3GETLAM QDiv QAdd		( meta shift frac new-lam4/lam3 )
  FXNDext 3PUTLAM 4PUTLAM		( meta shift frac )

  ( * update multiplicity in lam 1 * )
  3GETLAM LENCOMP #1- 2GETLAM LENCOMP #1- #/ SWAPDROP UNCOERCE 1PUTLAM
	
  ( * update lam5=result by adding intermediate shifted num/deno * )
  SWAP DupZIsNeg?			( meta frac shift ?sign )
  ROT 6GETLAM ZERO			( meta shift ?sign frac lvar #depth )
  4NULLLAM{} BIND			( meta shift )
  ZABS Z>#				( meta # )
  Z0ONE ROT				( meta meta-res # )
  #1+_ONE_DO (DO)			( meta meta-res )
    3GETLAM INDEX@ #>Z
    4GETLAM ITE QNeg :: Z1 QSub ;	( meta meta-res frac shift )
    FTAYL VAL1M
    4GETLAM ITE MetaAdd	MetaSub		( meta new-meta-res )
  LOOP
  ABND 5GETLAM SYMBINCOMP psh MetaAdd	( meta meta-res )
  CKSYMBN 5PUTLAM
;

LABEL FINDSHIFTP
::
  INNERCOMP DUPTWO #< caseSIZEERR
  #2- NDROP SWAP QDiv
;

**********************************************************************
* Desc:		Taylor shift for rational fractions
* Stack:	( f shift  -> f' )
* Note:	
**********************************************************************
NULLNAME FTAYL
::				( f shift )
  num#0=case7 DROP
  SWAP FXNDext			( shift n d )
  SWAP3PICK PTAYLext		( shift d n' )
  SWAPROT PTAYLext		( n' d' )
  QDiv
;

LABEL SUMRATEXC
::					( meta num den f m shift )
  5UNROLL 1PUTLAM 2PUTLAM		( meta shift num den )
  4GETLAM 3GETLAM 2SWAP			( meta shift new-num new-den num den )
  3PUTLAM 4PUTLAM ROT			( meta new-num new-den shift )
  QNeg					( meta new-num new-den shift )
;
	
**********************************************************************
* Desc:		Taylor shift for rational fractions
* Stack:	( obj  -> obj flag )
* Note:		true if obj is a cst fraction
**********************************************************************
NULLNAME CSTFRACTION?
::
  DUP FXNDext CSTPOLY?		( obj n d ? )
  NOTcase2drop FALSE		( -> obj flag )
				( obj n d )
  DROP CSTPOLY?			( obj n ? )
  SWAPDROP			( obj ? )
;

LABEL CSTPOLY?
* Q -> Q flag
* test if Q is constant with respect to the main var
::
  NOTLISTcase TRUE
  DUPLENCOMP #1=
;

**********************************************************************
* Desc:		Discrete summation (hypergeometric case)
* Stack:	( symb  -> symb )
* Note:		
**********************************************************************
NULLNAME NONRATSUM
::
  ( * first apply linearity if allowed * )
  ' HYPERGEO ' RATSUM LINEARAPPLY 
;

**********************************************************************
* Desc:		Apply linearity
* Stack:	( symb nonrat_prg rat_prg -> symb )
* Note:		nonrat_prg is applied for a non rational part symb -> symb
*		rat_prg applied for a rational part symb -> symb
*		linearity is applied on symb
**********************************************************************
NULLNAME LINEARAPPLY
::
  TWO 4ROLL SYMBINCOMP		( nonrat rat #2 meta )
  linearapply			( meta )
  CKSYMBN			( symb )
;

NULLNAME linearapply
( nonrat_prg rat_prg #2 meta -> meta )
::				( nonrat rat #2 meta )
  M1st+case LINEARAPPLY+-	
  M1st-case LINEARAPPLY+-
  M1stNEGcase LINEARAPPLYNEG
  M1st*case LINEARAPPLY*
  M1st/case LINEARAPPLY/
  linearapply!
;

LABEL linearapply!
::
  SYMBN ISPOLYNOMIAL?		( nonrat rat #2 symb ? )
  ITE 3PICK 4PICK EVAL		( nonrat rat #2 symb )
  4UNROLL3DROP			( symb )
  SYMBINCOMP			( meta )
;

LABEL LINEARAPPLY+-
::
  psh dup rot			( nonrat rat #2 nonrat rat #2 meta ) 
  #1-SWAP OBJ>R pshzerpsharg	( nonrat rat #2 nonrat rat #2 meta1 meta2 )
  rot psh linearapply		( nonrat rat #2 meta1 meta2 )
  unrot linearapply		( meta2 meta1 )
  R>OBJ EQ: x+			( meta2 meta1 ? )
  case MetaAdd MetaSub
;
  
LABEL LINEARAPPLYNEG
::
  pulldrop linearapply MetaNeg
;

LABEL LINEARAPPLY*
::
  ( * test if one of both arg is cst * )
  plDRPpZparg			( nonrat rat #2 meta1 meta2 )
  meta_cst?			( nonrat rat #2 meta1 meta2 ? )
  case linearapply*
  psh meta_cst?
  case linearapply*
  MetaMul linearapply!
;

LABEL linearapply*
::
  unrot linearapply MetaMul
;

LABEL LINEARAPPLY/
::
  ( * test if second arg is cst * )
  pulldrop larg			( nonrat rat #2 meta1 meta2 )
  meta_cst?			( nonrat rat #2 meta1 meta2 ? )
  case linearapply/
  MetaDiv linearapply!
;

LABEL linearapply/
::
  unrot linearapply psh MetaDiv
;

**********************************************************************
* Desc:		Test for meta to be cst with respect to current var
* Stack:	( meta -> meta flag )
**********************************************************************
NULLNAME meta_cst?
::
  RCLVX EQUALPOSMETA	( meta ob # )
  SWAPDROP #0=		( meta ? )
;


**********************************************************************
* Desc:		Test and do hypergeometric summation
* Stack:	( symb -> symb )
**********************************************************************
NULLNAME HYPERGEO
::					( fk )
  DUP RCLVX DUP				( fk fk vx vx )
  Z1 x+ext				( fk fk vx vx+1 )
  SWAP 2LAMBIND				( fk fk )
  SYMBINCOMP fk+1/fk CKSYMBN ABND	( fk fk+1/fk )
	
  ISPOLYNOMIAL? NOTcase UNSOLVEDSUM
					( fk fk+1/fk )
  LVARext VX!				( fk fk+1/fk lvar )
  VXXLext				( fk lvar fk+1/fk )
  FXNDext				( fk lvar A B )
  A/B2PQR				( fk lvar P Q R )
  GOSPER?				( fk lvar [ P R Y true | false ] )
  NOTcase UNSOLVEDSUM
					( fk lvar P R Y )
  QMul SWAP QDiv R2SYM x*ext		( gk=fk*YR/P )
  SIMPLIFY
;

NULLNAME fk+1/fk
* meta -> meta
* compute meta[lam1=lam2]/meta[lam1]
* special care for product, power, division and factorial
::
  M1st*case fk+1/fk*
  M1st/case fk+1/fk/
  M1st^case fk+1/fk^
  AEQ1stcase xEXP fk+1/fkEXP
  AEQ1stcase x! fk+1/fk!
  AEQ1stcase xCOMB fk+1/fkcomb
  AEQ1stcase xPERM fk+1/fkperm
  fk+1/fknotz
;

LABEL fk+1/fknotz
::					( meta-fk )
  dup CKSYMBN				( meta-fk fk )
  1GETLAM 2GETLAM MEVALext		( meta-fk fk+1 )
  SYMBINCOMP psh MetaDiv		( meta-fk+1/fk )
;

LABEL fk+1/fkcomb
::
  pulldrop larg addtCOMB fk+1/fk
;

LABEL fk+1/fkperm
::
  pulldrop larg addtPERM fk+1/fk
;

LABEL fk+1/fk*
::
  plDRPpZparg				( meta-1 meta-2 )
  fk+1/fk psh fk+1/fk MetaMul		( meta )
;

LABEL fk+1/fk/
::
  plDRPpZparg				( meta-1 meta-2 )
  fk+1/fk psh fk+1/fk MetaDiv		( meta )
;

LABEL fk+1/fk^
::
  3PICK TYPEZINT? NOTcase fk+1/fknotz^
  plDRPpZparg				( meta-1 meta-2 )
  fk+1/fk psh MetaPow			( meta )
;

LABEL fk+1/fknotz^
::
  fk+1/fknotz CKSYMBN			( fk+1/fk )
  ALGCASCOMPEVAL SYMBINCOMP		( meta )
;

LABEL fk+1/fkEXP
::					( meta-EXP )
  pulldrop metax+1-metax		( meta )
  addtEXP
;

LABEL fk+1/fk!
::
  dup pulldrop				( meta! meta )
  metax+1-metax				( meta! meta-x+1-meta-x )
  OVER TYPEZINT? casedrop fk+1/fk!z	( -> meta )
					( meta! meta-meta' )
  NDROP fk+1/fknotz
;

LABEL metax+1-metax
( meta -> meta_x+1-meta_x )
::
  dup CKSYMBN				( meta! meta symb )
  1GETLAM 2GETLAM REPLACE2BY1		( meta! meta symb' )
  SYMBINCOMP psh MetaSub CKSYMBN	( meta! symb )
  ALGCASCOMPEVAL SYMBINCOMP		( meta! meta-meta' )
  zneg2-z
;

LABEL zneg2-z
* meta -> meta
* if meta is zint xNEG TWO return -zint ONE
::
  DUPTWO #= NOT?SEMI
  3PICK TYPEZINT? NOT?SEMI
  OVER EQ: xNEG NOT?SEMI
  2DROP QNeg ONE
;

LABEL fk+1/fk!z
* meta-argfk+1=meta-argfk+z
* if z=0 then fk+1/fk=1
* if z>0 then fk+1=fk*argfk+1*...*argfk+z
::					( meta! z )
  Z0 EQUALcasedro :: NDROP Z1 ONE ;	( -> 1 # )
  DupZIsNeg? case fk+1/fk!zneg
					( meta! z )
  Z># OBJ>R pulldrop			( meta )
  Z1 ONE R>OBJ				( meta res # )
  #1+_ONE_DO (DO)			( meta res )
    psh dup unrot			( meta res meta )
    INDEX@ #>Z ONE MetaAdd		( meta res meta+z )
    MetaMul
  LOOP					( meta res )
  psh NDROP				( res )
;

LABEL fk+1/fk!zneg
* if z<0 then fk=fk+1*argfk*argfk-1*...*argfk-z+1
::					( meta! z )
  ZABS 					( meta! z )
  Z># OBJ>R pulldrop			( meta )
  Z1 ONE R>OBJ				( meta res # )
  ZERO_DO (DO)				( meta res )
    psh dup unrot			( meta res meta )
    INDEX@ #>Z ONE MetaSub		( meta res meta-z )
    MetaMul				( meta res )
  LOOP
  psh NDROP Z1 ONE psh MetaDiv		( 1/res )
;
	
LABEL UNSOLVEDSUM
::					( fk ? )
  DROP SYMB2METASUM SYMBN		( sum[fk,k] )
;

**********************************************************************
* Desc:		Write a fraction A/B as E[P]/P*Q/E[R]
* Stack:	( A B -> P Q R )
* Note:		Q and positive shifts of R are prime together
**********************************************************************
NULLNAME A/B2PQR
::
					( A B )
  Z1 UNROT 2DUP				( 1 A B A B )
  RESPSHIFTQ				( 1 A B C )
  IROOTS				( 1 A B {integer_roots} )
  DUPNULL{}? casedrop Z-1PTAYL		( -> 1 A E^-1[B] )
					( 1 A B {integer_roots} )
  DUP >R LENCOMP			( 1 A B # )
  ( * A/B=E[Pi]/Pi*Qi/Ri * )
  ( * if gcd[Qi,E^k[Ri]]=Y!=1 then Qi=Y*Qi+1, Ri=E^-k[Y]*Ri+1 * )
  ( * hence Qi/Ri=Qi+1/Ri+1* Y/E^[-k]Y * )
  ( * and Pi+1=Pi*E^[-k]Y*...*E^[-1]Y * )
  ZERO_DO (DO)				( Pi Qi Ri )
    RSWAP 'R RSWAP			( Pi Qi Ri i )
    A/B2PQRLP				( Pi Qi Ri )
  LOOP
  ( * Qi/Ri=Q/E[R] hence R=E^-1[Ri] * )
  Z-1PTAYL				( P Q R )
;

LABEL Z-1PTAYL
:: Z-1 PTAYLext ;

LABEL A/B2PQRLP
::					( Pi Qi Ri k )
  DupZIsNeg? caseDROP			( -> Pi Qi Ri )
					( Pi Qi Ri k )
  DUP4UNROLL PTAYLext			( Pi k Qi E^k[Ri] )
  SIMP3ext				( Pi k Y Qi+1 E^k[Ri]/Y )
  4PICK QNeg PTAYLext			( Pi k Y Qi+1 Ri+1 )
  5UNROLL 5UNROLL			( Qi+1 Ri+1 Pi k Y )
  Z-1PTAYL				( Qi+1 Ri+1 Pi k E^[-1]Y )
  SWAP QNeg SWAPDUP Z-1 		( Qi+1 Ri+1 Pi -k PI E^[-1]Y -1 )
  [BEGIN]				( Qi+1 Ri+1 Pi -k PI E^[-l]Y -l )
    4PICKOVER EQUAL			( Qi+1 Ri+1 Pi -k PI E^[-l]Y -l ? )
  NOT_WHILE				( Qi+1 Ri+1 Pi -k PI E^[-l]Y -l ? )
    ::  Z-1 QAdd			( Qi+1 Ri+1 Pi -k PI E^[-l]Y -l-1 )
	SWAP Z-1PTAYL			( Qi+1 Ri+1 Pi -k PI -l-1 E^[-l-1]Y )
	DUPUNROT 4ROLL QMul		( Qi+1 Ri+1 Pi -k -l-1 E^[-l-1]Y PI )
	UNROT				( Qi+1 Ri+1 Pi -k PI -l-1 E^[-l-1]Y )
	;
  [REPEAT]				( Qi+1 Ri+1 Pi -k PI E^[-l]Y -l )
  2DROP SWAPDROP			( Qi+1 Ri+1 Pi PI )
  QMul UNROT				( Pi+1 Qi+1 Ri+1 )
;

**********************************************************************
* Desc:		Solve P = Q E[Y] - R Y for Y
* Stack:	( P Q R -> P R Y true | false )
* Note:		
**********************************************************************
NULLNAME GOSPER?
::
  ( * find degree of Y * )
  DUPCKLEN{}				( P Q R #r )
  ROT DUPCKLEN{}			( P R #r Q #q )
  5ROLL DUPCKLEN{}			( R #r Q #q P #p )
  ( * if q>r then #p-q, if q<r then #p-r, if = then p-q or p * )
  5ROLL 4ROLL				( R Q P #p #r #q )
  2DUP#= NOTcase GOSPER!=
					( R Q P #p #r #q )
  6PICK CKCARCOMP 6PICK CKCARCOMP	( R Q P #p #r #q rr qq )
  EQUALNOTcase GOSPER!=
					( R Q P #p #r #q )
  ( * q=r same leading coeff, try to solve with degreeY=degreeP * )
  2DROP GOSPER1
;

LABEL GOSPER!=
::				( R Q P #p #r #q )
  #MAX				( R Q P #p max#q )
  2DUP#< case :: 5DROP FALSE ;
				( R Q P #p max#q )
  #-				( R Q P degree_of_y )
  GOSPER1
;

LABEL GOSPER1
::				( R Q P degree_of_y )
  ( * compute polynomial coeff of yy to y0 and keep leading length * )
  4UNROLL DUPCKLEN{} Z1 ONE{}N	( degree_of_y R Q P #equations triangle )
  ' NULLLAM FIVE NDUPN DOBIND 
  #1+ ZEROSWAP			( meta-columns #unknown )
  ZERO_DO (DO)			( meta-column )
    1GETLAM			( meta-column [X+1]^index )
    DUP PASCAL_NEXTLINE 1PUTLAM	( meta-column [X+1]^index )
    4GETLAM QMul		( meta-column [X+1]^index*Q )
    ONE INDEX@ MKPOLY		( meta-column [X+1]^index*Q X^index )
    5GETLAM QMul QSub		( meta-column poly )
    DUPCKLEN{} 2GETLAM #MAX	( meta-column poly #equations )
    2PUTLAM SWAP#1+		( meta-column )
  LOOP
				( meta-columns )
  ( * normalize each column length from below * )
  []N DUP >R LENCOMP ZEROSWAP	( meta-column #unknown )
  ZERO_DO (DO)
    RSWAP 'R RSWAP		( meta-column column )
    LENGTHADJUST SWAP#1+	( meta-column )
  LOOP
	
  ( * add P to the system * )
  3GETLAM LENGTHADJUST SWAP#1+
  
  mattran			( meta-matrix )

  ( * solve system * )
  SOLVEMETASYST			( d meta-sol true | false )
  NOTcase :: ABND FALSE ;
				( d meta-sol )
  reversym >POLYTRIM		( d Y*d )
  SWAP ONE>POLY QDiv		( Y )
  3GETLAM 5GETLAM ROT ABND TRUE	( P R Y true )
;

LABEL LENGTHADJUST
::				( c )
  CKINNERCOMP reversym		( c0...ck #k )
  Z0 2GETLAM 3PICK #-		( c0...ck #k 0 #n-k )
  NDUPN top& []N		( [] )
;

**********************************************************************
* Desc:		Zeilberger algorithm
* Stack:	( f(n,k) n k d -> C true | false )
*		d is the length of the recurrence relation to find
*		C is a d+1-vector of coefficients such that
*		Sigma(l=0,d)c_l shiftn^{-l} f(n,k)
*		is an exact hypergeom difference
* Note:		r(n,k)=Sigma(l=0,d,c_l(n) Product(k=1,l) shift_n^{-k}(F)
*		where F=f(n-1,k)/f(n,k)
*		Let r(n,k)=N(n,k,C)/D(n,k)
*		compute A/B2PQR for D/E(D)*f(n,k+1)/f(n,k)
*		then solve GOSPER for newP=P*N, Q and R
*		the linear system must be solved as parametric with respect
*		to C that appears only in the second member (P)
*		the system is Cramer if and only if C is solution of
*		a new linear system. If this next linear syst has solutions
*		Zeilberger algo is successful.
**********************************************************************
NULLNAME ZEILBERGER

**********************************************************************
* Desc:		Digamma function
* Stack:	( sym --> Psi(x) )
* Specials:	Psi(NaN)  = NaN
*		Psi(+inf) = +inf
*		Psi(-inf) = NaN
*		Psi(0)    = inf
*		Psi(-Z)   = inf
**********************************************************************
NULLNAME SYMPSI
::
  SYMBINCOMP
  SymPsi
  unsyminner
;

NULLNAME sympsi
::
  ' ROMPTR xPsi ONESYMBN		( Meta 'Psi' )  ( BANKSWITCH OK! )
  ONE ' xFCNAPPLY 4ROLL #3+		( Meta' )
;

**********************************************************************
* Desc:		Digamma function
* Stack:	( sym int --> Psi(x,n) )
**********************************************************************
NULLNAME SYMPSIN
::					( x n )
  OBJINT? NcaseSIZEERR			( -> error )
  DupZIsNeg? caseSIZEERR		( -> error )
					( x n )
  Z0 EQUALcasedrop SYMPSI		( -> Psi[x] )
					( x n )
  SWAP SYMBINCOMP get1			( meta-x n )
  sympsin
  CKSYMBN
;

NULLNAME sympsin
::					( meta-x n )
  ONE 2metaundef?7 SWAPDROP		( meta-x n # )
  DUP#0=csedrp sympsinnotinf
					( meta-x n # )
  2DROP metainftype			( # )
  #1=case Z0ONE				( -> 0 #1 )
  SETSIZEERR 
;


**********************************************************************
* Desc:		Bernoulli numbers
* Stack:	( #/zint -> Q )
* Note:	
**********************************************************************
NULLNAME IBERNOULLI
::				( #/zint )
  SETEXACT DUPTYPEREAL? IT R>Z
  DUPTYPEZINT? IT Z>#		( # )
  DUP#0=csedrp Z1
  DUPTWO #/ DROP		( n n_mod_2 )
  #1=case :: ( n )
	     #1= NOTcase Z0 
	     Z-1 Z2 NDXFext 
	     ;
				( n )
  DUP # 400 #>case Z>#ERR
  Z1 Z6 NDXFext ONE{}N 1LAMBIND	( n )
  INBERNOULLI			( Q )
  ABND				( Q )
;

LABEL INBERNOULLI
* lam1 contains a list of first Bernoulli numbers with at least Bernoulli[2]
::				( n )
  ( * if length lam1>n-1 then return n-th coeff of lam1 * )
  1GETLAM OVER #2/ NTHELCOMP	( n Q true | n false )
  case SWAPDROP			( -> Q )
				( n )
  Z1 DUP3PICK			( n 1 1 n )
  #>Z QSub Z2 QDiv		( n 1 1-n/2 )
  3PICK #2/			( n 1 1-n/2 n/2 )
  ONE_DO (DO)			( n a b )
    ?ATTNQUIT
    ( * compute new a * )
    3PICK #3+ INDEX@ #2* #-	( n a b n+3-2i )
    DUP#1- #* #>Z		( n a b n+3-2i*n+2-2i )
    ROT QMul			( n b a*n+3-2i*n+2-2i )
    INDEX@ #2* DUP#1- #*	( n b a*n+3-2i*n+2-2i 2i*2i-1 )
    #>Z ZQUOText		( n b newa )
    ( * compute new b * )
    INDEX@ #2* INBERNOULLI	( n b newa bernoulli[2*index] )
    OVER QMul			( n b newa newa*bernoulli )
    ROT QAdd			( n newa newb )
  LOOP				( n a b )
  SWAPDROPSWAP #1+		( b n+1 )
  #>Z QNeg QDiv			( newbernoulli )
  ( * update lam1 * )
  1GETLAM OVER >TCOMP 1PUTLAM	( newbernoulli )
;

**********************************************************************
* Desc:		Resultant of two polynomials in symbolic form
* Stack:	( symb1 symb2 -> symb )
* Note:	
**********************************************************************
NULLNAME FLAGRESULTANT
::
  RunSafeFlagsNoError INFLAGRESULTANT
;

LABEL INFLAGRESULTANT
::					( symb1 symb2 )
  ISPOLYNOMIAL? NOTcase TRANSCERROR
  SWAP ISPOLYNOMIAL? NOTcase TRANSCERROR
  TWO{}N LVARext VX! VXXLext INCOMPDROP	( lvar P1 P2 )
  FXNDext CSTPOLY? NcaseSIZEERR		( lvar P1 n2 d2 )
  SWAP DUPCKLEN{}			( lvar P1 d2 n2 # )
  ROTSWAP #1- RP#			( lvar P1 n2 d2^# )
  ROT FXNDext CSTPOLY? NcaseSIZEERR	( lvar n2 d2^# n1 d1 )
  SWAP DUPCKLEN{}			( lvar n2 d2^# d1 n1 # )
  ROTSWAP #1- RP#			( lvar n2 d2^# n1 d1^# )
  ROT QMul UNROT			( lvar d2^#*d1^# n2 n1 )
  RESULTANT ONE>POLY SWAP QDiv		( lvar Q )
  R2SYM
;
	
**********************************************************************
* Desc:		Resultant of two polynomials
* Stack:	( P1 P2 -> P )
* Note:		depth of P is one less than depth of P1 and P2
**********************************************************************
NULLNAME RESULTANT
::					( P Q )
  SWAP DUPCKLEN{} #1-			( Q P #p )
  ROT DUPCKLEN{} #1-			( P #p Q #q )
  ROT 2DUP#>				( P Q #q #p ?q>p )
  NOTcase RESULTANT1
					( P Q #q #p )
  4ROLL UNROTSWAP			( Q P #p #q )
  2DUP #* TWO #/ DROP			( Q P #p #q p*n_mod_2 )
  #0=case RESULTANT1
  RESULTANT1 QNeg
;

LABEL RESULTANT1
* here #p>=#q
::					( P Q #q #p )
  ( * if both of degree 0 return 1 * )
  DUP#0=case :: 4DROP Z1 ;
					( P Q #q #p )
  ( * if Q of degree 0 return q1^degree[P] * )
  OVER #0=case :: SWAPDROPSWAP		( P #p Q )
                  CKCARCOMP ROTDROPSWAP	( q1 #p )
                  RP#			( q1^#p )
		  ;
					( P Q #q #p )
  4ROLL PPZ				( Q #q #p pP a )
  ROT RP#				( Q #q pP a^#p )
  4ROLL PPZ				( #q pP a^#p pQ b )
  5ROLL RP#				( pP a^#p pQ b^#q )
  ROT QMul UNROT			( b^#q*a^#p pP pQ )
  
  Z1 DUP 2SWAP
  [BEGIN]				( res g h P Q )
     DUPCKLEN{} #1<>
  [WHILE]
     RESULTANTLP
  [REPEAT]
					( res g' h' P Q_avec_degre=0 )
  4ROLLDROP CKCARCOMP			( res h P q )
  SWAP LENCOMP #1-			( res h q #p )
  DUPUNROT RP#				( res h #p q^#p )
  UNROT #1- RP# QDiv			( res q^#p/h^#p-1 )
  QMul
;

**********************************************************************
* Desc:		Subresultant algorithm innerloop
* Stack:	( res g h P1 P2 -> +/-res g' h' P1' P2' )
* Note:		
**********************************************************************
NULLNAME RESULTANTLP
::				( res g h l1 l2 )
  ( * multiplies numerator by an invertible element * )

  DUPDUP CARCOMP SWAP LENCOMP	( res g h l1 l2 a2.1 #l2 )
  4PICK LENCOMP			( res g h l1 l2 a2.1 #l2 #l1 )
  OVER #1+ OVER #1+ #*
  TWO #/ DROP			( res g h l1 l2 a2.1 #l2 #l1 #l2-1*l1-1_mod_2 )
  #1= IT RESULTANTCHS
  SWAP#-			( res g h l1 l2 a2.1 #l1-#l2 )
  DUPUNROT #1+ RP# ONE>POLY	( res g h l1 l2 #l1-l2 {a2.1^} )
  4ROLL QMul			( res g h l2 #l1-l2 l1' )

  ( division de l1' par l2 )

  Z0 SWAP4PICK DIV2LISText	( res g h l2 #l1-l2 l1divl2 l1modl2 )
  SWAPDROP			( res g h l2 #l1-l2 l1modl2 )
	
				( res g h l2 #l1-l2 l1modl2 )
  5ROLL 5PICK			( res h l2 #l1-l2 l1modl2 g h )
  4PICK RP#			( res h l2 #l1-l2 l1modl2 g h^# )
  DUP4UNROLL RMULText DIVOBJext	( res h l2 #l1-l2 h^# l1modl2/[g*h^#] )
  UNROT 4PICK CARCOMP		( res h l2 l1modl2/[g*h^#] #l1-l2 h^# g' )
  DUP 7UNROLL ROT RP#		( res g' h l2 l1modl2/[g*h^#] h^# g'^# )
  5ROLL RMULText SWAP RDIVext	( res g' l2 l1modl2/[g*h^#] h^1-#*g'^# )
  UNROT				( res g' h' l1'=l2 l2'=l1modl2 )
;

LABEL RESULTANTCHS
:: 8ROLL QNeg 8UNROLL ;

**********************************************************************
* Desc:		Resultant of P and Q shifted
* Stack:	( P Q -> P' )
* Note:		gcd[Q(x-r),P(x)]!=1 equivalent to r root of P'
*		P' has same depth than P and Q
**********************************************************************
NULLNAME RESPSHIFTQ
::					( P Q )
  DUPTYPELIST? NOTcase2drop Z1		( -> 1 )
					( P Q )
  ( * augment depth of P * )
  SWAP ADDONEVAR			( Q P )
  ( * augment depth of Q and shift by r * )
  SWAP ADDONEVAR INTERNALX PTAYLext	( P Q-shifted )
  RESULTANT
;

**********************************************************************
* Desc:		Add one variable just below the main var
* Stack:	( P -> P' )
* Note:		works for polynomial, not for fractions
**********************************************************************
NULLNAME ADDONEVAR
::
  ' ONE>POLY TOTEMPOB 1LAMBIND LISTSECOext ABND
;

**********************************************************************
* Desc:		Find integer roots of a polynomial
* Stack:	( P -> list )
* Note:		
**********************************************************************
NULLNAME IROOTS
::					( P )
  DUPTYPELIST? NOTcasedrop NULL{}
					( P )
  PPZ DROP				( P )
  DUP LASTCOMP				( P p0 )
  PPZZ SWAPDROP				( P z )
  ZABS DIVISext				( P {} )
  SWAP 1LAMBIND				( {} )
  DUP >R LENCOMP ZEROSWAP		( meta # )
  ZERO_DO (DO)				( meta )
    RSWAP 'R RSWAP			( meta z )
    DUP QNeg OBJ>R			( meta z )
    IROOTSLP				( meta )
    R>OBJ IROOTSLP			( meta )
  LOOP					( meta )
  ABND {}N				( {} )
;

LABEL IROOTSLP
::					( meta z )
  1GETLAM SWAP HORNext			( meta P' z P[z] )
  Z0 EQUAL NOTcase2DROP			( -> meta )
					( meta P' z )
  SWAP 1PUTLAM SWAP#1+			( meta )
;
