* It is now possible to enhance the statistics menu using a user library.
* The HP49 does not provide every possible functions in every area,
* but let you customise the built in menu in order to add your functions
* 'as if they were built in'.
*
* Example: customise the main statistic menu.
*
* Go in RPL mode (MODE, +/-, ENTER )
* Attach the development library (256 ATTACH)
*
* In a directory, create the following variables:
*
* $ROMID          1324                      ( the library ID )
* $CONFIG         1                         ( if $CONFIG is real or int,
*                                             a standard config is created )
* $TITLE          "Statistic enhancements"  ( the lib title )
* $VISIBLE        { ABOUT }                 ( the list of the object 
*                                             that have to appear in the lib menu
*                                             and can be enter through the keyboard )
* $HIDDEN         { MessageHandler }        ( the list of the nullename variables )
* $EXTPRG         'MessageHandler'          ( the extention program! )
* ABOUT           "This library is a statisticc enhancement example"
* MessageHandler  << IF DUP 1 R~SB == THEN SWAP 
*                 { { "7.New entry" << "My Stats" 1 DISP 7 FREEZE >> } }
*                 + SWAP END >>
* 
* create the library (CRLIB)
* and store it in an extension port (0 STO)
* 
* Now, run the statistic menu (Shift 5)!
* 
* The statistic main menu ID is 1
* The Hypothesis test statistic menu ID is 2
* The Confidence interval menu ID is 3
* 
* Other will come soon!
*

* A deeper look in the guts of the thing:
*
* Each time the stat menu pops up, Vger executes every ExtentionProgram of
* the libs in the system. This Extention Program takes on the stack
* a message number (and let it on the stack!).
* Each messge number has a specific meaning. as discribe bellow.
*
* A lib with an ExtentionProgram must follow this architecture:
* DOLIB, Size
* Name
* LibNumber
* Offset to Hash table
* Offset to Message table
* Offset to Link Table
* Offset to config
* LibExtentMark (0C5D0)
* ROMPTR MessageHandler  (obviously one of the objects of this lib :-)
*


********************************************************************
* Messages description

* APPS menu
* Input: { { "String" Action } ... } ZERO
* Output: Modified list ZERO
DEFINE ExtMesAPPS ZERO

* Main Stat menu extention
* Input: { { "String" Action } ... } ONE
* Output: Modified list ONE
DEFINE ExtMesMainStat ONE

* hypothesis Stat menu extention
* Input: { { "String" Action } ... } TWO
* Output: Modified list TWO
DEFINE ExtMesHypStat TWO

* conf interval stat menu extention
* Input: { { "String" Action } ... } THREE
* Output: Modified list THREE
DEFINE ExtMesInterStat THREE

* Finance menu
* Input: { { "String" Action } ... } FOUR
* Output: Modified list FOUR
DEFINE ExtMesFinance FOUR

* Numeric solver menu
* Input: { { "String" Action } ... } FIVE
* Output: Modified list FIVE
DEFINE ExtMesSolve FIVE

* Time menu
* Input: { { "String" Action } ... } SIX
* Output: Modified list SIX
DEFINE ExtMesTime SIX

* Any user lib: When entering a user lib menu
* through the lib menu, a message is executed
* with the library number as arguement
* Input: Library number
* Output: Library number

* Games menu (posted while creating the apps menu)
* Input: N+2: MenuItem1
*        3: MenuItemN
*        2: #N
*        1: EIGHT
* output: N+2: MenuItem1 (you can add your own menu item)
*         3: MenuItemN
*         2: #N
*         1: EIGHT
DEFINE ExtMesGames EIGHT

* Is Catalog help
* This allows a library to provide an help for its functions
* Input: 3: ROMPTR to get help with
*        2: FALSE
*        1: NINE
* Output: 3: ROMPTR
*         2: TRUE/FALSE (Has help or not)
*	  1: NINE
DEFINE ExtMesHelp NINE

* Do Catalog help
* This allows a library to provide an help for its functions
* Input: 3: ROMPTR to get help with
*        2: FALSE
*        1: TEN
* Output: 3: ROMPTR 
*         2: TRUE/FALSE (the Help program would have been executed before)
*         1: TEN
* Or FALSE (Has help or not)
DEFINE ExtMesDoHelp TEN

* Do Find Editor Menu
* conf interval stat menu extention
* Input: { { "String" Action } ... } ELEVEN
* Output: Modified list ELEVEN
DEFINE ExtMesFindEdit ELEVEN

* Do Tools Editor Menu
* conf interval stat menu extention
* Input: { { "String" Action } ... } TWELVE
* Output: Modified list TWELVE
DEFINE ExtMesToolEdit TWELVE

* Do Goto Editor Menu
* conf interval stat menu extention
* Input: { { "String" Action } ... } THIRTEEN
* Output: Modified list THIRTEEN
DEFINE ExtMesGotoEdit THIRTEEN

* Do Find Editor Soft Menu
* conf interval stat menu extention
* Input: MenuItem1 MenuItem2 ... #N FOURTEEN
* Output: Modified meta-object FOURTEEN
DEFINE ExtMesFindSoftEdit FOURTEEN

* Do Tools Editor Soft Menu
* conf interval stat menu extention
* Input: MenuItem1 MenuItem2 ... #N FIFTEEN
* Output: Modified meta-object FIFTEEN
DEFINE ExtMesToolSoftEdit FIFTEEN

* Do Goto Editor Soft Menu
* conf interval stat menu extention
* Input: MenuItem1 MenuItem2 ... #N SIXTEEN
* Output: Modified meta-object SIXTEEN
DEFINE ExtMesGotoSoftEdit SIXTEEN
